DATA_PORT:           EQU $00BE 
CTRL_PORT:           EQU $00BF 
SOUND_PORT:          EQU $00FF
JOY_PORT:            EQU $00C0
KEYBOARD_PORT:       EQU $0080
CONTROLLER1_IN:      EQU $00FC
CONTROLLER2_IN:      EQU $00FF


; COLECO BIOS JUMP TABLE
BOOT_UP:           EQU $0000      ; RESET CONSOLE
AMERICA:           EQU $0069       ;CONTAINS HOW MANY TIMER TICKS IN A SECOND (50/60)
POWER_UP:          EQU $006E
DECLSN:            EQU $0190
DECMSN:            EQU $019B
MSNTOLSN:          EQU $01A6
ADD816:            EQU $01B1      ; ADD 8-BIT VALUE TO 16-BIT VALUE
SET_UP_WRITE:      EQU $0623
PUTSEMI:           EQU $06FF
PX_TO_PTRN_POS:    EQU $07E8
GET_BKGRND:        EQU $0898
PUT_FRAME:         EQU $080B
CALC_OFFSET:       EQU $08C0
PUT0SPRITE:        EQU $08DF
PUT1SPRITE:        EQU $0955
PUT_MOBILE:        EQU $0A87
PUTCOMPLEX:        EQU $0EA2
CONT_READ:         EQU $113D
CONTROLLER_INIT:   EQU $1105
JOY_DBNCE:         EQU $12B9
FIRE_DBNCE:        EQU $1289
ARM_DBNCE:         EQU $12E9
KBD_DBNCE:         EQU $1250
DISPLAY_LOGO:      EQU $1319
PLAY_SONGS:        EQU $1F61       ;CALL DURING INTERRUPT (EARLY)
REFLECT_VERTICAL:  EQU $1F6A
REFLECT_HORZONTAL: EQU $1F6D
ROTATE_90:         EQU $1F70
ENLARGE:           EQU $1F73
CONTROLLER_SCAN:   EQU $1F76
DECODER:           EQU $1F79
GAME_OPT:          EQU $1F7C
LOAD_ASCII:        EQU $1F7F
FILL_VRAM:         EQU $1F82
MODE_1:            EQU $1F85
UPDATE_SPINNER:    EQU $1F88

INIT_TABLEP:       EQU $1F8B
INIT_TIMERP:       EQU $1F9A
REQUEST_SIGNALP:   EQU $1FA0
TEST_SIGNALP:      EQU $1FA3
WRITE_REGISTERP:   EQU $1FA6
SOUND_INITP:       EQU $1FB2
PLAY_ITP:          EQU $1FB5


INIT_TABLE:        EQU $1FB8
GET_VRAM:          EQU $1FBB
PUT_VRAM:          EQU $1FBE
INIT_SPR_NM_TBL:   EQU $1FC1
WR_SPR_NM_TBL:     EQU $1FC4
INIT_TIMER:        EQU $1FC7       ;**HL=TIMER TABLE,DE=TIMER DATA BLOCK
FREE_SIGNAL:       EQU $1FCA       ;NOTE: MUST NOT BE INTERRUPTED
REQUEST_SIGNAL:    EQU $1FCD
TEST_SIGNAL:       EQU $1FD0
TIME_MGR:          EQU $1FD3
TURN_OFF_SOUND:    EQU $1FD6       ;NO SOUNDS
WRITE_REGISTER:    EQU $1FD9
READ_REGISTER:     EQU $1FDC
WRITE_VRAM:        EQU $1FDF
READ_VRAM:         EQU $1FE2
INIT_WRITER:       EQU $1FE5
WRITER:            EQU $1FE8
POLLER:            EQU $1FEB
SOUND_INIT:        EQU $1FEE       ;B=CONCURRENT VOICES+EFFECTS, HL=SONG TABLE
PLAY_IT:           EQU $1FF1       ;B=SONG NUMBER
SOUND_MAN:         EQU $1FF4       ;CALL DURING INTERRUPT (LATE)
ACTIVATE:          EQU $1FF7
PUTOBJ:            EQU $1FFA
RAND_GEN:          EQU $1FFD      ; OUTPUT: 16 BIT RESULT IN RAND_NUM, HL, A=L

VRAM_PATTERN:       EQU $0000
VRAM_NAME:          EQU $1800
VRAM_SPRATTR:       EQU $1B00
VRAM_COLOR:         EQU $2000
VRAM_SPRGEN:        EQU $3800

FNAME "SMURF RESCUE.ROM"
CPU Z80

	ORG        8000H



	DW 55AAH
	DW 0
	DW 0
	DW 702BH
	DW 712DH
	DW START
	RET
	NOP
	NOP
	RET
	NOP
	NOP
	RET
	NOP
	NOP
	RET
	NOP
	NOP
	RET
	NOP
	NOP
	RET
	NOP
	NOP
	RETI
	NOP
	RETN
	NOP
	DB 1DH," PEYO 1982"
	DB "/SMURF",1EH,1FH," RESCUE/1982"


START:
	CALL    SUB_8AC3

LOC_8046:
	CALL    SUB_8642

LOC_8049:
	CALL    SUB_8571
	LD      HL, 73C7H
	LD      (HL), 0
	CALL    SUB_8105
	LD      HL, UNK_873B
	LD      ($7139), HL
	CALL    SOUND_INITP
	LD      (HL), C
	ADD     A, B
	ADD     HL, SP
	LD      (HL), C
	CALL    SUB_86A1
	JP      Z, LOC_8049
	CALL    SUB_AACE
	CALL    SUB_AD1B
	JP      LOC_8046

DATA_SET_00:
	DB 0C9H, 009



SUB_8072:
	LD      BC, DATA_SET_01
	LD      DE, 713BH
	CALL    SUB_BF58
	LD      A, ($713B)
	CALL    SUB_BF1F
	LD      D, H
	LD      E, L
	ADD     HL, HL
	ADD     HL, HL
	ADD     HL, DE
	ADD     HL, HL
	LD      DE, 71FAH
	ADD     HL, DE
	LD      ($713C), HL
	LD      DE, 0
	LD      (HL), E
	INC     HL
	LD      (HL), D
	LD      HL, ($713C)
	INC     HL
	INC     HL
	LD      (HL), 0FH
	LD      HL, ($713C)
	INC     HL
	INC     HL
	INC     HL
	LD      (HL), 5
	LD      HL, ($713C)
	INC     HL
	INC     HL
	INC     HL
	INC     HL
	LD      (HL), 7
	LD      HL, ($713C)
	LD      DE, 5
	ADD     HL, DE
	LD      (HL), 1
	LD      HL, ($713C)
	LD      DE, 6
	ADD     HL, DE
	LD      (HL), 1
	LD      HL, ($713C)
	LD      DE, 7
	ADD     HL, DE
	LD      (HL), 1
	LD      HL, ($713C)
	LD      DE, 9
	ADD     HL, DE
	LD      (HL), 1
RET

DATA_SET_01:
	db 001,000,001,000

SUB_80D5:
LD      HL, 71EFH
LD      ($713E), HL
INC     HL
LD      A, (HL)
CP      1
JP      NZ, LOC_80EB
LD      HL, ($713E)
INC     HL
LD      (HL), 0
JP      LOC_80F1

LOC_80EB:
LD      HL, ($713E)
INC     HL
LD      (HL), 1

LOC_80F1:
LD      A, ($71F0)
CALL    SUB_BF1F
LD      D, H
LD      E, L
ADD     HL, HL
ADD     HL, HL
ADD     HL, DE
ADD     HL, HL
LD      DE, 71FAH
ADD     HL, DE
LD      ($718D), HL
RET
; END OF FUNCTION SUB_80D5




SUB_8105:
CALL    SUB_8072
OR      D
ADD     A, D
LD      A, ($71EF)
CP      2
JP      NZ, LOC_8117
CALL    SUB_8072
OR      E
ADD     A, D

LOC_8117:
LD      HL, 71F0H
LD      (HL), 1
CALL    SUB_80D5

LOC_811F:
LD      HL, ($718D)
LD      ($7140), HL
CALL    SUB_AACE
LD      HL, 7150H
LD      ($7142), HL
LD      HL, 7188H
LD      ($7144), HL
CALL    INIT_TIMERP
LD      B, D
LD      (HL), C
LD      B, H
LD      (HL), C
LD      A, (AMERICA)
CALL    SUB_BF1F
LD      ($7142), HL
CALL    REQUEST_SIGNALP
OR      E
ADD     A, D
LD      B, D
LD      (HL), C
LD      ($714F), A
CALL    REQUEST_SIGNALP
OR      E
ADD     A, D
OR      H
ADD     A, D
LD      ($714E), A
LD      HL, ($7140)
LD      DE, 6
ADD     HL, DE
LD      (HL), 1
LD      HL, ($7140)
INC     HL
INC     HL
LD      (HL), 0FH
LD      HL, ($7140)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
LD      ($71F9), A
LD      HL, ($7140)
LD      DE, 7
ADD     HL, DE
LD      A, (HL)
LD      ($71F2), A
LD      HL, ($7140)
LD      DE, 5
ADD     HL, DE
LD      A, (HL)
LD      ($71F3), A
LD      HL, ($7140)
LD      DE, 6
ADD     HL, DE
LD      A, (HL)
LD      ($71F8), A
CALL    SUB_BE39
CALL    SUB_A288
LD      A, ($71F3)
CP      7
JP      NZ, LOC_81A8
CALL    SUB_ACD8
JP      LOC_81AB

LOC_81A8:
CALL    SUB_AD1B

LOC_81AB:
CALL    SUB_8AED
CALL    SUB_A288
CALL    SUB_BE78
LD      HL, 718FH
LD      (HL), 14H
CALL    SUB_A68A
CALL    SUB_A00C
CALL    SUB_BB2E
CALL    SUB_82BB
LD      HL, UNK_873B
LD      ($7142), HL
CALL    SOUND_INITP
OR      (HL)
ADD     A, D
LD      B, D
LD      (HL), C
LD      A, ($718C)
CP      3
JP      NZ, LOC_8259
CALL    PLAY_ITP
OR      A
ADD     A, D
CALL    PLAY_ITP
CP      B
ADD     A, D
LD      HL, ($7140)
LD      DE, 9
ADD     HL, DE
LD      (HL), 1
LD      HL, ($7140)
LD      DE, 5
ADD     HL, DE
LD      (HL), 1
LD      HL, ($7140)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
OR      7
LD      HL, ($7140)
INC     HL
INC     HL
INC     HL
INC     HL
LD      (HL), A
LD      HL, ($7140)
LD      E, (HL)
INC     HL
LD      D, (HL)
LD      HL, 64H ; 'D'
ADD     HL, DE
EX      DE, HL
LD      HL, ($7140)
LD      (HL), E
INC     HL
LD      (HL), D
CALL    SUB_A288
LD      HL, ($7140)
LD      DE, 7
ADD     HL, DE
LD      A, (HL)
CP      4
JP      Z, LOC_823B
LD      HL, ($7140)
LD      DE, 7
ADD     HL, DE
LD      A, (HL)
ADD     A, 1
LD      HL, ($7140)
LD      DE, 7
ADD     HL, DE
LD      (HL), A

LOC_823B:
CALL    REQUEST_SIGNALP
OR      D
ADD     A, D
CP      C
ADD     A, D
LD      ($714D), A

LOC_8245:
CALL    SOUND_MAN
CALL    PLAY_SONGS
CALL    SUB_9F8C
CALL    TIME_MGR
CALL    TEST_SIGNALP
LD      C, L
LD      (HL), C
JP      Z, LOC_8245

LOC_8259:
LD      A, ($718C)
CP      2
JP      NZ, LOC_811F
LD      HL, ($718D)
LD      ($7140), HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
SUB     1
LD      HL, ($7140)
INC     HL
INC     HL
INC     HL
LD      (HL), A
LD      HL, ($7140)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
OR      6
LD      HL, ($7140)
INC     HL
INC     HL
INC     HL
INC     HL
LD      (HL), A
LD      HL, 71EFH
LD      ($7140), HL
LD      A, (HL)
CP      2
JP      NZ, LOC_8295
CALL    SUB_80D5

LOC_8295:
LD      HL, ($718D)
INC     HL
INC     HL
INC     HL
LD      A, (HL)
CP      0
JP      NZ, LOC_811F
LD      HL, 71FCH
LD      (HL), 0
LD      HL, 7206H
LD      (HL), 0
CALL    SUB_A38F
CALL    SUB_A38F
RET
; END OF FUNCTION SUB_8105

DB    0
DB    1
DB  96H
DB    0
DB    9
DB    4
DB    5
DB 0F4H
DB    1



SUB_82BB:
LD      HL, 718CH
LD      (HL), 0
LD      HL, ($718D)
LD      ($7146), HL

LOC_82C6:
LD      A, ($718F)
LD      L, A
LD      A, 0
CALL    SUB_BF3F
JP      Z, LOC_82EB
LD      A, 1
CALL    SUB_BF3F
JP      Z, LOC_82E8
LD      A, L
LD      B, A
XOR     1
AND     B
LD      ($718F), A
CALL    SUB_BB2E
CALL    SUB_ACD8

LOC_82E8:
JP      LOC_8520

LOC_82EB:
LD      A, ($718F)
LD      L, A
LD      A, 4
CALL    SUB_BF3F
JP      Z, LOC_8377
LD      HL, ($7299)
LD      DE, 0F7H
CALL    SUB_BEE1
JP      Z, LOC_8320
LD      A, ($718F)
LD      L, A
LD      A, 2
CALL    SUB_BF3F
JP      NZ, LOC_8315
LD      A, L
OR      4
LD      ($718F), A

LOC_8315:
LD      A, ($718F)
OR      8
LD      ($718F), A
JP      LOC_8377

LOC_8320:
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      A, (HL)
CP      1
JP      NZ, LOC_8332
XOR     A
INC     A
JP      LOC_8333

LOC_8332:
XOR     A

LOC_8333:
LD      HL, ($7299)
LD      DE, 10H
LD      B, A
CALL    SUB_BEC1
AND     B
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      B, A
LD      A, (HL)
CP      1
JP      NZ, LOC_8351
XOR     A
INC     A
JP      LOC_8352

LOC_8351:
XOR     A

LOC_8352:
AND     B
JP      Z, LOC_835C
LD      HL, 10H
LD      ($7299), HL

LOC_835C:
LD      HL, ($7299)
LD      DE, 4
CALL    SUB_BEC1
JP      Z, LOC_8377
LD      A, ($718F)
OR      8
LD      B, A
XOR     4
AND     B
LD      ($718F), A
CALL    SUB_AD1B

LOC_8377:
LD      A, ($718F)
LD      L, A
LD      A, 3
CALL    SUB_BF3F
JP      Z, LOC_8520
CALL    SUB_BC25
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
AND     10H
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      (HL), A
LD      A, ($718F)
LD      L, A
LD      A, 2
CALL    SUB_BF3F
JP      Z, LOC_8481
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      A, (HL)
ADD     A, 1
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      (HL), A
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      A, ($71F7)
LD      B, A
LD      A, (HL)
LD      L, B
CALL    SUB_BF01
JP      Z, LOC_8440
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      (HL), 1
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      A, (HL)
ADD     A, 1
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      (HL), A
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
OR      2
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      (HL), A
LD      HL, ($7146)
LD      DE, 9
ADD     HL, DE
EX      DE, HL
LD      HL, ($7146)
LD      BC, 5
ADD     HL, BC
LD      A, (DE)
LD      B, A
LD      A, (HL)
LD      L, B
CALL    SUB_BF01
JP      Z, LOC_8440
LD      HL, ($7146)
INC     HL
INC     HL
LD      A, (HL)
CALL    SUB_BF1F
EX      DE, HL
LD      HL, ($7146)
LD      C, (HL)
INC     HL
LD      B, (HL)
EX      DE, HL
ADD     HL, BC
EX      DE, HL
LD      HL, ($7146)
LD      (HL), E
INC     HL
LD      (HL), D
LD      HL, ($7146)
INC     HL
INC     HL
LD      (HL), 0FH
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
EX      DE, HL
LD      HL, ($7146)
LD      BC, 9
ADD     HL, BC
LD      A, (DE)
LD      (HL), A

LOC_8440:
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      A, (HL)
CP      7
JP      NZ, LOC_8452
XOR     A
INC     A
JP      LOC_8453

LOC_8452:
XOR     A

LOC_8453:
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      B, A
LD      A, ($71F7)
CP      (HL)
JP      NZ, LOC_8467
XOR     A
INC     A
JP      LOC_8468

LOC_8467:
XOR     A

LOC_8468:
OR      B
JP      Z, LOC_847E
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
OR      8
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      (HL), A

LOC_847E:
JP      LOC_84CF

LOC_8481:
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      A, (HL)
SUB     1
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      (HL), A
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      A, (HL)
CP      0
JP      NZ, LOC_84CF
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      A, (HL)
SUB     1
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      (HL), A
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      A, ($71F7)
LD      (HL), A
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
OR      0AH
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      (HL), A

LOC_84CF:
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, (HL)
LD      ($71F9), A
LD      HL, ($7146)
LD      DE, 7
ADD     HL, DE
LD      A, (HL)
LD      ($71F2), A
LD      HL, ($7146)
LD      DE, 5
ADD     HL, DE
LD      A, (HL)
LD      ($71F3), A
LD      HL, ($7146)
LD      DE, 6
ADD     HL, DE
LD      A, (HL)
LD      ($71F8), A
CALL    SUB_8AED
LD      HL, ($7146)
INC     HL
INC     HL
INC     HL
INC     HL
LD      A, 1
LD      L, (HL)
CALL    SUB_BF3F
JP      Z, LOC_8511
CALL    SUB_BE78

LOC_8511:
CALL    SUB_9829
LD      A, ($718F)
OR      1
LD      B, A
XOR     0AH
AND     B
LD      ($718F), A

LOC_8520:
CALL    SUB_BBF5
CALL    SUB_BBE2
CALL    SUB_9917
CALL    SOUND_MAN
CALL    PLAY_SONGS
CALL    SUB_A38F
CALL    SUB_9F8C
CALL    TIME_MGR
CALL    SUB_982E
CALL    TEST_SIGNALP
LD      C, (HL)
LD      (HL), C
JP      Z, LOC_8565
LD      HL, ($7146)
INC     HL
INC     HL
LD      A, (HL)
SUB     1
LD      HL, ($7146)
INC     HL
INC     HL
LD      (HL), A
CALL    SUB_A38F
CALL    SUB_A38F
LD      HL, ($7146)
INC     HL
INC     HL
LD      A, (HL)
CP      0
JP      NZ, LOC_8565
CALL    SUB_AA61

LOC_8565:
LD      A, ($718C)
CP      0
JP      Z, LOC_82C6
CALL    SUB_BC25
RET
; END OF FUNCTION SUB_82BB




SUB_8571:
LD      HL, UNK_873B
LD      ($7148), HL
CALL    SOUND_INITP
ADD     A, IYL
LD      C, B
LD      (HL), C
CALL    WRITE_REGISTERP
CP      85H
RST     38H
ADD     A, L
CALL    WRITE_REGISTERP
NOP
ADD     A, (HL)
CP      85H
CALL    INIT_TABLEP
CP      85H
LD      BC, 0CD86H
ADC     A, E
RRA
INC     BC
ADD     A, (HL)
INC     B
ADD     A, (HL)
CALL    INIT_TABLEP
RST     38H
ADD     A, L
LD      B, 86H
CALL    INIT_TABLEP
EX      AF, AF'
ADD     A, (HL)
ADD     HL, BC
ADD     A, (HL)
CALL    INIT_TABLEP
DEC     BC
ADD     A, (HL)
INC     C
ADD     A, (HL)
CALL    WRITE_REGISTERP
INC     BC
ADD     A, (HL)
LD      C, 86H
LD      HL, 73C6H
LD      (HL), 0
LD      HL, 73C7H
LD      (HL), 0
LD      HL, 7150H
LD      ($7148), HL
LD      HL, 7188H
LD      ($714A), HL
CALL    INIT_TIMERP
LD      C, B
LD      (HL), C
LD      C, D
LD      (HL), C
LD      A, (AMERICA)
CALL    SUB_BF1F
LD      ($7148), HL
CALL    REQUEST_SIGNALP
INC     BC
ADD     A, (HL)
LD      C, B
LD      (HL), C
LD      ($714F), A
LD      A, ($71F1)
CP      1
JP      NZ, LOC_85F6
LD      HL, 71F7H
LD      (HL), 2
JP      LOCRET_85FC

LOC_85F6:
LD      A, ($71F1)
LD      ($71F7), A

LOCRET_85FC:
RET
; END OF FUNCTION SUB_8571

DB    9
DB    0
DB    2
DB    7
DB    0
DB  1EH
DB    1
DB    0
DB  38H ; 8
DB    0
DB  18H
DB    3
DB    0
DB  20H
DB    4
DB    0
DB    0
DB 0C2H
UNK_860F:DB    0
DB    0
DB    0
DB    0
DB    1
DB    1
DB    2
DB    2
DB    2
DB    2
DB    3
DB    3
DB    3
DB    3
DB    3
DB    3
UNK_861F:DB    0
DB    0
DB    2
DB    0
DB    0
DB    1
DB 0FFH
UNK_8626:DB    0
DB  10H
DB  28H ; (
DB  49H ; I
DB    0
DB  11H
DB  29H ; )
DB  49H ; I
DB    0
DB  12H
DB  29H ; )
DB  49H ; I
DB    0
DB  13H
DB  29H ; )
DB  59H ; Y
DB    0
DB  25H ; %
DB  29H ; )
DB  69H ; I
DB    0
DB  27H ; '
DB  39H ; 9
DB  69H ; I
DB    0
DB    0
DB    0
DB    0



SUB_8642:
CALL    MODE_1
CALL    LOAD_ASCII
CALL    GAME_OPT
OR      A
LD      ($7191), A
LD      HL, 0
LD      ($7192), HL

LOC_8655:
CALL    SUB_8686
CALL    RAND_GEN
CALL    POLLER
LD      A, ($7133)
CP      0FH
JR      NZ, LOC_866C
LD      A, ($7138)
CP      0FH
JR      Z, LOC_8655

LOC_866C:
DEC     A
BIT     3, A
JR      NZ, LOC_8655
LD      HL, 71EFH
BIT     2, A
JR      NZ, LOC_867C
LD      (HL), 1
JR      LOC_867E

LOC_867C:
LD      (HL), 2

LOC_867E:
AND     3
INC     A
LD      HL, 71F1H
LD      (HL), A
RET
; END OF FUNCTION SUB_8642




SUB_8686:
LD      A, ($7191)
DEC     A
LD      ($7191), A
RET     NZ
; END OF FUNCTION SUB_8686




SUB_868E:
LD      HL, ($7192)
LD      BC, 1
SBC     HL, BC
LD      ($7192), HL
RET     NZ
LD      C, 82H
LD      B, 1
JP      WRITE_REGISTER
; END OF FUNCTION SUB_868E




SUB_86A1:
LD      HL, 5AH ; 'Z'
LD      A, 1
CALL    REQUEST_SIGNAL
LD      ($7190), A
LD      A, ($71F3)
CP      7
JR      NZ, LOC_86B6
CALL    SUB_ACD8

LOC_86B6:
LD      HL, 8CA0H
LD      ($7192), HL

LOC_86BC:
CALL    SUB_868E
CALL    SUB_9F8C
CALL    TIME_MGR
CALL    SUB_8715
CALL    POLLER
LD      A, ($7133)
CALL    SUB_872C
JR      NZ, LOC_8706
LD      A, ($7138)
CALL    SUB_872C
JR      NZ, LOC_8706
LD      BC, 71EFH
LD      A, (BC)
DEC     A
JR      Z, LOC_8704
LD      A, ($7190)
PUSH    BC
CALL    TEST_SIGNAL
POP     BC
JR      Z, LOC_8704
INC     BC
LD      A, (BC)
OR      A
JR      Z, LOC_86F8
LD      HL, 71FAH
XOR     A
LD      (BC), A
JR      LOC_86FE

LOC_86F8:
LD      HL, 7204H
LD      A, 1
LD      (BC), A

LOC_86FE:
LD      ($718D), HL
CALL    SUB_A288

LOC_8704:
JR      LOC_86BC

LOC_8706:
PUSH    AF
LD      A, ($71F3)
CP      7
JR      NZ, LOC_8711
CALL    SUB_AD1B

LOC_8711:
POP     AF
CP      0
RET
; END OF FUNCTION SUB_86A1




SUB_8715:
LD      IX, 8008H
LD      H, (IX+1)
LD      L, (IX+0)
INC     HL
INC     HL
LD      D, H
LD      E, L
INC     DE
LD      BC, 0AH
LD      (HL), 0
LDIR
RET
; END OF FUNCTION SUB_8715




SUB_872C:
SUB     0AH
JP      M, LOC_8736
CP      2
JP      M, LOC_8738

LOC_8736:
LD      A, 0FFH

LOC_8738:
CP      0FFH
RET
; END OF FUNCTION SUB_872C

UNK_873B:DB  7BH ; {
DB  87H
DB  94H
DB  71H ; Q
DB 0B0H
DB  87H
DB  9EH
DB  71H ; Q
DB  3DH ; =
DB  88H
DB 0A8H
DB  71H ; Q
DB 0B4H
DB  88H
DB  94H
DB  71H ; Q
DB  0FH
DB  89H
DB 0A8H
DB  71H ; Q
DB  73H ; S
DB  8AH
DB 0BCH
DB  71H ; Q
DB  4EH ; N
DB  89H
DB 0E4H
DB  71H ; Q
DB 0FFH
DB  89H
DB 0DAH
DB  71H ; Q
DB  2CH ; ,
DB  8AH
DB 0E4H
DB  71H ; Q
DB  6DH ; M
DB  8AH
DB 0B2H
DB  71H ; Q
DB  79H ; Y
DB  8AH
DB 0BCH
DB  71H ; Q
DB  8CH
DB  8AH
DB 0C6H
DB  71H ; Q
DB  92H
DB  8AH
DB 0D0H
DB  71H ; Q
DB  9FH
DB  8AH
DB  94H
DB  71H ; Q
DB 0A5H
DB  8AH
DB  9EH
DB  71H ; Q
DB 0B4H
DB  8AH
DB 0A8H
DB  71H ; Q
DB  38H ; 8
DB  38H ; 8
DB 0C2H
DB  47H ; G
DB  40H ; @
DB  40H ; @
DB  18H
DB  38H ; 8
DB 0C2H
DB  55H ; U
DB  40H ; @
DB  40H ; @
DB  18H
DB  38H ; 8
DB 0C0H
DB  50H ; P
DB  40H ; @
DB  20H
DB 0C0H
DB  5FH ; _
DB  40H ; @
DB  20H
DB 0C2H
DB  55H ; U
DB  40H ; @
DB  40H ; @
DB  18H
DB  38H ; 8
DB 0C2H
DB  5FH ; _
DB  40H ; @
DB  40H ; @
DB  18H
DB  38H ; 8
DB 0C2H
DB  71H ; Q
DB  40H ; @
DB  40H ; @
DB  18H
DB  38H ; 8
DB 0C0H
DB  6BH ; K
DB  40H ; @
DB  20H
DB 0C0H
DB  7FH ; 
DB  50H ; P
DB  20H
DB 0C0H
DB  5FH ; _
DB  50H ; P
DB  10H
DB  18H
DB  30H ; 0
DB  80H
DB  1DH
DB  41H ; A
DB  0EH
DB  22H ; "
DB  80H
DB  1DH
DB  41H ; A
DB  0EH
DB  22H ; "
DB  82H
DB 0D6H
DB  40H ; @
DB  18H
DB  15H
DB  38H ; 8
DB  80H
DB 0D6H
DB  40H ; @
DB    6
DB  22H ; "
DB  80H
DB 0D6H
DB  40H ; @
DB  0EH
DB  22H ; "
DB  80H
DB 0BEH
DB  40H ; @
DB  0EH
DB  22H ; "
DB  80H
DB 0AAH
DB  40H ; @
DB  10H
DB  80H
DB 0D6H
DB  40H ; @
DB  10H
DB  80H
DB 0AAH
DB  40H ; @
DB  10H
DB  80H
DB 0A0H
DB  40H ; @
DB  10H
DB  82H
DB  8FH
DB  40H ; @
DB  18H
DB  15H
DB  38H ; 8
DB  80H
DB  8FH
DB  40H ; @
DB    6
DB  22H ; "
DB  80H
DB  8FH
DB  40H ; @
DB  0EH
DB  22H ; "
DB  80H
DB 0A0H
DB  40H ; @
DB  10H
DB  80H
DB 0AAH
DB  40H ; @
DB  20H
DB  80H
DB 0BEH
DB  40H ; @
DB  10H
DB  80H
DB 0D6H
DB  40H ; @
DB  10H
DB  82H
DB 0BEH
DB  40H ; @
DB  18H
DB  15H
DB  38H ; 8
DB  80H
DB 0BEH
DB  40H ; @
DB    6
DB  22H ; "
DB  80H
DB 0BEH
DB  40H ; @
DB  0EH
DB  22H ; "
DB  80H
DB 0D6H
DB  40H ; @
DB  10H
DB  80H
DB 0BEH
DB  40H ; @
DB  10H
DB  80H
DB 0AAH
DB  40H ; @
DB  10H
DB  80H
DB 0BEH
DB  40H ; @
DB  10H
DB  80H
DB 0D6H
DB  40H ; @
DB  10H
DB  82H
DB 0BEH
DB  40H ; @
DB  18H
DB  15H
DB  38H ; 8
DB  80H
DB 0BEH
DB  40H ; @
DB    6
DB  22H ; "
DB  80H
DB 0BEH
DB  40H ; @
DB  0EH
DB  22H ; "
DB  80H
DB 0E2H
DB  50H ; P
DB  10H
DB  80H
DB  1DH
DB  51H ; Q
DB  10H
DB  18H
DB  38H ; 8
DB  38H ; 8
DB  40H ; @
DB 0ACH
DB  41H ; A
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0AAH
DB  50H ; P
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0ACH
DB  41H ; A
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0D6H
DB  50H ; P
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0C5H
DB  41H ; A
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0A0H
DB  50H ; P
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0ACH
DB  41H ; A
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0AAH
DB  50H ; P
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0C5H
DB  41H ; A
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0A0H
DB  50H ; P
DB  10H
DB  40H ; @
DB  1DH
DB  51H ; Q
DB  10H
DB  40H ; @
DB  3BH ; ;
DB  42H ; B
DB  10H
DB  40H ; @
DB  40H ; @
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0E2H
DB  50H ; P
DB  10H
DB  40H ; @
DB  40H ; @
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0FCH
DB  41H ; A
DB  10H
DB  40H ; @
DB  40H ; @
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0A0H
DB  50H ; P
DB  10H
DB  40H ; @
DB  40H ; @
DB  51H ; Q
DB  10H
DB  40H ; @
DB 0C5H
DB  61H ; A
DB  10H
DB  18H
DB  82H
DB 0AAH
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB 0AAH
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  7FH ; 
DB  30H ; 0
DB  1EH
DB  14H
DB  48H ; H
DB  82H
DB  7FH ; 
DB  30H ; 0
DB  0AH
DB  14H
DB  24H ; $
DB  82H
DB  7FH ; 
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  71H ; Q
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  65H ; E
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  7FH ; 
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  65H ; E
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  5FH ; _
DB  30H ; 0
DB  14H
DB  14H
DB  36H ; 6
DB  82H
DB  55H ; U
DB  30H ; 0
DB  21H ; !
DB  14H
DB  48H ; H
DB  82H
DB  55H ; U
DB  30H ; 0
DB  0CH
DB  14H
DB  24H ; $
DB  82H
DB  55H ; U
DB  30H ; 0
DB  1AH
DB  14H
DB  36H ; 6
DB  82H
DB  5FH ; _
DB  30H ; 0
DB  1CH
DB  14H
DB  36H ; 6
DB  82H
DB  65H ; E
DB  40H ; @
DB  40H ; @
DB  19H
DB  3FH ; ?
DB  10H
DB  3EH ; >
DB  2AH ; *
DB 0C2H
DB 0FCH
DB  41H ; A
DB  14H
DB  14H
DB  36H ; 6
DB 0C2H
DB  53H ; S
DB  51H ; Q
DB  14H
DB  14H
DB  36H ; 6
DB 0C2H
DB 0CAH
DB  50H ; P
DB  14H
DB  14H
DB  36H ; 6
DB 0C2H
DB  53H ; S
DB  51H ; Q
DB  14H
DB  14H
DB  36H ; 6
DB 0C2H
DB 0FCH
DB  41H ; A
DB  50H ; P
DB  19H
DB  46H ; F
DB 0C2H
DB  1BH
DB  42H ; B
DB  16H
DB  14H
DB  36H ; 6
DB 0C2H
DB  53H ; S
DB  51H ; Q
DB  18H
DB  14H
DB  36H ; 6
DB 0C2H
DB 0BEH
DB  50H ; P
DB  1AH
DB  14H
DB  36H ; 6
DB 0C2H
DB  53H ; S
DB  51H ; Q
DB  1CH
DB  14H
DB  36H ; 6
DB 0C2H
DB 0FCH
DB  51H ; Q
DB  40H ; @
DB  18H
DB  3FH ; ?
DB  10H
DB  40H ; @
DB  55H ; U
DB  30H ; 0
DB  10H
DB  40H ; @
DB  50H ; P
DB  20H
DB  10H
DB  40H ; @
DB  40H ; @
DB  30H ; 0
DB  10H
DB  40H ; @
DB  47H ; G
DB  20H
DB  10H
DB  40H ; @
DB  50H ; P
DB  20H
DB    8
DB  40H ; @
DB  55H ; U
DB  30H ; 0
DB    8
DB  40H ; @
DB  5FH ; _
DB  30H ; 0
DB  10H
DB  40H ; @
DB  8FH
DB  30H ; 0
DB  10H
DB  40H ; @
DB  6BH ; K
DB  20H
DB  10H
DB  40H ; @
DB  5FH ; _
DB  30H ; 0
DB  10H
DB  40H ; @
DB  55H ; U
DB  20H
DB  10H
DB  40H ; @
DB  50H ; P
DB  30H ; 0
DB    8
DB  40H ; @
DB  55H ; U
DB  30H ; 0
DB    8
DB  40H ; @
DB  5FH ; _
DB  20H
DB  10H
DB  40H ; @
DB  55H ; U
DB  30H ; 0
DB  10H
DB  40H ; @
DB  50H ; P
DB  20H
DB  10H
DB  40H ; @
DB  47H ; G
DB  30H ; 0
DB    8
DB  40H ; @
DB  50H ; P
DB  30H ; 0
DB    8
DB  40H ; @
DB  55H ; U
DB  20H
DB  10H
DB  40H ; @
DB  47H ; G
DB  20H
DB    8
DB  68H ; H
DB  40H ; @
DB  47H ; G
DB  20H
DB    8
DB  68H ; H
DB  40H ; @
DB  47H ; G
DB  20H
DB    8
DB  68H ; H
DB  40H ; @
DB  47H ; G
DB  20H
DB  20H
DB  40H ; @
DB  50H ; P
DB  20H
DB    8
DB  40H ; @
DB  55H ; U
DB  20H
DB    8
DB  40H ; @
DB  5FH ; _
DB  20H
DB    8
DB  40H ; @
DB  6BH ; K
DB  40H ; @
DB    8
DB  40H ; @
DB  71H ; Q
DB  30H ; 0
DB  10H
DB  40H ; @
DB  6BH ; K
DB  40H ; @
DB  10H
DB  40H ; @
DB  5FH ; _
DB  40H ; @
DB  10H
DB  40H ; @
DB  55H ; U
DB  40H ; @
DB    8
DB  40H ; @
DB  5FH ; _
DB  40H ; @
DB    8
DB  40H ; @
DB  6BH ; K
DB  30H ; 0
DB  10H
DB  40H ; @
DB  5FH ; _
DB  40H ; @
DB  10H
DB  40H ; @
DB  55H ; U
DB  40H ; @
DB  10H
DB  40H ; @
DB  50H ; P
DB  40H ; @
DB    8
DB  40H ; @
DB  55H ; U
DB  40H ; @
DB    8
DB  40H ; @
DB  5FH ; _
DB  30H ; 0
DB  10H
DB  40H ; @
DB  50H ; P
DB  40H ; @
DB    8
DB  28H ; (
DB  40H ; @
DB  50H ; P
DB  40H ; @
DB    8
DB  28H ; (
DB  40H ; @
DB  50H ; P
DB  40H ; @
DB    8
DB  28H ; (
DB  42H ; B
DB  50H ; P
DB  30H ; 0
DB  20H
DB  18H
DB  44H ; D
DB  10H
DB  80H
DB 0B4H
DB  50H ; P
DB  30H ; 0
DB  80H
DB 0AAH
DB  60H ; `
DB  20H
DB  80H
DB 0B4H
DB  60H ; `
DB  20H
DB  80H
DB 0E2H
DB  60H ; `
DB  60H ; `
DB  80H
DB 0D6H
DB  50H ; P
DB  20H
DB  80H
DB 0CAH
DB  60H ; `
DB  20H
DB  80H
DB  87H
DB  60H ; `
DB  20H
DB  80H
DB  8FH
DB  50H ; P
DB  20H
DB  80H
DB  97H
DB  60H ; `
DB  80H
DB  80H
DB  87H
DB  60H ; `
DB  20H
DB  80H
DB  78H ; X
DB  60H ; `
DB  10H
DB  18H
DB 0C0H
DB 0E2H
DB  90H
DB  20H
DB 0C0H
DB 0F0H
DB  70H ; P
DB  20H
DB 0C0H
DB 0FEH
DB  60H ; `
DB  20H
DB 0C0H
DB  0DH
DB  61H ; A
DB  20H
DB 0C0H
DB  97H
DB  60H ; `
DB  20H
DB 0C0H
DB 0AAH
DB  60H ; `
DB  20H
DB 0C0H
DB 0B4H
DB  60H ; `
DB  20H
DB 0C0H
DB 0F0H
DB  60H ; `
DB  20H
DB 0C0H
DB  2EH ; .
DB  61H ; A
DB  20H
DB 0C0H
DB 0AAH
DB  60H ; `
DB  20H
DB 0C0H
DB 0FEH
DB  60H ; `
DB  20H
DB 0C0H
DB 0F0H
DB  60H ; `
DB  20H
DB 0C0H
DB  2EH ; .
DB  61H ; A
DB  20H
DB 0C0H
DB 0F0H
DB  60H ; `
DB  20H
DB 0C0H
DB 0AAH
DB  60H ; `
DB  20H
DB 0C0H
DB 0BEH
DB  60H ; `
DB  20H
DB  18H
DB    2
DB    3
DB  23H ; #
DB  1FH
DB  3FH ; ?
DB  10H
DB 0C0H
DB 0ACH
DB  21H ; !
DB    1
DB  2BH ; +
DB  18H
DB 0C1H
DB  19H
DB    0
DB  14H
DB  11H
DB 0FFH
DB 0C1H
DB  0FH
DB    0
DB    9
DB  11H
DB 0FFH
DB 0C1H
DB  0DH
DB    0
DB    9
DB  11H
DB 0FFH
DB  10H
DB    2
DB  37H ; 7
DB  10H
DB  4FH ; O
DB  11H
DB  18H
DB 0C1H
DB    1
DB 0F0H
DB  1EH
DB  11H
DB    3
DB 0C1H
DB  5DH ; ]
DB 0F0H
DB  1EH
DB  11H
DB 0FDH
DB  18H
DB    2
DB    2
DB    4
DB  26H ; &
DB  11H
DB  10H
DB  42H ; B
DB  1BH
DB    2
DB    4
DB  26H ; &
DB  11H
DB  7EH ; ~
DB  7EH ; ~
DB  41H ; A
DB  57H ; W
DB    2
DB  0FH
DB  11H
DB 0E4H
DB  50H ; P
DB  82H
DB 0FAH
DB    2
DB    4
DB  26H ; &
DB  11H
DB 0BEH
DB 0BEH
DB  81H
DB  57H ; W
DB    1
DB  0FH
DB  11H
DB 0EEH
DB  90H



SUB_8AC3:
LD      HL, 712DH
LD      (HL), 90H
INC     HL
LD      (HL), 90H
INC     HL
LD      DE, 7130H
LD      BC, 0AH
LD      (HL), 0
LDIR
LD      A, 0FH
LD      ($7133), A
LD      ($7138), A
RET
; END OF FUNCTION SUB_8AC3

UNK_8ADF:DB  44H ; D
DB 0ADH
DB 0C8H
DB 0B0H
DB  11H
DB 0B4H
DB  1BH
DB 0B6H
DB  44H ; D
DB 0ADH
DB  67H ; G
DB 0B6H
DB 0A1H
DB 0B8H



SUB_8AED:

; FUNCTION CHUNK AT 8DD6 SIZE 0000000C BYTES

LD      HL, 7250H
LD      (HL), 0
LD      A, 0
LD      ($7259), A
LD      HL, 71F9H
BIT     0, (HL)
JR      Z, LOC_8B14
LD      C, 82H
LD      B, 1
CALL    WRITE_REGISTER
LD      A, ($71F4)
AND     2
ADD     A, 3
LD      ($724E), A
LD      HL, 71F9H
SET     1, (HL)

LOC_8B14:
LD      HL, 71F9H
BIT     1, (HL)
JR      Z, LOC_8B4A
CALL    SUB_8E7D
LD      A, ($71F3)
CP      7
JR      NZ, LOC_8B32
LD      A, 6
LD      ($71F3), A
CALL    SUB_8E7D
LD      A, 7
LD      ($71F3), A

LOC_8B32:
LD      HL, UNK_8ADF
LD      A, ($71F3)
DEC     A
SLA     A
LD      C, A
LD      B, 0
ADD     HL, BC
CALL    SUB_8DB2
LD      ($7257), HL
LD      A, 0B0H
LD      ($724F), A

LOC_8B4A:
LD      A, ($724F)
LD      C, A
LD      A, ($718F)
BIT     2, A
LD      HL, 71F3H
LD      A, (HL)
JR      NZ, LOC_8B5D
LD      C, 0B0H
JR      LOC_8B69

LOC_8B5D:
CP      2
JR      NZ, LOC_8B63
LD      C, 0A8H

LOC_8B63:
CP      4
JR      NZ, LOC_8B69
LD      C, 0B0H

LOC_8B69:
CP      3
JR      NZ, LOC_8B6F
LD      C, 80H

LOC_8B6F:
CP      1
JR      NZ, LOC_8B7E
LD      D, A
LD      A, ($71F8)
CP      1
LD      A, D
JR      NZ, LOC_8B7E
LD      C, 0A8H

LOC_8B7E:
LD      A, C
LD      ($724F), A
LD      HL, ($7257)
CALL    SUB_8DB2
CALL    SUB_AAEC
LD      A, ($71F3)
CP      6
JP      Z, LOC_8CBE
CP      7
JP      Z, LOC_8DD6
LD      B, 5
CP      3
JR      Z, LOC_8BAC
CP      2
JR      Z, LOC_8BAA
CP      4
JR      Z, LOC_8BA8
JR      NZ, LOC_8BBB

LOC_8BA8:
INC     B
INC     B

LOC_8BAA:
INC     B
INC     B

LOC_8BAC:
LD      A, ($71F1)
CP      1
JR      Z, LOC_8BBB
LD      A, B
ADD     A, A
ADD     A, A
LD      C, A
LD      B, 0
JR      LOC_8BBE

LOC_8BBB:
LD      BC, 0

LOC_8BBE:
LD      HL, ($7257)
LD      DE, 4
ADD     HL, DE
ADD     HL, BC
LD      ($7251), HL
LD      A, ($71F3)
DEC     A
JR      NZ, LOC_8BE3
LD      A, ($71F8)
DEC     A
JR      NZ, LOC_8BE3
LD      A, 5
LD      ($7259), A
LD      DE, 720EH
LD      HL, UNK_8E0F
CALL    SUB_8DE2

LOC_8BE3:
LD      HL, ($7251)
INC     HL
INC     HL
CALL    SUB_8DB2
CALL    SUB_8CC6

LOC_8BEE:
LD      A, ($7259)
CP      20H ; ' '
JP      NC, LOC_8CBE
CALL    RAND_GEN
LD      HL, ($7251)

LOC_8BFC:
LD      C, A
LD      A, (HL)
CP      0FFH
LD      A, C
JR      NZ, LOC_8C06
INC     HL
JR      LOC_8C13

LOC_8C06:
CP      (HL)
INC     HL
JR      Z, LOC_8C18
JR      C, LOC_8C13
CP      (HL)
JR      Z, LOC_8C18
JR      NC, LOC_8C13
JR      LOC_8C18

LOC_8C13:
INC     HL
INC     HL
INC     HL
JR      LOC_8BFC

LOC_8C18:
INC     HL
LD      ($7255), HL
CALL    SUB_8DB2
LD      ($7253), HL
LD      HL, ($7253)
PUSH    HL
POP     IX
LD      A, (IX+1)
BIT     7, A
LD      IX, ($7257)
JR      Z, LOC_8C40
LD      HL, 724FH
ADD     A, (HL)
JR      NC, LOC_8C4D
CP      (IX+3)
JR      NC, LOC_8C67
JR      LOC_8C4D

LOC_8C40:
LD      HL, 724FH
ADD     A, (HL)
JR      C, LOC_8C5A
CP      (IX+2)
JR      NC, LOC_8C5A
JR      LOC_8C67

LOC_8C4D:
CALL    SUB_8E16

LOC_8C50:
LD      A, (HL)
BIT     5, A
JR      NZ, LOC_8C67
CALL    SUB_8DB7
JR      LOC_8C50

LOC_8C5A:
CALL    SUB_8E16

LOC_8C5D:
LD      A, (HL)
BIT     6, A
JR      NZ, LOC_8C67
CALL    SUB_8DB7
JR      LOC_8C5D

LOC_8C67:
LD      A, ($7250)
INC     A
LD      HL, 724EH
CP      (HL)
JR      Z, LOC_8C78
LD      A, ($7259)
CP      18H
JR      C, LOC_8CB5

LOC_8C78:
LD      HL, 71F9H
BIT     3, (HL)
JR      Z, LOC_8C89
LD      C, 0AH
CALL    SUB_8E1F
LD      ($7253), HL
JR      LOC_8C96

LOC_8C89:
LD      HL, ($7253)
LD      A, (HL)
BIT     7, A
JR      NZ, LOC_8C96
CALL    SUB_8DB7
JR      LOC_8C89

LOC_8C96:
LD      A, ($7259)
CP      20H ; ' '
JR      NC, LOC_8CA7
LD      C, 0EH
CALL    SUB_8E1F
CALL    SUB_8CC6
JR      LOC_8C96

LOC_8CA7:
LD      IX, ($7253)
LD      A, (IX+2)
LD      B, A
LD      A, 20H ; ' '
SUB     B
LD      ($7259), A

LOC_8CB5:
LD      HL, ($7253)
CALL    SUB_8CC6
JP      LOC_8BEE

LOC_8CBE:
LD      C, 0C2H
LD      B, 1
CALL    WRITE_REGISTER
RET
; END OF FUNCTION SUB_8AED




SUB_8CC6:
LD      ($725B), HL
PUSH    HL
POP     IX
LD      L, (IX+5)
LD      H, (IX+6)
LD      ($725D), HL
INC     HL
INC     HL
CALL    SUB_8DB2
LD      (HL), 0
INC     HL
LD      A, ($7259)
ADD     A, A
ADD     A, A
ADD     A, A
LD      ($7260), A
CALL    SUB_8E27
LD      A, ($724F)
LD      B, (IX+4)
SUB     B
LD      ($725F), A
CALL    SUB_8E2D
LD      HL, ($725D)
PUSH    HL
OR      A
CALL    ACTIVATE
POP     IX
CALL    SUB_8E39
LD      A, 0
LD      ($725A), A

LOC_8D08:
LD      IX, ($725B)
LD      C, (IX+2)
LD      A, ($725A)
CP      C
JR      Z, LOC_8D4F
LD      A, ($7259)
CP      20H ; ' '
JR      NC, LOC_8D4F
ADD     A, A
LD      E, A
LD      D, 0
LD      HL, 720EH
ADD     HL, DE
LD      IX, ($725B)
LD      A, ($725A)
ADD     A, A
LD      E, A
LD      D, 0
ADD     IX, DE
LD      A, (IX+8)
LD      (HL), A
INC     IX
INC     HL
LD      A, (IX+8)
PUSH    HL
LD      HL, 724FH
ADD     A, (HL)
POP     HL
LD      (HL), A
LD      ($724F), A
LD      HL, 725AH
INC     (HL)
LD      HL, 7259H
INC     (HL)
JR      LOC_8D08

LOC_8D4F:
LD      A, ($725F)
LD      IX, ($725B)
LD      B, (IX+3)
PUSH    AF
LD      A, B
ADD     A, A
ADD     A, A
ADD     A, A
LD      B, A
POP     AF
ADD     A, B
JR      C, LOC_8DA5
CP      0C0H
JR      NC, LOC_8DA5
LD      ($725F), A
LD      HL, 702BH
LD      IX, ($725B)
LD      A, (IX+2)
LD      (HL), A
INC     HL
LD      (HL), 1
LD      B, A
LD      A, (IX+7)

LOC_8D7C:
INC     HL
LD      (HL), A
DJNZ    LOC_8D7C

LOC_8D80:
LD      HL, 72C3H
LD      (HL), 0
INC     HL
LD      A, ($7260)
CALL    SUB_8E27
LD      A, ($725F)
CALL    SUB_8E2D
LD      IX, UNK_AADF
CALL    SUB_8E39
LD      A, ($725F)
ADD     A, 8
LD      ($725F), A
CP      0C0H
JR      C, LOC_8D80

LOC_8DA5:
LD      HL, ($725B)
LD      A, (HL)
AND     80H
JR      Z, LOCRET_8DB1
LD      HL, 7250H
INC     (HL)

LOCRET_8DB1:
RET
; END OF FUNCTION SUB_8CC6




SUB_8DB2:
LD      E, (HL)
INC     HL
LD      D, (HL)
EX      DE, HL
RET
; END OF FUNCTION SUB_8DB2




SUB_8DB7:
LD      HL, ($7255)
; END OF FUNCTION SUB_8DB7




SUB_8DBA:
LD      BC, 4
ADD     HL, BC
LD      ($7255), HL
CALL    SUB_8DB2
LD      ($7253), HL
RET
; END OF FUNCTION SUB_8DBA




SUB_8DC8:
LD      HL, 720EH
LD      B, 20H ; ' '

LOC_8DCD:
LD      (HL), 0
INC     HL
LD      (HL), 0B0H
INC     HL
DJNZ    LOC_8DCD
RET
; END OF FUNCTION SUB_8DC8

; START OF FUNCTION CHUNK FOR SUB_8AED

LOC_8DD6:
LD      DE, 720EH
LD      HL, UNK_8DF6
CALL    SUB_8DE2
JP      LOC_8CBE
; END OF FUNCTION CHUNK FOR SUB_8AED



SUB_8DE2:
LD      B, (HL)
DEC     B
JR      Z, LOCRET_8DF5
INC     HL

LOC_8DE7:
LD      A, (HL)
LD      (DE), A
INC     DE
INC     HL
LD      A, (HL)
LD      (DE), A
INC     DE
DEC     HL
DJNZ    LOC_8DE7
INC     HL
INC     HL
JR      SUB_8DE2

LOCRET_8DF5:
RET
; END OF FUNCTION SUB_8DE2

UNK_8DF6:DB  14H
DB    0
DB 0ADH
DB    2
DB    1
DB  90H
DB    2
DB    1
DB  88H
DB    2
DB  40H ; @
DB  88H
DB    2
DB    0
DB  88H
DB    2
DB    0
DB  90H
DB    2
DB    1
DB 0B0H
DB    8
DB    6
DB  60H ; `
DB    1
UNK_8E0F:DB    3
DB  0EH
DB 0A8H
DB    4
DB    0
DB 0A8H
DB    1



SUB_8E16:
LD      HL, ($7251)
DEC     HL
DEC     HL
CALL    SUB_8DBA
RET
; END OF FUNCTION SUB_8E16




SUB_8E1F:
LD      HL, ($7257)
LD      B, 0
ADD     HL, BC
JR      SUB_8DB2
; END OF FUNCTION SUB_8E1F




SUB_8E27:
LD      (HL), A
INC     HL
LD      (HL), 0
INC     HL
RET
; END OF FUNCTION SUB_8E27




SUB_8E2D:
CALL    SUB_8E27
LD      A, ($71F9)
BIT     2, A
CALL    Z, SUB_98E2
RET
; END OF FUNCTION SUB_8E2D




SUB_8E39:
CALL    PUTOBJ
LD      A, ($71F9)
BIT     2, A
CALL    Z, SUB_98F8
RET
; END OF FUNCTION SUB_8E39

UNK_8E45:DB  88H
DB  8FH
DB    5
DB  91H
DB  6AH ; J
DB  91H
DB  96H
DB  91H
DB  12H
DB  93H
DB 0F8H
DB  94H
DB  61H ; A
DB  95H
DB 0A9H
DB  95H
DB 0C0H
DB  91H
DB 0E8H
DB  92H
DB    7
DB  93H
DB  0CH
DB  93H
DB  12H
DB  93H
DB 0F8H
DB  94H
DB  61H ; A
DB  95H
DB 0A9H
DB  95H
DB  88H
DB  8FH
DB    5
DB  91H
DB  6AH ; J
DB  91H
DB  96H
DB  91H
DB 0E7H
DB  95H
DB  8BH
DB  97H
DB 0EEH
DB  97H
DB  0EH
DB  98H
DB 0E7H
DB  95H
DB  8BH
DB  97H
DB 0EEH
DB  97H
DB  0EH
DB  98H



SUB_8E7D:
LD      HL, 71F3H
LD      A, (HL)
DEC     A
ADD     A, A
ADD     A, A
ADD     A, A
LD      C, A
LD      B, 0
LD      HL, UNK_8E45
ADD     HL, BC
LD      C, 8
LD      DE, 7261H
LDIR
LD      D, 0
CALL    SUB_8EC2
LD      D, 8
CALL    SUB_8EC2
LD      D, 10H
CALL    SUB_8EC2
LD      D, 0
CALL    SUB_8ED5
LD      D, 8
CALL    SUB_8ED5
LD      D, 10H
JR      SUB_8ED5
; END OF FUNCTION SUB_8E7D




SUB_8EB0:
PUSH    HL
LD      A, ($71F3)
BIT     0, A
JR      Z, LOC_8EBA

LOC_8EB8:
POP     HL
RET

LOC_8EBA:
LD      HL, 400H
ADD     HL, DE
PUSH    HL
POP     DE
JR      LOC_8EB8
; END OF FUNCTION SUB_8EB0




SUB_8EC2:
LD      E, 0
CALL    SUB_8EB0
LD      HL, 2000H
ADD     HL, DE
LD      IY, ($7261)
LD      IX, ($7263)
JR      LOC_8EE6
; END OF FUNCTION SUB_8EC2




SUB_8ED5:
LD      E, 0
CALL    SUB_8EB0
LD      HL, 0
ADD     HL, DE
LD      IY, ($7265)
LD      IX, ($7267)

LOC_8EE6:
XOR     A
CALL    SUB_8EEB
RET
; END OF FUNCTION SUB_8ED5




SUB_8EEB:
LD      ($7269), IX
LD      ($726B), IY
LD      ($726D), HL
LD      ($726F), A

LOC_8EF9:
LD      IX, ($7269)
LD      A, (IX+0)
CP      0
JR      Z, LOCRET_8F7C
LD      A, (IX+0)
AND     80H
JR      Z, LOC_8F31
LD      A, (IX+0)
AND     7FH
LD      E, A
LD      D, 0
LD      IY, ($726B)
LD      A, (IY+0)
LD      HL, ($726D)
LD      C, A
LD      A, ($726F)
INC     A
LD      A, C
JR      Z, LOC_8F7D
CALL    FILL_VRAM

LOC_8F28:
LD      HL, ($726B)
INC     HL
LD      ($726B), HL
JR      LOC_8F5E

LOC_8F31:
LD      A, (IX+0)
AND     7FH
LD      C, A
LD      B, 0
LD      HL, ($726B)
LD      DE, ($726D)
LD      A, ($726F)
INC     A
JR      Z, LOC_8F84
CALL    WRITE_VRAM

LOC_8F49:
LD      HL, ($726B)
LD      IX, ($7269)
LD      A, (IX+0)
AND     7FH
ADD     A, L
LD      L, A
LD      A, 0
ADC     A, H
LD      H, A
LD      ($726B), HL

LOC_8F5E:
LD      IX, ($7269)
LD      HL, ($726D)
LD      A, (IX+0)
AND     7FH
ADD     A, L
LD      L, A
LD      A, 0
ADC     A, H
LD      H, A
LD      ($726D), HL
INC     IX
LD      ($7269), IX
JP      LOC_8EF9

LOCRET_8F7C:
RET

LOC_8F7D:
LD      B, E

LOC_8F7E:
LD      (HL), A
INC     HL
DJNZ    LOC_8F7E
JR      LOC_8F28

LOC_8F84:
LDIR
JR      LOC_8F49
; END OF FUNCTION SUB_8EEB

DB    0
DB  83H
DB    3
DB    2
DB    2
DB    0
DB    0
DB  80H
DB  80H
DB 0C7H
DB 0C7H
DB  87H
DB    7
DB  0FH
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB 0F8H
DB 0F0H
DB 0F0H
DB 0E1H
DB 0E1H
DB 0FFH
DB 0FFH
DB 0FCH
DB 0FCH
DB 0F8H
DB  2FH ; /
DB  2FH ; /
DB  0FH
DB  87H
DB 0C7H
DB 0C7H
DB 0C3H
DB 0C3H
DB 0E1H
DB 0E0H
DB 0F8H
DB 0FCH
DB 0FEH
DB 0FFH
DB 0E1H
DB 0F0H
DB 0F1H
DB 0F3H
DB 0E3H
DB    0
DB  30H ; 0
DB  7CH ; |
DB 0FFH
DB  7FH ; 
DB 0FFH
DB  1FH
DB  7FH ; 
DB  6FH ; O
DB  4FH ; O
DB  1DH
DB    8
DB 0F3H
DB 0E1H
DB 0E1H
DB 0F7H
DB 0FFH
DB 0EFH
DB 0C7H
DB 0CFH
DB 0FEH
DB 0FFH
DB 0F8H
DB 0FEH
DB 0F6H
DB 0F2H
DB  48H ; H
DB  10H
DB    0
DB  80H
DB    0
DB    1
DB 0C3H
DB  81H
DB  30H ; 0
DB 0C5H
DB 0FFH
DB 0FFH
DB 0F7H
DB 0F3H
DB  31H ; 1
DB  21H ; !
DB    0
DB    0
DB  7FH ; 
DB  7FH ; 
DB  33H ; 3
DB    3
DB    6
DB    4
DB    0
DB    0
DB 0FFH
DB 0F7H
DB 0E7H
DB  47H ; G
DB  0BH
DB 0FEH
DB 0FCH
DB 0F8H
DB 0F0H
DB 0E0H
DB 0C0H
DB 0FFH
DB  1FH
DB  7FH ; 
DB  6FH ; O
DB  4FH ; O
DB  1DH
DB    8
DB 0FCH
DB 0FFH
DB 0F8H
DB 0FEH
DB 0F6H
DB 0F2H
DB 0B8H
DB  8CH
DB  0FH
DB    7
DB    1
DB    0
DB 0FFH
DB  7FH ; 
DB  1FH
DB    7
DB    3
DB    1
DB 0FFH
DB 0FFH
DB  7FH ; 
DB  3FH ; ?
DB  1FH
DB  0FH
DB  1FH
DB  1FH
DB  3FH ; ?
DB  3FH ; ?
DB    0
DB    0
DB    1
DB    1
DB    7
DB  0FH
DB  3FH ; ?
DB 0FFH
DB  7FH ; 
DB  1FH
DB    3
DB    0
DB 0FFH
DB    0
DB 0FFH
DB 0F8H
DB 0E0H
DB    0
DB    0
DB 0FFH
DB 0FFH
DB 0F7H
DB 0FFH
DB  9FH
DB 0F9H
DB 0FFH
DB  80H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0F0H
DB 0F0H
DB 0F8H
DB 0FCH
DB 0F8H
DB 0F0H
DB 0E0H
DB 0E0H
DB 0C0H
DB 0C0H
DB  80H
DB    0
DB 0FEH
DB 0FCH
DB 0F8H
DB 0F0H
DB 0E0H
DB  80H
DB    0
DB    0
DB  0FH
DB  1FH
DB  3FH ; ?
DB  3FH ; ?
DB 0FFH
DB  3FH ; ?
DB  1FH
DB  0FH
DB 0FFH
DB  7FH ; 
DB  7FH ; 
DB  3FH ; ?
DB  3FH ; ?
DB 0FFH
DB  7FH ; 
DB  7FH ; 
DB  3FH ; ?
DB  3FH ; ?
DB  1FH
DB  0FH
DB    7
DB  0FH
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB  0FH
DB 0FFH
DB    0
DB    1
DB    3
DB    3
DB    1
DB    1
DB    0
DB    0
DB  40H ; @
DB 0E0H
DB 0E0H
DB 0E2H
DB 0E7H
DB 0F7H
DB 0FFH
DB 0EFH
DB    0
DB  10H
DB  38H ; 8
DB 0E7H
DB 0F7H
DB 0FFH
DB 0EFH
DB 0B8H
DB 0F8H
DB  78H ; X
DB  38H ; 8
DB 0E7H
DB 0E7H
DB  67H ; G
DB    7
DB    3
DB  38H ; 8
DB  38H ; 8
DB 0B8H
DB 0F8H
DB  78H ; X
DB  38H ; 8
DB    0
DB  52H ; R
DB 0CAH
DB  6AH ; J
DB 0ADH
DB  38H ; 8
DB  52H ; R
DB 0CAH
DB  6AH ; J
DB 0ADH
DB    0
DB  54H ; T
DB 0D7H
DB  95H
DB 0BDH
DB 0FFH
DB 0D4H
DB  95H
DB 0BDH
DB 0FFH
DB    0
DB    1
DB  57H ; W
DB  94H
DB 0BDH
DB 0FFH
DB    0
DB  56H ; V
DB 0D5H
DB 0BCH
DB 0FFH
DB    0
DB  56H ; V
DB 0D5H
DB  95H
DB    0
DB  56H ; V
DB 0D5H
DB  65H ; E
DB 0BDH
DB    0
DB  56H ; V
DB 0D5H
DB  95H
DB 0BDH
DB 0FFH
DB    0
DB    0
DB  56H ; V
DB 0D5H
DB  95H
DB 0BDH
DB 0FFH
DB 0ADH
DB  25H ; %
DB  95H
DB  52H ; R
DB 0FFH
DB 0ADH
DB  25H ; %
DB  96H
DB  59H ; Y
DB    0
DB 0FFH
DB 0FDH
DB 0AFH
DB  25H ; %
DB  96H
DB  52H ; R
DB    0
DB    0
DB 0FFH
DB 0ADH
DB  25H ; %
DB  96H
DB  52H ; R
DB    0
DB 0ADH
DB  25H ; %
DB  96H
DB  52H ; R
DB    0
DB 0FFH
DB 0ADH
DB  25H ; %
DB  96H
DB  52H ; R
DB    0
DB 0FFH
DB 0ADH
DB  25H ; %
DB  96H
DB  52H ; R
DB    0
DB 0FFH
DB 0FBH
DB 0F1H
DB 0E4H
DB 0F1H
DB 0FBH
DB  8CH
DB  52H ; R
DB  8CH
DB    0
DB  31H ; 1
DB  4AH ; J
DB  0AH
DB  32H ; 2
DB  42H ; B
DB  42H ; B
DB  79H ; Y
DB    0
DB  79H ; Y
DB  0AH
DB  12H
DB  32H ; 2
DB  0AH
DB  4AH ; J
DB  31H ; 1
DB    0
DB  88H
DB  10H
DB  84H
DB    8
DB  84H
DB  0DH
DB  86H
DB    8
DB  85H
DB  30H ; 0
DB  84H
DB    9
DB  83H
DB  9AH
DB  11H
DB  85H
DB  83H
DB    8
DB  84H
DB    1
DB  84H
DB  0BH
DB  8DH
DB    4
DB  84H
DB  84H
DB  84H
DB  0AH
DB  8AH
DB    6
DB  83H
DB  83H
DB  83H
DB  83H
DB  0EH
DB  84H
DB    5
DB  84H
DB  83H
DB  84H
DB    4
DB  84H
DB    5
DB  83H
DB  84H
DB  83H
DB  84H
DB  83H
DB    2
DB  86H
DB  8EH
DB  88H
DB  10H
DB  86H
DB    2
DB  85H
DB    6
DB  85H
DB    3
DB  84H
DB    6
DB  83H
DB  84H
DB    4
DB  84H
DB    4
DB  88H
DB    4
DB  84H
DB    3
DB  85H
DB  86H
DB    4
DB  86H
DB  86H
DB    3
DB  87H
DB  85H
DB    3
DB  84H
DB    4
DB  83H
DB  0BH
DB  8EH
DB    4
DB  83H
DB  12H
DB  83H
DB    4
DB  84H
DB  8FH
DB    4
DB  85H
DB  86H
DB    4
DB  8EH
DB  83H
DB    6
DB  85H
DB  12H
DB    0
DB  88H
DB  78H ; X
DB  33H ; 3
DB  33H ; 3
DB  78H ; X
DB  28H ; (
DB  28H ; (
DB  78H ; X
DB  33H ; 3
DB  78H ; X
DB  73H ; S
DB  32H ; 2
DB  72H ; R
DB  82H
DB  72H ; R
DB  22H ; "
DB  33H ; 3
DB  77H ; W
DB  38H ; 8
DB  37H ; 7
DB  78H ; X
DB  28H ; (
DB  88H
DB  8AH
DB 0A8H
DB 0AAH
DB 0A2H
DB 0A1H
DB 0ACH
DB 0CCH
DB 0CCH
DB  8AH
DB 0C8H
DB  22H ; "
DB  38H ; 8
DB 0F2H
DB 0F1H
DB  31H ; 1
DB 0F1H
DB  31H ; 1
DB  12H
DB  13H
DB  36H ; 6
DB 0FDH
DB  88H
DB  98H
DB    2
DB  86H
DB    2
DB  8EH
DB  83H
DB  85H
DB  88H
DB  98H
DB  88H
DB  88H
DB  98H
DB  88H
DB  88H
DB  88H
DB  88H
DB  88H
DB  98H
DB  90H
DB  88H
DB  98H
DB  88H
DB  88H
DB  98H
DB  88H
DB  98H
DB    2
DB  9EH
DB  90H
DB  88H
DB  88H
DB  90H
DB 0A0H
DB  88H
DB  84H
DB  84H
DB 0E0H
DB 0D8H
DB  88H
DB  98H
DB    0
DB 0FFH
DB  10H
DB  30H ; 0
DB  30H ; 0
DB  10H
DB  18H
DB  38H ; 8
DB  3CH ; <
DB  1EH
DB  1EH
DB  18H
DB  78H ; X
DB  3CH ; <
DB  1CH
DB  1CH
DB  3CH ; <
DB  38H ; 8
DB  7CH ; |
DB  7EH ; ~
DB  0EH
DB  3CH ; <
DB  3CH ; <
DB  1EH
DB  3EH ; >
DB  3CH ; <
DB  3EH ; >
DB  7FH ; 
DB  0FH
DB  3EH ; >
DB  3EH ; >
DB  3CH ; <
DB  3EH ; >
DB  1FH
DB  7EH ; ~
DB  7CH ; |
DB 0FCH
DB 0FCH
DB 0FEH
DB  7FH ; 
DB  3FH ; ?
DB 0FEH
DB 0FEH
DB 0FFH
DB  7FH ; 
DB  3FH ; ?
DB  1FH
DB  0FH
DB  0FH
DB  3FH ; ?
DB  3FH ; ?
DB 0FFH
DB  1CH
DB  3CH ; <
DB  78H ; X
DB  78H ; X
DB  18H
DB  1EH
DB  3CH ; <
DB  38H ; 8
DB  78H ; X
DB  7CH ; |
DB  3CH ; <
DB  7CH ; |
DB 0FEH
DB 0F0H
DB  7CH ; |
DB  7CH ; |
DB  3CH ; <
DB  7CH ; |
DB 0F8H
DB  7EH ; ~
DB  3EH ; >
DB  3FH ; ?
DB  3FH ; ?
DB  7FH ; 
DB 0FEH
DB 0FCH
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FEH
DB 0FCH
DB 0F8H
DB 0F0H
DB 0F0H
DB 0FCH
DB 0FCH
DB 0FFH
DB  10H
DB  30H ; 0
DB  30H ; 0
DB  10H
DB  18H
DB  38H ; 8
DB  3CH ; <
DB  1EH
DB  1EH
DB  18H
DB  78H ; X
DB  3CH ; <
DB  1CH
DB  1CH
DB  3CH ; <
DB  38H ; 8
DB  7CH ; |
DB  7EH ; ~
DB  0EH
DB  3CH ; <
DB  3CH ; <
DB  1EH
DB  3EH ; >
DB  3CH ; <
DB  3EH ; >
DB  7FH ; 
DB  0FH
DB  3EH ; >
DB  3EH ; >
DB  3CH ; <
DB  3EH ; >
DB  1FH
DB  7EH ; ~
DB  7CH ; |
DB 0FCH
DB 0FCH
DB 0FEH
DB  7FH ; 
DB  3FH ; ?
DB 0FEH
DB 0FEH
DB 0FFH
DB    3
DB    7
DB    7
DB    1
DB    1
DB  1BH
DB  1FH
DB  1FH
DB 0FFH
DB  10H
DB  18H
DB  18H
DB  10H
DB  30H ; 0
DB  3CH ; <
DB  7CH ; |
DB 0F8H
DB  7EH ; ~
DB  3EH ; >
DB  3FH ; ?
DB  3FH ; ?
DB  7FH ; 
DB 0FEH
DB 0FCH
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FEH
DB 0FCH
DB 0F8H
DB 0F0H
DB 0F0H
DB 0FCH
DB 0FCH
DB 0FFH
DB 0C0H
DB 0E0H
DB 0E0H
DB  80H
DB  80H
DB 0D8H
DB 0F8H
DB 0F0H
DB  8CH
DB  52H ; R
DB  8CH
DB    0
DB  31H ; 1
DB  4AH ; J
DB  0AH
DB  32H ; 2
DB  42H ; B
DB  42H ; B
DB  79H ; Y
DB    0
DB  79H ; Y
DB  0AH
DB  12H
DB  32H ; 2
DB  0AH
DB  4AH ; J
DB  31H ; 1
DB    0
DB  18H
DB    8
DB  0CH
DB  0CH
DB    8
DB  38H ; 8
DB  3CH ; <
DB  1EH
DB  18H
DB  78H ; X
DB  78H ; X
DB  3CH ; <
DB  1CH
DB  3CH ; <
DB  3CH ; <
DB  70H ; P
DB  7EH ; ~
DB  3EH ; >
DB  1CH
DB  3CH ; <
DB  38H ; 8
DB  7CH ; |
DB  7CH ; |
DB 0F0H
DB 0FEH
DB  7CH ; |
DB  3CH ; <
DB  7CH ; |
DB  78H ; X
DB  7FH ; 
DB  3FH ; ?
DB  3FH ; ?
DB  3EH ; >
DB  7EH ; ~
DB 0F8H
DB  7CH ; |
DB  3CH ; <
DB 0FFH
DB  7FH ; 
DB  7FH ; 
DB 0FCH
DB 0FEH
DB  7FH ; 
DB 0FFH
DB 0FCH
DB 0FCH
DB 0F0H
DB 0F0H
DB 0F8H
DB 0FCH
DB 0FEH
DB 0FFH
DB  0CH
DB    8
DB  18H
DB  18H
DB    8
DB  1CH
DB  3CH ; <
DB  78H ; X
DB  18H
DB  1EH
DB  1EH
DB  3CH ; <
DB  38H ; 8
DB  3CH ; <
DB  3CH ; <
DB  0EH
DB  7EH ; ~
DB  7CH ; |
DB  38H ; 8
DB  3CH ; <
DB  1CH
DB  3EH ; >
DB  3EH ; >
DB  0FH
DB  7FH ; 
DB  3EH ; >
DB  3CH ; <
DB  3EH ; >
DB  1EH
DB 0FFH
DB 0FEH
DB 0FEH
DB 0CFH
DB  7FH ; 
DB 0FEH
DB 0FFH
DB  3FH ; ?
DB  3FH ; ?
DB  0FH
DB  0FH
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB  0FH
DB  1FH
DB  13H
DB    1
DB    1
DB    7
DB    7
DB    3
DB  88H
DB  84H
DB  23H ; #
DB  84H
DB  0CH
DB  89H
DB  17H
DB  84H
DB  0DH
DB  84H
DB  23H ; #
DB  84H
DB  0DH
DB  88H
DB  84H
DB  0BH
DB  84H
DB  16H
DB  85H
DB  16H
DB  84H
DB  25H ; %
DB  83H
DB    8
DB  88H
DB    4
DB  84H
DB  1DH
DB  83H
DB  10H
DB    0
DB 0AAH
DB 0DAH
DB  1DH
DB 0F4H
DB  1AH
DB  88H
DB 0E8H
DB 0E8H
DB  98H
DB 0F8H
DB    0
DB 0F0H
DB  0FH
DB  10H
DB  10H
DB  38H ; 8
DB  38H ; 8
DB  7CH ; |
DB  7CH ; |
DB 0FEH
DB 0FFH
DB    0
DB    1
DB    3
DB    7
DB  0CH
DB  1CH
DB 0FCH
DB 0F0H
DB 0FCH
DB 0FCH
DB 0F8H
DB 0FFH
DB  87H
DB 0C3H
DB 0E1H
DB 0F0H
DB 0F8H
DB 0FCH
DB 0FEH
DB  38H ; 8
DB  38H ; 8
DB  3CH ; <
DB  3EH ; >
DB  1EH
DB  1CH
DB  3CH ; <
DB  7DH ; }
DB  10H
DB  18H
DB  1CH
DB  1CH
DB  1EH
DB  1FH
DB  8FH
DB  8FH
DB 0FFH
DB  3FH ; ?
DB  1FH
DB    7
DB  0FH
DB  1FH
DB  3FH ; ?
DB    0
DB  80H
DB 0C0H
DB 0E0H
DB 0F0H
DB 0F8H
DB 0FCH
DB 0FEH
DB  1FH
DB  0FH
DB    3
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB  3FH ; ?
DB  1FH
DB 0FBH
DB 0FBH
DB 0F1H
DB 0FFH
DB  7FH ; 
DB  1FH
DB  0FH
DB    7
DB    0
DB    2
DB  0AH
DB  2AH ; *
DB  16H
DB  12H
DB  15H
DB  0DH
DB  45H ; E
DB  33H ; 3
DB  5BH ; [
DB  57H ; W
DB  5BH ; [
DB  2BH ; +
DB 0A7H
DB 0AFH
DB 0DFH
DB 0BFH
DB  7FH ; 
DB  7FH ; 
DB    0
DB  40H ; @
DB  50H ; P
DB  54H ; T
DB 0DAH
DB 0D4H
DB 0E5H
DB 0F5H
DB 0FBH
DB 0FDH
DB 0FEH
DB 0FEH
DB  68H ; H
DB  48H ; H
DB 0A8H
DB 0B0H
DB 0A2H
DB 0CCH
DB 0DAH
DB 0EAH
DB 0FFH
DB 0FCH
DB 0E0H
DB    0
DB 0FCH
DB 0F8H
DB 0F0H
DB 0C0H
DB    0
DB 0FFH
DB 0FFH
DB 0FCH
DB 0E0H
DB    0
DB 0FFH
DB 0FFH
DB  3FH ; ?
DB    7
DB    0
DB 0FFH
DB  3FH ; ?
DB    7
DB    0
DB  3FH ; ?
DB  3FH ; ?
DB  0FH
DB    7
DB    0
DB 0FCH
DB 0FCH
DB 0F8H
DB 0F0H
DB 0E0H
DB 0C0H
DB  80H
DB    0
DB 0FBH
DB  8AH
DB  90H
DB 0D0H
DB 0D1H
DB 0E5H
DB 0F6H
DB 0F6H
DB 0DFH
DB  51H ; Q
DB    1
DB    3
DB  83H
DB 0A7H
DB  6FH ; O
DB  6FH ; O
DB  25H ; %
DB 0ADH
DB 0CBH
DB 0D7H
DB 0FFH
DB    0
DB    0
DB    1
DB  0BH
DB  1FH
DB  3FH ; ?
DB    6
DB  7FH ; 
DB  0BH
DB  37H ; 7
DB  0FH
DB 0BFH
DB 0FFH
DB    3
DB  1FH
DB  0FH
DB  0FH
DB    7
DB  0FH
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB 0FFH
DB  3FH ; ?
DB  0FH
DB    3
DB    3
DB    7
DB  0FH
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB  52H ; R
DB 0DAH
DB  6AH ; J
DB 0ADH
DB 0FFH
DB 0D0H
DB 0ECH
DB 0F0H
DB 0FDH
DB 0FFH
DB    0
DB    0
DB  80H
DB 0C0H
DB 0E0H
DB 0FCH
DB  60H ; `
DB 0FEH
DB 0C0H
DB 0F8H
DB 0F0H
DB 0F0H
DB 0E0H
DB 0F0H
DB 0F8H
DB 0FCH
DB 0FEH
DB 0F0H
DB 0FFH
DB 0FCH
DB 0F0H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0F0H
DB 0F8H
DB 0F8H
DB 0FCH
DB 0FEH
DB 0FFH
DB    7
DB 0C0H
DB 0E0H
DB 0F0H
DB 0F0H
DB 0E0H
DB 0C0H
DB    0
DB 0FFH
DB  7FH ; 
DB 0FFH
DB 0FFH
DB  87H
DB  87H
DB 0DFH
DB 0FFH
DB 0E0H
DB    3
DB    7
DB  0FH
DB  0FH
DB    7
DB    3
DB    0
DB 0FFH
DB 0FEH
DB 0FFH
DB 0FFH
DB 0E1H
DB 0E1H
DB 0FBH
DB 0FFH
DB    0
DB  52H ; R
DB 0DAH
DB  6AH ; J
DB 0ADH
DB 0FFH
DB 0EFH
DB 0C7H
DB  93H
DB 0C7H
DB 0EFH
DB 0FFH
DB 0FBH
DB 0F1H
DB 0E4H
DB 0F1H
DB 0FBH
DB    0
DB  52H ; R
DB 0DAH
DB  6AH ; J
DB 0ADH
DB    0
DB  8CH
DB  52H ; R
DB  8CH
DB    0
DB  31H ; 1
DB  4AH ; J
DB  0AH
DB  32H ; 2
DB  42H ; B
DB  42H ; B
DB  79H ; Y
DB    0
DB  79H ; Y
DB  0AH
DB  12H
DB  32H ; 2
DB  0AH
DB  4AH ; J
DB  31H ; 1
DB    0
DB  50H ; P
DB 0DAH
DB  6AH ; J
DB 0AAH
DB 0FDH
DB 0FFH
DB    0
DB  50H ; P
DB 0DAH
DB  6AH ; J
DB 0AAH
DB 0FDH
DB 0FFH
DB    0
DB  50H ; P
DB 0DAH
DB  6AH ; J
DB 0AAH
DB 0FDH
DB 0FFH
DB 0FFH
DB    0
DB  50H ; P
DB 0DAH
DB  6AH ; J
DB 0AAH
DB 0FDH
DB    0
DB  60H ; `
DB  10H
DB    9
DB    4
DB    4
DB  62H ; B
DB  12H
DB    0
DB    8
DB  90H
DB  51H ; Q
DB  52H ; R
DB  54H ; T
DB    1
DB  41H ; A
DB  22H ; "
DB  12H
DB    9
DB 0C5H
DB  37H ; 7
DB  1FH
DB  58H ; X
DB  59H ; Y
DB 0D1H
DB 0D2H
DB 0D2H
DB 0F6H
DB 0FEH
DB 0FEH
DB    0
DB    0
DB  0DH
DB  1FH
DB  1FH
DB    7
DB  77H ; W
DB  3FH ; ?
DB    0
DB  7CH ; |
DB 0FEH
DB 0FEH
DB 0FFH
DB    0
DB    0
DB  3EH ; >
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB    0
DB 0C0H
DB 0E0H
DB 0D0H
DB 0B8H
DB  1FH
DB  0FH
DB    7
DB    7
DB    3
DB    1
DB    0
DB    0
DB 0FFH
DB 0FFH
DB  3EH ; >
DB  34H ; 4
DB    0
DB 0F9H
DB 0F0H
DB    0
DB 0FFH
DB 0FDH
DB  7EH ; ~
DB  3FH ; ?
DB 0FEH
DB 0F8H
DB    0
DB    0
DB 0FCH
DB 0FCH
DB 0E0H
DB    0
DB  0FH
DB  1FH
DB  3FH ; ?
DB  1FH
DB    7
DB    1
DB    0
DB  20H
DB  70H ; P
DB 0F8H
DB 0FCH
DB 0F8H
DB 0B0H
DB    0
DB    7
DB  1FH
DB  3FH ; ?
DB  3FH ; ?
DB    0
DB    0
DB  40H ; @
DB 0F1H
DB 0FBH
DB  3FH ; ?
DB 0DFH
DB 0FFH
DB    0
DB    0
DB 0E0H
DB 0F0H
DB 0F0H
DB 0E0H
DB 0F8H
DB 0FCH
DB  0FH
DB  1FH
DB  3EH ; >
DB  3FH ; ?
DB  18H
DB    0
DB 0FFH
DB  7FH ; 
DB  3FH ; ?
DB  1FH
DB  1FH
DB  0EH
DB    0
DB    0
DB 0FEH
DB 0FEH
DB 0FCH
DB 0F8H
DB  20H
DB    0
DB  88H
DB  88H
DB    8
DB  83H
DB    6
DB  84H
DB  13H
DB  83H
DB  85H
DB    2
DB  83H
DB    3
DB  88H
DB    1
DB  83H
DB  0EH
DB  86H
DB    5
DB  83H
DB    2
DB  84H
DB  86H
DB    4
DB  85H
DB  13H
DB  85H
DB  13H
DB  8DH
DB    7
DB  84H
DB    4
DB  84H
DB    4
DB  84H
DB  85H
DB    7
DB  84H
DB    7
DB  89H
DB  14H
DB  84H
DB  0CH
DB  84H
DB    4
DB  85H
DB  83H
DB    9
DB  83H
DB    4
DB  84H
DB    4
DB  84H
DB    4
DB  84H
DB  0CH
DB  85H
DB  83H
DB    9
DB  83H
DB    5
DB  83H
DB    8
DB  83H
DB  83H
DB    5
DB  85H
DB    8
DB  83H
DB  83H
DB    5
DB  85H
DB  83H
DB    4
DB  8AH
DB    5
DB  85H
DB    5
DB  83H
DB    6
DB  85H
DB  11H
DB  86H
DB    5
DB  86H
DB  87H
DB    5
DB  84H
DB    8
DB  83H
DB  0DH
DB  83H
DB  21H ; !
DB  84H
DB    5
DB  83H
DB  84H
DB  1FH
DB  86H
DB  0DH
DB  86H
DB  19H
DB  83H
DB  0DH
DB  83H
DB    0
DB  17H
DB  1CH
DB  17H
DB  1AH
DB  17H
DB  1AH
DB  3CH ; <
DB  77H ; W
DB  7CH ; |
DB  3AH ; :
DB  3CH ; <
DB 0A3H
DB 0ACH
DB  3CH ; <
DB  3AH ; :
DB 0ACH
DB  3AH ; :
DB  3CH ; <
DB 0A3H
DB 0ACH
DB  3AH ; :
DB 0ACH
DB  3AH ; :
DB 0CAH
DB  3AH ; :
DB 0CAH
DB  3AH ; :
DB  3CH ; <
DB  38H ; 8
DB 0C5H
DB  11H
DB  11H
DB 0F1H
DB  3CH ; <
DB 0F7H
DB 0FEH
DB 0FEH
DB 0FFH
DB 0F7H
DB 0FEH
DB 0FEH
DB 0FFH
DB 0F7H
DB 0E7H
DB 0FFH
DB 0FFH
DB 0FEH
DB 0E7H
DB 0FFH
DB 0FEH
DB 0E7H
DB 0F7H
DB 0E7H
DB 0E7H
DB  77H ; W
DB 0F7H
DB 0E7H
DB 0F7H
DB  77H ; W
DB 0E7H
DB 0F7H
DB 0FEH
DB 0F7H
DB 0E7H
DB 0E7H
DB  77H ; W
DB 0FEH
DB 0E7H
DB 0F7H
DB 0E7H
DB 0E7H
DB  77H ; W
DB  88H
DB  88H
DB  98H
DB  88H
DB 0C0H
DB  90H
DB 0B0H
DB  88H
DB 0C0H
DB  98H
DB  86H
DB    2
DB  88H
DB    1
DB  8FH
DB  90H
DB  96H
DB    3
DB  8FH
DB  91H
DB  87H
DB  91H
DB  87H
DB  90H
DB  90H
DB  90H
DB  86H
DB    2
DB  98H
DB 0D0H
DB  8AH
DB    2
DB  84H
DB  83H
DB    2
DB  83H
DB  89H
DB  87H
DB    2
DB  83H
DB  83H
DB    1
DB  83H
DB  84H
DB    3
DB  85H
DB  85H
DB  83H
DB  88H
DB  84H
DB    1
DB  88H
DB    1
DB  8DH
DB    2
DB  83H
DB  84H
DB  84H
DB  83H
DB    2
DB  83H
DB    0
DB 0FFH
DB    0
DB  3FH ; ?
DB  7FH ; 
DB    0
DB 0FCH
DB 0FEH
DB    0
DB 0FFH
DB    0
DB    0
DB  9FH
DB  9FH
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB    0
DB 0FFH
DB 0FFH
DB 0FEH
DB 0FEH
DB 0FCH
DB 0FDH
DB 0FDH
DB 0F8H
DB 0F7H
DB 0CFH
DB 0AFH
DB  6FH ; O
DB 0F7H
DB 0FBH
DB 0F7H
DB 0FFH
DB  7FH ; 
DB 0BFH
DB 0DFH
DB 0AFH
DB 0F7H
DB 0EFH
DB 0DFH
DB  7FH ; 
DB  3FH ; ?
DB    0
DB 0FEH
DB 0FCH
DB    0
DB 0FFH
DB 0FEH
DB 0FEH
DB 0FCH
DB 0FCH
DB    0
DB 0CFH
DB  9FH
DB  9FH
DB  3FH ; ?
DB  3FH ; ?
DB  7FH ; 
DB  7FH ; 
DB    0
DB 0FFH
DB 0FEH
DB 0FEH
DB 0FFH
DB 0BFH
DB 0BFH
DB  77H ; W
DB  67H ; G
DB 0AFH
DB 0DFH
DB 0CFH
DB  7FH ; 
DB 0FEH
DB  3FH ; ?
DB  7FH ; 
DB  3FH ; ?
DB    7
DB    7
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB 0E0H
DB 0E8H
DB 0FCH
DB 0FEH
DB 0FFH
DB 0E0H
DB 0F8H
DB  1FH
DB  3FH ; ?
DB  1FH
DB 0E7H
DB  1FH
DB  0DH
DB  7FH ; 
DB  7FH ; 
DB  1FH
DB    0
DB  20H
DB 0FFH
DB  7FH ; 
DB  23H ; #
DB    7
DB    0
DB    0
DB 0E0H
DB 0F0H
DB  30H ; 0
DB 0F8H
DB 0FCH
DB 0FEH
DB    7
DB    3
DB    0
DB    3
DB    0
DB  10H
DB 0D8H
DB 0F0H
DB 0FCH
DB 0F4H
DB    8
DB 0BDH
DB  66H ; F
DB  42H ; B
DB  42H ; B
DB  81H
DB  42H ; B
DB  66H ; F
DB 0BDH
DB  80H
DB  40H ; @
DB  20H
DB  10H
DB    8
DB    4
DB    2
DB    1
DB    1
DB    2
DB    4
DB    8
DB  10H
DB  20H
DB  40H ; @
DB  80H
DB  81H
DB  82H
DB  44H ; D
DB  48H ; H
DB  50H ; P
DB 0A0H
DB 0CCH
DB 0F3H
DB  89H
DB  89H
DB  49H ; I
DB  49H ; I
DB  2AH ; *
DB  2AH ; *
DB  1CH
DB    8
DB  81H
DB  41H ; A
DB  22H ; "
DB  12H
DB  0AH
DB    5
DB  33H ; 3
DB 0CFH
DB 0CFH
DB  33H ; 3
DB    5
DB  0AH
DB  12H
DB  22H ; "
DB  41H ; A
DB  81H
DB    8
DB  1CH
DB  2AH ; *
DB  2AH ; *
DB  49H ; I
DB  49H ; I
DB  89H
DB  89H
DB 0F3H
DB 0CCH
DB 0A0H
DB  50H ; P
DB  48H ; H
DB  44H ; D
DB  82H
DB  81H
DB    0
DB 0FFH
DB  3CH ; <
DB    4
DB    2
DB    1
DB    0
DB 0FFH
DB    0
DB  80H
DB  40H ; @
DB  20H
DB  78H ; X
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FFH
DB  1EH
DB  10H
DB  20H
DB  40H ; @
DB  80H
DB    1
DB    2
DB    4
DB  1EH
DB 0FFH
DB    0
DB  20H
DB  78H ; X
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FFH
DB  1EH
DB    2
DB    1
DB  80H
DB  40H ; @
DB 0F0H
DB 0FFH
DB    0
DB    1
DB    2
DB  0FH
DB 0FFH
DB    0
DB 0FFH
DB  70H ; P
DB  40H ; @
DB  80H
DB    0
DB 0FFH
DB  3CH ; <
DB  20H
DB  40H ; @
DB  80H
DB    0
DB    0
DB 0FFH
DB  3CH ; <
DB    8
DB    4
DB    2
DB    1
DB    1
DB    3
DB  0FH
DB  1FH
DB  7FH ; 
DB 0FFH
DB    0
DB    1
DB    3
DB    7
DB    3
DB  0FH
DB  1FH
DB  1FH
DB  19H
DB    8
DB  18H
DB  19H
DB  1FH
DB  0FH
DB    6
DB    6
DB    3
DB    2
DB    2
DB    5
DB    5
DB    7
DB    3
DB    1
DB 0FFH
DB  60H ; `
DB  60H ; `
DB  70H ; P
DB 0F0H
DB 0F8H
DB 0F8H
DB 0BFH
DB  1FH
DB  1BH
DB  0CH
DB  0EH
DB 0FFH
DB 0DBH
DB 0DBH
DB  6DH ; M
DB  6DH ; M
DB 0FFH
DB 0F8H
DB 0FFH
DB 0FEH
DB 0FEH
DB 0FDH
DB 0C5H
DB 0F9H
DB 0FDH
DB 0FDH
DB  7FH ; 
DB  3FH ; ?
DB  1DH
DB  1CH
DB  1CH
DB  3FH ; ?
DB 0FFH
DB 0FCH
DB 0F0H
DB  69H ; I
DB  19H
DB  1BH
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB 0FCH
DB 0E0H
DB    0
DB    0
DB 0FFH
DB 0F8H
DB  87H
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB  1FH
DB 0FFH
DB  3FH ; ?
DB  9EH
DB 0BCH
DB  80H
DB    0
DB  80H
DB 0C0H
DB 0E0H
DB 0E0H
DB 0F0H
DB 0F0H
DB  70H ; P
DB 0F0H
DB 0F8H
DB 0F0H
DB 0E0H
DB 0E0H
DB 0C0H
DB 0C0H
DB  80H
DB    0
DB  8FH
DB  77H ; W
DB  8FH
DB 0FFH
DB 0DFH
DB  9FH
DB 0DFH
DB  8FH
DB 0FFH
DB  8CH
DB  52H ; R
DB  8CH
DB    0
DB  79H ; Y
DB  0AH
DB  12H
DB  32H ; 2
DB  0AH
DB  4AH ; J
DB  31H ; 1
DB    0
DB  7FH ; 
DB  3FH ; ?
DB  1FH
DB  0FH
DB    7
DB    3
DB    1
DB    0
DB 0FFH
DB  80H
DB 0C0H
DB 0E0H
DB 0F0H
DB 0F8H
DB 0FCH
DB 0FEH
DB 0FFH
DB    0
DB    1
DB    3
DB    7
DB  0FH
DB  1FH
DB  3FH ; ?
DB  7FH ; 
DB 0FFH
DB 0FEH
DB 0FCH
DB 0F8H
DB 0F0H
DB 0E0H
DB 0C0H
DB  80H
DB  88H
DB    2
DB  86H
DB    2
DB  86H
DB    1
DB  8EH
DB    6
DB  83H
DB  18H
DB  86H
DB    2
DB  86H
DB    2
DB  83H
DB  10H
DB  86H
DB    7
DB  88H
DB  88H
DB  0CH
DB  84H
DB    3
DB  84H
DB    2
DB  83H
DB  0FH
DB  83H
DB    4
DB  83H
DB  83H
DB    2
DB  83H
DB    3
DB  88H
DB    4
DB  89H
DB  43H ; C
DB  83H
DB    5
DB  83H
DB    1
DB  84H
DB    5
DB  87H
DB    1
DB  85H
DB  0BH
DB  83H
DB    3
DB  87H
DB    1
DB  89H
DB    8
DB  84H
DB    4
DB  88H
DB    4
DB  83H
DB  12H
DB  83H
DB  86H
DB    1
DB  83H
DB  84H
DB    5
DB  83H
DB    3
DB  83H
DB    8
DB  83H
DB    1
DB  8BH
DB  10H
DB  84H
DB    1
DB  84H
DB  15H
DB  83H
DB    9
DB  8AH
DB    5
DB  84H
DB  84H
DB    8
DB  84H
DB  84H
DB    5
DB  87H
DB    1
DB  85H
DB    4
DB  84H
DB    3
DB  85H
DB  12H
DB  88H
DB  18H
DB    0
DB  1EH
DB  1EH
DB 0F1H
DB 0A1H
DB 0F1H
DB 0AFH
DB 0AFH
DB 0A4H
DB  41H ; A
DB  4AH ; J
DB  41H ; A
DB  41H ; A
DB 0F1H
DB  41H ; A
DB 0F1H
DB 0F1H
DB  41H ; A
DB 0F1H
DB  15H
DB 0F1H
DB 0F5H
DB 0F5H
DB 0F1H
DB 0F5H
DB 0F1H
DB 0F5H
DB 0F1H
DB 0F5H
DB 0F1H
DB  9FH
DB  1FH
DB  81H
DB 0FFH
DB  89H
DB  85H
DB  83H
DB  88H
DB    2
DB  87H
DB  8FH
DB  84H
DB    2
DB  87H
DB    3
DB  86H
DB 0DAH
DB 0F0H
DB 0A8H
DB    3
DB  85H
DB  9FH
DB    1
DB  9CH
DB  84H
DB 0B8H
DB  90H
DB  90H
DB 0A8H
DB    0



SUB_9829:
XOR     A
LD      ($7270), A
RET
; END OF FUNCTION SUB_9829




SUB_982E:

; FUNCTION CHUNK AT 9903 SIZE 00000014 BYTES

LD      A, ($718F)
BIT     0, A
RET     Z
LD      A, 3
LD      ($7271), A

LOC_9839:
LD      A, ($718F)
BIT     2, A
JR      Z, LOC_989A
JR      LOC_9861

LOC_9842:
LD      A, ($7271)
INC     A
CP      18H
LD      ($7271), A
JR      NZ, LOC_9839
LD      A, ($7270)
ADD     A, 4
CP      20H ; ' '
LD      ($7270), A
RET     NZ
CALL    SUB_ACD8
LD      HL, 718FH
SET     1, (HL)
RET

LOC_9861:
CALL    SUB_98C0
INC     DE
INC     DE
INC     DE
INC     DE
CALL    GET_VRAM
CALL    SUB_98D4
LD      A, ($7270)
LD      E, A
LD      D, 0
ADD     HL, DE
EX      DE, HL
LD      HL, 7049H

LOC_9879:
LD      IY, 4
LD      A, 2
CALL    SUB_98E2
CALL    GET_VRAM
CALL    SUB_98F8
LD      A, ($7271)
SLA     A
SLA     A
SLA     A
LD      ($72C6), A
XOR     A
LD      ($72C6+1), A
JR      LOC_9903

LOC_989A:
CALL    SUB_98C0
INC     HL
INC     HL
INC     HL
INC     HL
DEC     IY
DEC     IY
DEC     IY
DEC     IY
CALL    GET_VRAM
CALL    SUB_98D4
LD      A, ($7270)
SUB     1CH
NEG
LD      E, A
LD      D, 0
ADD     HL, DE
EX      DE, HL
LD      HL, 702DH
JR      LOC_9879
; END OF FUNCTION SUB_982E




SUB_98C0:
CALL    SUB_98D4
EX      DE, HL
LD      IY, 20H ; ' '
LD      HL, 120H
LD      ($702B), HL
LD      HL, 702DH
LD      A, 2
RET
; END OF FUNCTION SUB_98C0




SUB_98D4:
LD      A, ($7271)
LD      BC, 20H ; ' '
LD      HL, 0

LOC_98DD:
ADD     HL, BC
DEC     A
JR      NZ, LOC_98DD
RET
; END OF FUNCTION SUB_98D4




SUB_98E2:
PUSH    HL
PUSH    IY
LD      A, 2
LD      HL, 1B00H
CALL    INIT_TABLE
LD      B, 2
LD      C, 6
CALL    WRITE_REGISTER
POP     IY
POP     HL
RET
; END OF FUNCTION SUB_98E2




SUB_98F8:
PUSH    HL
LD      A, 2
LD      HL, 1800H
CALL    INIT_TABLE
POP     HL
RET
; END OF FUNCTION SUB_98F8

; START OF FUNCTION CHUNK FOR SUB_982E

LOC_9903:
XOR     A
LD      ($72C3), A
LD      HL, 0
LD      ($72C4), HL
LD      IX, UNK_AADF
CALL    PUTOBJ
JP      LOC_9842
; END OF FUNCTION CHUNK FOR SUB_982E



SUB_9917:
CALL    SUB_AA19
CP      1
JR      NZ, LOC_9921
JP      SUB_AA61

LOC_9921:
CALL    SUB_9FEF
CP      2
JR      NZ, LOC_992E
LD      A, 3
LD      ($718C), A
RET

LOC_992E:
LD      IY, 7288H
PUSH    IY
CALL    SUB_9D79
CALL    SUB_994C
POP     IY
BIT     6, (IY+0)
RET     Z
RES     6, (IY+0)
LD      IX, UNK_A085
JP      PUTOBJ
; END OF FUNCTION SUB_9917




SUB_994C:

; FUNCTION CHUNK AT 9D22 SIZE 00000007 BYTES
; FUNCTION CHUNK AT 9D61 SIZE 00000018 BYTES
; FUNCTION CHUNK AT 9D84 SIZE 000000A4 BYTES
; FUNCTION CHUNK AT 9E5E SIZE 00000072 BYTES
; FUNCTION CHUNK AT 9EF4 SIZE 00000037 BYTES
; FUNCTION CHUNK AT 9F42 SIZE 00000037 BYTES

CALL    SUB_9F9C
LD      A, ($7286)
CP      1
JR      NZ, LOC_9959
JP      LOC_9D22

LOC_9959:
BIT     7, (IY+0)
JR      NZ, LOC_9982
CALL    SUB_9F79
LD      A, ($7283)
BIT     0, A
JR      Z, LOC_9974
LD      A, ($7272)
CP      0CH
JP      C, LOC_9DD7
JP      LOC_9F42

LOC_9974:
LD      B, A
AND     0AH
JR      Z, LOC_997C
JP      LOC_9E8A

LOC_997C:
BIT     2, B
RET     Z
JP      LOC_9EF4

LOC_9982:
CALL    SUB_9F79
BIT     1, (IY+8)
JP      Z, LOC_9A55
LD      A, ($718F)
BIT     0, A
JR      Z, LOC_99DF
LD      HL, 7284H
INC     (HL)
LD      A, ($7285)
OR      A
JR      NZ, LOC_99B0
LD      (HL), A
LD      A, 1
LD      ($7285), A
SET     6, (IY+0)
LD      (IX+1), 7FH
LD      (IX+3), 0C1H
RET

LOC_99B0:
LD      A, ($7284)
CP      7
RET     NZ
CALL    SUB_9D1C
LD      A, 1
LD      ($7273), A
LD      ($7275), A
BIT     2, (IY+7)
JR      Z, LOC_99CB
LD      A, 6
JR      LOC_99CD

LOC_99CB:
LD      A, 0F5H

LOC_99CD:
LD      (IX+1), A
CALL    SUB_A210
LD      (IX+3), A
XOR     A
LD      ($7284), A
SET     6, (IY+0)
RET

LOC_99DF:
XOR     A
LD      ($7285), A
BIT     1, (IY+8)
JR      Z, LOC_9A55
CALL    SUB_9F2B
LD      A, C
CP      1
JR      NZ, LOC_9A34
LD      A, ($7273)
OR      A
JR      NZ, LOC_9A23
LD      A, 2
LD      ($7273), A
LD      A, (IY+0CH)
ADD     A, (IX+1)
LD      (IX+1), A
SET     6, (IY+0)
CALL    SUB_A20A
LD      (IX+3), A
LD      A, (IX+1)
CALL    SUB_A218
AND     1
JR      Z, LOC_9A23
RES     6, (IY+0)
LD      A, 1
LD      ($7286), A
RET

LOC_9A23:
LD      A, ($7275)
OR      A
RET     NZ
LD      A, 3
LD      ($7275), A
SET     6, (IY+0)
JP      LOC_9E5E

LOC_9A34:
LD      A, ($7283)
OR      A
JR      NZ, LOC_9A45
LD      ($7272), A
LD      A, 0FFH
LD      ($71BC), A
JP      SUB_9E3B

LOC_9A45:
BIT     0, A
JP      NZ, LOC_9DD7
BIT     2, A
JP      NZ, LOC_9EF4
AND     0AH
JP      NZ, LOC_9E8A
RET

LOC_9A55:
BIT     3, (IY+8)
JP      Z, LOC_9AEB
BIT     4, (IY+0)
JR      NZ, LOC_9A6C
LD      A, ($7283)
OR      A
JR      NZ, LOC_9A6C
SET     4, (IY+0)

LOC_9A6C:
LD      A, ($7280)
CP      11H
JR      NZ, LOC_9A83
SET     5, (IY+0)
LD      A, 3CH ; '<'
LD      ($7276), A
XOR     A
LD      ($7280), A
JP      LOC_9D61

LOC_9A83:
BIT     5, (IY+0)
JR      Z, LOC_9AB8
LD      HL, 7276H
DEC     (HL)
BIT     4, (IY+0FH)
JR      Z, LOC_9A96
JP      LOC_9D84

LOC_9A96:
LD      A, ($7276)
OR      A
JP      Z, SUB_9E3B
BIT     4, (IY+0)
RET     Z
LD      A, ($7283)
LD      B, A
OR      A
RET     Z
BIT     0, B
JP      Z, LOC_9E75
LD      A, ($7276)
CP      30H ; '0'
JP      NC, LOC_9D84
JP      LOC_9DD7

LOC_9AB8:
LD      A, ($7273)
OR      A
RET     NZ
LD      HL, ($7279)
CALL    SUB_9E51
LD      (IY+0DH), A
ADD     A, (IX+3)
LD      (IX+3), A
LD      A, 3
LD      ($7273), A
SET     6, (IY+0)
LD      A, ($7272)
CP      24H ; '$'
RET     C
BIT     4, (IY+0)
RET     Z
LD      A, ($7283)
AND     1
RET     Z
SET     4, (IY+0FH)
RET

LOC_9AEB:
LD      A, (IY+8)
AND     38H ; '8'
JP      Z, LOC_9CF9
BIT     4, (IY+0)
JR      NZ, LOC_9B05
LD      A, ($7283)
OR      A
JR      NZ, LOC_9B1A
SET     4, (IY+0)
JR      LOC_9B1A

LOC_9B05:
LD      A, ($727B)
OR      A
JR      NZ, LOC_9B1A
LD      A, ($7283)
OR      A
JR      Z, LOC_9B1A
LD      ($727B), A
LD      A, ($7272)
LD      ($727C), A

LOC_9B1A:
LD      A, ($718F)
BIT     0, A
JR      NZ, LOC_9B27
XOR     A
LD      ($7285), A
JR      LOC_9BA4

LOC_9B27:
LD      HL, 7284H
INC     (HL)
LD      A, ($7285)
BIT     0, A
JR      NZ, LOC_9B4C
XOR     A
LD      ($7284), A
LD      HL, 7285H
SET     0, (HL)
LD      (IX+1), 7FH
LD      (IX+3), 0C1H
SET     6, (IY+0)
XOR     A
LD      (IY+0FH), A
RET

LOC_9B4C:
LD      A, ($7284)
CP      5
JR      NZ, LOC_9B9E
LD      A, 1
LD      ($7273), A
CALL    SUB_9D1C
BIT     2, (IY+7)
JR      Z, LOC_9B69
LD      (IX+1), 8
LD      A, 1CH
JR      LOC_9B6F

LOC_9B69:
LD      (IX+1), 0D6H
LD      A, 0D6H

LOC_9B6F:
CALL    SUB_A210
CP      40H ; '@'
JR      C, LOC_9B7E
SUB     30H ; '0'
CP      20H ; ' '
JR      C, LOC_9B7E
JR      LOC_9B80

LOC_9B7E:
LD      A, 20H ; ' '

LOC_9B80:
LD      (IX+3), A
LD      HL, 7285H
SET     1, (HL)
SET     6, (IY+0)
BIT     4, (IY+8)
JR      Z, LOC_9B98
LD      A, 8
LD      ($7280), A
RET

LOC_9B98:
LD      A, 0EH
LD      ($7280), A
RET

LOC_9B9E:
LD      A, ($7285)
BIT     1, A
RET     Z

LOC_9BA4:
BIT     5, (IY+0)
JP      NZ, LOC_9CA7
LD      A, ($727B)
OR      A
JR      Z, LOC_9BDB
LD      A, ($727C)
LD      B, A
LD      A, ($7272)
SUB     B
CP      3
JR      NC, LOC_9BD0
LD      A, ($727B)
AND     1
JR      Z, LOC_9BDB
BIT     2, (IY+0FH)
JR      NZ, LOC_9BDB
SET     3, (IY+0FH)
JR      LOC_9BDB

LOC_9BD0:
LD      A, ($7283)
AND     1
JR      Z, LOC_9BDB
SET     2, (IY+0FH)

LOC_9BDB:
LD      A, ($7273)
OR      A
RET     NZ
LD      A, ($7277)
LD      ($7273), A
LD      A, ($7280)
BIT     4, (IY+8)
JR      Z, LOC_9BF7
CP      11H
JR      NZ, LOC_9BF7
LD      (IY+0CH), 0

LOC_9BF7:
LD      B, A
LD      A, ($7278)
CP      B
JR      NC, LOC_9C03
LD      A, B
DEC     A
LD      ($7280), A

LOC_9C03:
LD      HL, ($7279)
CALL    SUB_9E51
LD      ($727D), A
ADD     A, (IX+3)
LD      C, A
CP      0C0H
JR      NC, LOC_9C37
CALL    SUB_A20A
CP      C
JR      C, LOC_9C37
JR      Z, LOC_9C37
LD      A, ($727D)
LD      (IY+0DH), A
CALL    SUB_9EE1
SET     6, (IY+0)
CALL    SUB_A218
AND     0C0H
RET     Z
PUSH    IX
CALL    SUB_A59C
POP     IX
RET

LOC_9C37:
LD      (IY+9), 1
LD      (IX+3), A
LD      A, (IY+0CH)
ADD     A, (IX+1)
LD      (IX+1), A
CALL    SUB_A218
LD      B, A
AND     1
JR      NZ, LOC_9C61
LD      A, B
AND     0C0H
JR      Z, LOC_9C6A
CP      0C0H
JR      Z, LOC_9C6A
PUSH    IX
CALL    SUB_A59C
POP     IX
JR      LOC_9C6A

LOC_9C61:
LD      A, 1
LD      ($7286), A
XOR     A
LD      ($7280), A

LOC_9C6A:
BIT     2, (IY+7)
JR      Z, LOC_9C7E
LD      A, (IX+1)
CP      0F7H
JR      C, LOC_9C8F
JR      NZ, LOC_9C8A
DEC     (IX+1)
JR      LOC_9C8F

LOC_9C7E:
LD      A, (IX+1)
CP      5
JR      NC, LOC_9C8F
JR      Z, LOC_9C8A
INC     (IX+1)

LOC_9C8A:
LD      (IY+0), 0C0H
RET

LOC_9C8F:
LD      (IY+0), 0E0H
XOR     A
LD      (IY+0CH), 0
LD      (IY+0DH), 0
LD      ($7272), A
LD      A, 4BH ; 'K'
LD      ($7276), A
JP      LOC_9D61

LOC_9CA7:
BIT     4, (IY+0)
JR      Z, LOC_9CDC
LD      HL, 7276H
DEC     (HL)
LD      A, ($7272)
CP      0CH
JR      NC, LOC_9CC6
LD      A, ($7283)
LD      B, A
AND     1
JP      NZ, LOC_9D84
LD      A, B
OR      A
JP      NZ, LOC_9E75

LOC_9CC6:
LD      A, ($7276)
OR      A
JP      Z, SUB_9E3B
LD      A, ($7283)
LD      B, A
AND     1
JP      NZ, LOC_9DD7
LD      A, B
OR      A
JP      NZ, LOC_9E75
RET

LOC_9CDC:
LD      A, ($7283)
OR      A
JR      Z, LOC_9CE9
AND     1
JR      NZ, LOC_9CE9
JP      LOC_9E75

LOC_9CE9:
LD      A, 0BH
LD      ($7272), A
LD      A, 1
LD      ($7276), A
LD      (IY+0FH), 0
RET
DB 0C9H

LOC_9CF9:
LD      A, (IY+8)
LD      B, A
AND     40H ; '@'
RET     Z
LD      A, ($7283)
AND     1
JP      NZ, LOC_9F42
LD      A, ($7283)
AND     4
RET     NZ
LD      (IY+0), 0
LD      A, (IX+3)
ADD     A, 0F0H
LD      (IX+3), A
JR      LOC_9D61
; END OF FUNCTION SUB_994C




SUB_9D1C:
LD      HL, 718FH
SET     4, (HL)
RET
; END OF FUNCTION SUB_9D1C

; START OF FUNCTION CHUNK FOR SUB_994C

LOC_9D22:
XOR     A
LD      ($7286), A
JP      SUB_AA61
; END OF FUNCTION CHUNK FOR SUB_994C
DB 0CDH
DB  52H ; R
DB 0A2H
DB  3AH ; :
DB  99H
DB  72H ; R
DB 0C6H
DB 0D8H
DB  32H ; 2
DB  99H
DB  72H ; R
DB 0CDH
DB  10H
DB 0A2H
DB 0C6H
DB  10H
DB  32H ; 2
DB  9BH
DB  72H ; R
DB  3EH ; >
DB  0EH
DB  32H ; 2
DB  98H
DB  72H ; R
DB 0DDH
DB  21H ; !
DB  85H
DB 0A0H
DB 0CDH
DB 0FAH
DB  1FH
DB 0CDH
DB  2FH ; /
DB 0A2H
DB  3EH ; >
DB  7FH ; 
DB  32H ; 2
DB  99H
DB  72H ; R
DB  3EH ; >
DB 0C1H
DB  32H ; 2
DB  9BH
DB  72H ; R
DB 0DDH
DB  21H ; !
DB  85H
DB 0A0H
DB  3EH ; >
DB    2
DB  32H ; 2
DB  8CH
DB  71H ; Q
DB 0C3H
DB 0FAH
DB  1FH
; START OF FUNCTION CHUNK FOR SUB_994C

LOC_9D61:
SET     6, (IY+0)
BIT     2, (IY+7)
JR      Z, LOC_9D72
LD      (IY+6), 0
JP      LOC_9E5E

LOC_9D72:
LD      (IY+6), 7
JP      LOC_9E5E
; END OF FUNCTION CHUNK FOR SUB_994C



SUB_9D79:
LD      HL, 7272H
INC     (HL)
INC     HL
DEC     (HL)
INC     HL
DEC     (HL)
INC     HL
DEC     (HL)
RET
; END OF FUNCTION SUB_9D79

; START OF FUNCTION CHUNK FOR SUB_994C

LOC_9D84:
CALL    SUB_9E28
LD      (IY+0), 0C0H
LD      (IY+8), 20H ; ' '
XOR     A
LD      (IY+0FH), A
LD      ($727B), A
LD      ($7272), A
LD      ($7280), A
LD      A, 1FH
LD      ($7278), A
LD      A, 2
LD      ($7277), A
LD      ($7273), A
LD      HL, UNK_9FCE
LD      ($7279), HL
CALL    SUB_9E51
LD      (IY+0DH), A
ADD     A, (IX+3)
LD      (IX+3), A
BIT     1, (IY+7)
JR      Z, LOC_9DCC
LD      (IY+0CH), 0FEH
LD      (IY+6), 0BH
JP      LOC_9E5E

LOC_9DCC:
LD      (IY+0CH), 2
LD      (IY+6), 0AH
JP      LOC_9E5E

LOC_9DD7:
CALL    SUB_9E28
LD      (IY+0), 0C0H
LD      (IY+8), 10H
XOR     A
LD      (IY+0FH), A
LD      ($727B), A
LD      ($7272), A
LD      ($7280), A
LD      A, 11H
LD      ($7278), A
LD      A, 2
LD      ($7277), A
LD      ($7273), A
LD      HL, 9FBCH
LD      ($7279), HL
CALL    SUB_9E51
LD      (IY+0DH), A
ADD     A, (IX+3)
LD      (IX+3), A
BIT     1, (IY+7)
JR      Z, LOC_9E1E
LD      (IY+0CH), 0FEH
LD      (IY+6), 0BH
JR      LOC_9E5E

LOC_9E1E:
LD      (IY+0CH), 2
LD      (IY+6), 0AH
JR      LOC_9E5E
; END OF FUNCTION CHUNK FOR SUB_994C



SUB_9E28:
PUSH    IX
PUSH    IY
LD      B, 0AH
CALL    PLAY_IT
LD      B, 0BH
CALL    PLAY_IT
POP     IY
POP     IX
RET
; END OF FUNCTION SUB_9E28




SUB_9E3B:
XOR     A
LD      (IY+0), A
LD      (IY+0CH), A
LD      (IY+0DH), A
LD      (IY+8), A
LD      A, (IY+9)
AND     7
LD      (IY+9), A
RET
; END OF FUNCTION SUB_9E3B




SUB_9E51:
LD      A, ($7280)
LD      C, A
INC     A
LD      ($7280), A
LD      B, 0
ADD     HL, BC
LD      A, (HL)
RET
; END OF FUNCTION SUB_9E51

; START OF FUNCTION CHUNK FOR SUB_994C

LOC_9E5E:
LD      C, (IY+6)
LD      B, 0
LD      L, (IY+4)
LD      H, (IY+5)
ADD     HL, BC
ADD     HL, BC
LD      A, (HL)
LD      (IX+0), A
INC     HL
LD      A, (HL)
LD      (IY+6), A
RET

LOC_9E75:
LD      A, ($7283)
SRL     A
JP      Z, LOC_9F42
SRL     A
JR      Z, LOC_9E8A
SRL     A
JR      Z, LOC_9EF4
SRL     A
JR      Z, LOC_9E8A
RET

LOC_9E8A:
PUSH    IX
PUSH    IY
LD      B, 6
CALL    PLAY_IT
POP     IY
POP     IX
LD      (IY+0), 80H
LD      (IY+8), 2
XOR     A
LD      (IY+0FH), A
LD      A, 1
LD      ($7273), A
LD      A, 3
LD      ($7275), A
LD      A, ($7283)
BIT     3, A
JR      Z, LOC_9EC2
LD      (IY+7), 2
LD      (IY+0CH), 0FEH
LD      (IY+6), 7
JR      LOC_9E5E

LOC_9EC2:
LD      (IY+7), 4
LD      (IY+0CH), 2
LD      (IY+6), 0
JR      LOC_9E5E
; END OF FUNCTION CHUNK FOR SUB_994C
DB 0C9H
DB  3AH ; :
DB  82H
DB  72H ; R
DB  4FH ; O
DB  3CH ; <
DB  32H ; 2
DB  82H
DB  72H ; R
DB    6
DB    0
DB    9
DB  7EH ; ~
DB  32H ; 2
DB  73H ; S
DB  72H ; R
DB 0C9H



SUB_9EE1:
LD      A, (IY+0CH)
ADD     A, (IX+1)
LD      (IX+1), A
LD      A, (IY+0DH)
ADD     A, (IX+3)
LD      (IX+3), A
RET
; END OF FUNCTION SUB_9EE1

; START OF FUNCTION CHUNK FOR SUB_994C

LOC_9EF4:
LD      A, ($71F3)
CP      7
JR      NZ, LOC_9F06
LD      A, ($7299)
CALL    SUB_A218
AND     0FH
CP      6
RET     Z

LOC_9F06:
LD      A, (IX+3)
ADD     A, 10H
LD      (IX+3), A
LD      A, 5AH ; 'Z'
LD      ($7274), A
LD      (IY+8), 40H ; '@'
LD      (IY+0), 0C0H
BIT     2, (IY+7)
JR      Z, LOC_9F26
LD      (IX+0), 0CH
RET

LOC_9F26:
LD      (IX+0), 0DH
RET
; END OF FUNCTION CHUNK FOR SUB_994C



SUB_9F2B:
LD      A, ($7283)
LD      C, 0
BIT     1, (IY+7)
JR      Z, LOC_9F3C
BIT     3, A
RET     Z
LD      C, 1
RET

LOC_9F3C:
BIT     1, A
RET     Z
LD      C, 1
RET
; END OF FUNCTION SUB_9F2B

; START OF FUNCTION CHUNK FOR SUB_994C

LOC_9F42:
CALL    SUB_9E28
XOR     A
LD      (IY+0FH), A
LD      ($7272), A
LD      ($7280), A
LD      (IY+0CH), A
LD      (IY+0), 0C0H
LD      (IY+8), 8
LD      A, 3
LD      ($7273), A
LD      HL, UNK_9FAB
LD      ($7279), HL
BIT     2, (IY+7)
JR      Z, LOC_9F72
LD      (IY+6), 0AH
JP      LOC_9E5E

LOC_9F72:
LD      (IY+6), 0BH
JP      LOC_9E5E
; END OF FUNCTION CHUNK FOR SUB_994C



SUB_9F79:
LD      HL, 0
LD      A, ($71F0)
OR      A
JR      Z, LOC_9F84
LD      H, 1

LOC_9F84:
CALL    DECODER
LD      A, L
LD      ($7283), A
RET
; END OF FUNCTION SUB_9F79




SUB_9F8C:
CALL    READ_REGISTER

LOC_9F8F:
CALL    READ_REGISTER
LD      ($7281), A
BIT     7, A
JR      NZ, LOCRET_9F9B
JR      LOC_9F8F

LOCRET_9F9B:
RET
; END OF FUNCTION SUB_9F8C




SUB_9F9C:
LD      L, (IY+1)
LD      H, (IY+2)
INC     HL
INC     HL
LD      E, (HL)
INC     HL
LD      D, (HL)
PUSH    DE
POP     IX
RET
; END OF FUNCTION SUB_9F9C

UNK_9FAB:DB 0F9H
DB 0FAH
DB 0FBH
DB 0FCH
DB 0FCH
DB 0FDH
DB 0FEH
DB 0FFH
DB    0
DB    1
DB    2
DB    3
DB    4
DB    4
DB    5
DB    6
DB    7
DB 0F5H
DB 0F9H
DB 0FBH
DB 0FDH
DB 0FDH
DB 0FEH
DB 0FEH
DB 0FFH
DB    0
DB    1
DB    2
DB    3
DB    3
DB    3
DB    6
DB  0AH
DB  0AH
DB  0AH
UNK_9FCE:DB 0FBH
DB 0FBH
DB 0FBH
DB 0FBH
DB 0FCH
DB 0FCH
DB 0FCH
DB 0FDH
DB 0FDH
DB 0FDH
DB 0FEH
DB 0FEH
DB 0FFH
DB 0FFH
DB    1
DB    1
DB    2
DB    2
DB    3
DB    3
DB    3
DB    4
DB    4
DB    4
DB    5
DB    5
DB    5
DB    5
DB    6
DB    6
DB    6
DB    6
DB    6



SUB_9FEF:
LD      B, 0
LD      A, ($71F3)
CP      7
JR      Z, LOC_9FFA
JR      LOC_A00A

LOC_9FFA:
LD      A, ($7299)
CP      0D8H
JR      C, LOC_A00A
LD      A, ($7299)
CP      0F0H
JR      NC, LOC_A00A
LD      B, 2

LOC_A00A:
LD      A, B
RET
; END OF FUNCTION SUB_9FEF




SUB_A00C:
LD      HL, 7288H
LD      DE, 7289H
LD      BC, 14H
LD      (HL), 0
LDIR
LD      IY, 7288H
LD      IX, 7298H
LD      HL, UNK_A085
LD      (IY+1), L
LD      (IY+2), H
LD      HL, UNK_A067
LD      (IY+4), L
LD      (IY+5), H
LD      (IY+7), 4
LD      L, (IY+1)
LD      H, (IY+2)
OR      A
CALL    ACTIVATE
LD      A, 10H

LOC_A043:
LD      (IX+1), A
CALL    SUB_A210
LD      (IX+3), A
CALL    SUB_A218
AND     1
JR      Z, LOC_A05A
LD      A, 8
ADD     A, (IX+1)
JR      LOC_A043

LOC_A05A:
INC     (IX+1)
CALL    SUB_A68A
LD      IX, UNK_A085
JP      PUTOBJ
; END OF FUNCTION SUB_A00C

UNK_A067:DB    0
DB    1
DB    1
DB    2
DB    2
DB    3
DB    3
DB    4
DB    4
DB    0
DB    5
DB    6
DB    6
DB    7
DB    7
DB    8
DB    8
DB    9
DB    9
DB    5
DB  0AH
DB  0AH
DB  0BH
DB  0BH
DB  0CH
DB  0CH
DB  0DH
DB  0DH
DB  0EH
DB  0EH
UNK_A085:DB  91H
DB 0A0H
DB  98H
DB  72H ; R
DB  42H ; B
DB 0A1H
DB  70H ; P
DB 0A1H
DB  9EH
DB 0A1H
DB 0CCH
DB 0A1H
DB  44H ; D
DB 0CEH
DB 0A0H
DB  0AH
DB 0A1H
DB 0D2H
DB 0A0H
DB  12H
DB 0A1H
DB 0D6H
DB 0A0H
DB  0AH
DB 0A1H
DB 0DAH
DB 0A0H
DB  1AH
DB 0A1H
DB 0DEH
DB 0A0H
DB  1AH
DB 0A1H
DB 0E2H
DB 0A0H
DB  0AH
DB 0A1H
DB 0E6H
DB 0A0H
DB  12H
DB 0A1H
DB 0EAH
DB 0A0H
DB  0AH
DB 0A1H
DB 0EEH
DB 0A0H
DB  1AH
DB 0A1H
DB 0F2H
DB 0A0H
DB  1AH
DB 0A1H
DB 0F6H
DB 0A0H
DB  22H ; "
DB 0A1H
DB 0FAH
DB 0A0H
DB  22H ; "
DB 0A1H
DB 0FEH
DB 0A0H
DB  2AH ; *
DB 0A1H
DB    2
DB 0A1H
DB  32H ; 2
DB 0A1H
DB    6
DB 0A1H
DB  3AH ; :
DB 0A1H
DB    0
DB    0
DB    0
DB    0
DB    1
DB    1
DB    1
DB    1
DB    2
DB    2
DB    2
DB    2
DB    3
DB    3
DB    3
DB    3
DB    4
DB    4
DB    4
DB    4
DB    5
DB    5
DB    5
DB    5
DB    6
DB    6
DB    6
DB    6
DB    7
DB    7
DB    7
DB    7
DB    8
DB    8
DB    8
DB    8
DB    9
DB    9
DB    9
DB    9
DB  0AH
DB  0AH
DB  0AH
DB  0AH
DB  0BH
DB  0BH
DB  0BH
DB  0BH
DB  0CH
DB  0CH
DB  0CH
DB  0CH
DB  0DH
DB  0DH
DB  0DH
DB  0DH
DB  0EH
DB  0EH
DB  0EH
DB  0EH
DB    0
DB    0
DB    0
DB    8
DB    0
DB  10H
DB    0
DB    8
DB    0
DB    0
DB    0
DB    9
DB    0
DB  10H
DB    0
DB    9
DB    0
DB    0
DB    0
DB    7
DB    0
DB  10H
DB    0
DB    7
DB    0
DB    0
DB    0
DB    8
DB    0
DB  10H
DB    0
DB    8
DB    0
DB    0
DB  10H
DB    0
DB    0
DB    0
DB  10H
DB    0
DB  10H
DB    0
DB    0
DB    0
DB  10H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    8
DB    0
DB  10H
DB    0
DB    8
DB    0
DB  47H ; G
DB 0A1H
DB  9DH
DB  72H ; R
DB    0
DB    3
DB    0
DB  19H
DB 0A7H
DB  9CH
DB  4EH ; N
DB 0A1H
DB  0FH
DB    0
DB  0FH
DB  10H
DB  0FH
DB    0
DB  0FH
DB  28H ; (
DB  0FH
DB  28H ; (
DB  0FH
DB  60H ; `
DB  0FH
DB  70H ; P
DB  0FH
DB  60H ; `
DB  0FH
DB  88H
DB  0FH
DB  88H
DB  0FH
DB  40H ; @
DB  0FH
DB 0A0H
DB  0FH
DB  50H ; P
DB  0FH
DB 0B0H
DB  0FH
DB  70H ; P
DB  0FH
DB  70H ; P
DB  0FH
DB  80H
DB  75H ; U
DB 0A1H
DB 0A3H
DB  72H ; R
DB    1
DB    3
DB    0
DB  19H
DB 0A7H
DB  9CH
DB  7CH ; |
DB 0A1H
DB    4
DB    4
DB    4
DB  14H
DB    4
DB  20H
DB    4
DB  2CH ; ,
DB    4
DB  38H ; 8
DB    4
DB  64H ; D
DB    4
DB  74H ; T
DB    4
DB  80H
DB    4
DB  8CH
DB    4
DB  98H
DB    4
DB  44H ; D
DB    4
DB 0A4H
DB  0FH
DB  54H ; T
DB  0FH
DB 0B4H
DB    4
DB  74H ; T
DB    4
DB  74H ; T
DB    4
DB  84H
DB 0A3H
DB 0A1H
DB 0A9H
DB  72H ; R
DB    2
DB    3
DB    0
DB  19H
DB 0A7H
DB  9CH
DB 0AAH
DB 0A1H
DB  0FH
DB    8
DB  0FH
DB  18H
DB  0FH
DB  24H ; $
DB  0FH
DB  30H ; 0
DB  0FH
DB  3CH ; <
DB  0FH
DB  68H ; H
DB  0FH
DB  78H ; X
DB  0FH
DB  84H
DB  0FH
DB  90H
DB  0FH
DB  9CH
DB  0FH
DB  48H ; H
DB  0FH
DB 0A8H
DB    4
DB  58H ; X
DB    4
DB 0B8H
DB  0FH
DB  78H ; X
DB    4
DB  78H ; X
DB    4
DB  88H
DB 0D1H
DB 0A1H
DB 0AFH
DB  72H ; R
DB  0FH
DB    3
DB    0
DB  19H
DB 0A7H
DB  9CH
DB 0D8H
DB 0A1H
DB    1
DB  0CH
DB    1
DB  1CH
DB    1
DB  0CH
DB    1
DB  34H ; 4
DB    1
DB  34H ; 4
DB    1
DB  6CH ; L
DB    1
DB  7CH ; |
DB    1
DB  6CH ; L
DB    1
DB  94H
DB    1
DB  94H
DB    1
DB  4CH ; L
DB    1
DB 0ACH
DB    4
DB  5CH ; \
DB    4
DB 0BCH
DB    4
DB  7CH ; |
DB    4
DB  7CH ; |
DB    4
DB  8CH
DB 0DDH
DB  21H ; !
DB  85H
DB 0A0H
DB 0AFH
DB  32H ; 2
DB  99H
DB  72H ; R
DB  3EH ; >
DB 0C1H
DB  32H ; 2
DB  9BH
DB  72H ; R
DB 0C3H
DB 0FAH
DB  1FH



SUB_A20A:
LD      A, ($7299)
CALL    SUB_A23D
; END OF FUNCTION SUB_A20A




SUB_A210:
CALL    SUB_A223
INC     HL
LD      A, (HL)
SUB     20H ; ' '
RET
; END OF FUNCTION SUB_A210




SUB_A218:
LD      A, ($7299)
CALL    SUB_A23D
CALL    SUB_A223
LD      A, (HL)
RET
; END OF FUNCTION SUB_A218




SUB_A223:
RRCA
RRCA
AND     3EH ; '>'
LD      E, A
LD      D, 0
LD      HL, 720EH
ADD     HL, DE
RET
; END OF FUNCTION SUB_A223

DB  1EH
DB    2
DB  21H ; !
DB 0FFH
DB 0FFH
DB  2BH ; +
DB  7DH ; }
DB 0B4H
DB  20H
DB 0FBH
DB  1DH
DB  20H
DB 0F5H
DB 0C9H



SUB_A23D:
PUSH    AF
LD      A, ($728F)
BIT     1, A
JR      NZ, LOC_A24B
POP     AF
ADD     A, 0BH
JR      C, LOC_A24F
RET

LOC_A24B:
POP     AF
ADD     A, 4
RET

LOC_A24F:
LD      A, 0FFH
RET
; END OF FUNCTION SUB_A23D




SUB_A252:
LD      DE, 0
LD      HL, 60H ; '`'
CALL    SUB_A27B
LD      HL, 80H
LD      DE, 60H ; '`'
CALL    SUB_A27B
LD      HL, 70H ; 'P'
LD      ($72BB), HL
LD      DE, 80H
CALL    SUB_A27B
LD      B, 4
LD      HL, UNK_A284
LD      ($72BD), HL
JP      LOC_A6B2
; END OF FUNCTION SUB_A252




SUB_A27B:
LD      A, 1
LD      BC, 10H
CALL    REFLECT_VERTICAL
RET
; END OF FUNCTION SUB_A27B

UNK_A284:DB    1
DB    3
DB    0
DB    2



SUB_A288:

; FUNCTION CHUNK AT A400 SIZE 0000002B BYTES

LD      HL, ($6C)
LD      DE, 0E0H
LD      IY, 0AH
LD      A, 3
CALL    PUT_VRAM
LD      HL, (702BH)
LD      A, 90H
LD      B, 10H

LOC_A29E:
LD      (HL), A
INC     HL
DJNZ    LOC_A29E
LD      B, 5
LD      DE, 0E0H

LOC_A2A7:
PUSH    BC
PUSH    DE
LD      HL, (702BH)
LD      IY, 2
LD      A, 4
CALL    PUT_VRAM
POP     DE
POP     BC
INC     DE
INC     DE
DJNZ    LOC_A2A7
LD      HL, UNK_A5F6
LD      DE, 0EAH
LD      B, 8

LOC_A2C3:
PUSH    BC
LD      C, (HL)
LD      B, 0
PUSH    HL
LD      HL, ($6A)
ADD     HL, BC
LD      IY, 1
LD      A, 3
PUSH    DE
CALL    PUT_VRAM
POP     DE
POP     HL
INC     HL
INC     DE
POP     BC
DJNZ    LOC_A2C3
LD      B, 9
LD      DE, 0EAH

LOC_A2E2:
PUSH    BC
LD      HL, (702BH)
LD      A, 4
LD      IY, 1
PUSH    DE
CALL    PUT_VRAM
POP     DE
INC     DE
POP     BC
DJNZ    LOC_A2E2
CALL    SUB_A539
CALL    SUB_A55F
CALL    SUB_A4D8
CALL    SUB_A57C
CALL    SUB_A515
LD      HL, UNK_A5FE
LD      DE, 72C4H
LD      BC, 4
LDIR
LD      HL, UNK_A602
LD      DE, 702BH
LD      BC, 8
LDIR
LD      IX, UNK_AADF
CALL    PUTOBJ
XOR     A
LD      ($72B7), A
LD      HL, UNK_A612
LD      DE, 72C4H
LD      BC, 4
LDIR
LD      HL, UNK_A60A
LD      DE, 702BH
LD      BC, 8
LDIR
LD      IX, UNK_AADF
CALL    PUTOBJ
LD      HL, UNK_A616
LD      DE, 72C4H
LD      BC, 4
LDIR
LD      B, 0E1H
LD      A, ($71F0)
OR      A
JR      Z, LOC_A356
INC     B

LOC_A356:
LD      HL, 702BH
LD      (HL), 1
INC     HL
LD      (HL), 1
INC     HL
LD      (HL), B
LD      IX, UNK_AADF
CALL    PUTOBJ
LD      DE, $E800
CALL    SUB_A3F0
LD      HL, 702BH
LD      (HL), 2
INC     HL
LD      (HL), 1
INC     HL
LD      (HL), 0E0H
INC     HL
LD      (HL), 0E0H
LD      IX, UNK_AADF
CALL    PUTOBJ
LD      IX, ($718D)
LD      A, (IX+0)
OR      (IX+1)
JP      NZ, LOC_A400
; END OF FUNCTION SUB_A288




SUB_A38F:

; FUNCTION CHUNK AT A400 SIZE 0000002B BYTES

LD      IX, ($718D)
LD      B, (IX+3)
LD      A, ($72B8)
CP      B
JP      NZ, SUB_A515
LD      L, (IX+0)
LD      H, (IX+1)
LD      DE, ($72B5)
LD      A, L
CP      E
JR      NZ, LOC_A400
LD      A, H
CP      D
JR      NZ, LOC_A400
LD      IX, ($718D)
LD      B, (IX+2)
LD      A, ($72B7)
CP      B
JR      NZ, LOC_A3BD
RET

LOC_A3BD:
LD      A, (IX+2)
LD      C, A
LD      ($72B7), A
LD      A, 0FFH
LD      B, 10H
LD      HL, 702BH
LD      (HL), 10H
INC     HL
LD      (HL), 1
INC     HL

LOC_A3D1:
LD      (HL), A
INC     HL
DJNZ    LOC_A3D1
XOR     A
CP      C
JR      Z, LOC_A3E3
LD      B, C
LD      HL, 702DH
LD      A, 0F8H

LOC_A3DF:
LD      (HL), A
INC     HL
DJNZ    LOC_A3DF

LOC_A3E3:
LD      DE, 8010H
CALL    SUB_A3F0
LD      IX, UNK_AADF
JP      PUTOBJ
; END OF FUNCTION SUB_A38F




SUB_A3F0:
LD      HL, 72C3H
LD      (HL), 0
INC     HL
LD      (HL), D
INC     HL
LD      (HL), 0
INC     HL
LD      (HL), E
INC     HL
LD      (HL), 0
RET
; END OF FUNCTION SUB_A3F0

; START OF FUNCTION CHUNK FOR SUB_A288
;   ADDITIONAL PARENT FUNCTION SUB_A38F

LOC_A400:
LD      IX, ($718D)
LD      H, (IX+1)
LD      L, (IX+0)
LD      ($72B5), HL
CALL    SUB_A441
LD      HL, 702BH
LD      (HL), 5
INC     HL
LD      (HL), 1
LD      HL, 72C4H
LD      (HL), 0C0H
INC     HL
INC     HL
LD      (HL), 0
CALL    SUB_A42B
LD      IX, UNK_AADF
JP      PUTOBJ
; END OF FUNCTION CHUNK FOR SUB_A288



SUB_A42B:
LD      A, 0E0H
LD      HL, 702DH
LD      B, 4

LOC_A432:
CPI
RET     NZ
PUSH    HL
POP     IX
DEC     IX
LD      (IX+0), 0FFH
DJNZ    LOC_A432
RET
; END OF FUNCTION SUB_A42B




SUB_A441:
PUSH    HL
POP     DE
LD      IX, 702DH
LD      (IX+0), 0E0H
LD      (IX+1), 0E0H
LD      (IX+2), 0E0H
LD      (IX+3), 0E0H
LD      (IX+4), 0E0H
LD      A, 0A7H
CP      H
RET     C
JR      NZ, LOC_A465
LD      A, 0FH
CP      L
RET     C

LOC_A465:
LD      BC, 2710H
OR      A
SBC     HL, BC
JR      NC, LOC_A48F
PUSH    DE
POP     HL
LD      BC, 3E8H
OR      A
SBC     HL, BC
JR      NC, LOC_A4A0
PUSH    DE
POP     HL
LD      BC, 64H ; 'D'
OR      A
SBC     HL, BC
JR      NC, LOC_A4B1
PUSH    DE
POP     HL
LD      BC, 0AH
OR      A
SBC     HL, BC
JR      NC, LOC_A4C2
PUSH    DE
POP     HL
JR      LOC_A4D0

LOC_A48F:
PUSH    DE
POP     HL
JR      LOC_A498

LOC_A493:
PUSH    HL
POP     DE
INC     (IX+0)

LOC_A498:
OR      A
SBC     HL, BC
JR      NC, LOC_A493
LD      BC, 3E8H

LOC_A4A0:
PUSH    DE
POP     HL
JR      LOC_A4A9

LOC_A4A4:
PUSH    HL
POP     DE
INC     (IX+1)

LOC_A4A9:
OR      A
SBC     HL, BC
JR      NC, LOC_A4A4
LD      BC, 64H ; 'D'

LOC_A4B1:
PUSH    DE
POP     HL
JR      LOC_A4BA

LOC_A4B5:
PUSH    HL
POP     DE
INC     (IX+2)

LOC_A4BA:
OR      A
SBC     HL, BC
JR      NC, LOC_A4B5
LD      BC, 0AH

LOC_A4C2:
PUSH    DE
POP     HL
JR      LOC_A4CB

LOC_A4C6:
PUSH    HL
POP     DE
INC     (IX+3)

LOC_A4CB:
OR      A
SBC     HL, BC
JR      NC, LOC_A4C6

LOC_A4D0:
LD      A, E
ADD     A, (IX+4)
LD      (IX+4), A
RET
; END OF FUNCTION SUB_A441




SUB_A4D8:
LD      HL, 72C3H
LD      (HL), 0
LD      HL, 702BH
LD      (HL), 20H ; ' '
INC     HL
LD      (HL), 1
INC     HL
LD      B, 20H ; ' '
LD      A, 0FFH

LOC_A4EA:
LD      (HL), A
INC     HL
DJNZ    LOC_A4EA
LD      DE, 0
CALL    SUB_A3F0
LD      IX, UNK_AADF
PUSH    IX
CALL    PUTOBJ
POP     IX
LD      DE, 8
CALL    SUB_A3F0
PUSH    IX
CALL    PUTOBJ
POP     IX
LD      DE, 10H
CALL    SUB_A3F0
JP      PUTOBJ
; END OF FUNCTION SUB_A4D8




SUB_A515:
LD      DE, 3008H
CALL    SUB_A3F0
LD      HL, 702BH
LD      (HL), 1
INC     HL
LD      (HL), 1
INC     HL
LD      IX, ($718D)
LD      B, 0E0H
LD      A, (IX+3)
LD      ($72B8), A
ADD     A, B
LD      (HL), A
LD      IX, UNK_AADF
JP      PUTOBJ
; END OF FUNCTION SUB_A515




SUB_A539:
LD      HL, (702BH)
XOR     A
LD      B, 8

LOC_A53F:
LD      (HL), A
INC     HL
DJNZ    LOC_A53F
LD      HL, (702BH)
LD      DE, 0FFH
LD      A, 3
LD      IY, 1
PUSH    HL
PUSH    DE
PUSH    IY
CALL    PUT_VRAM
POP     IY
POP     DE
POP     HL
LD      A, 4
JP      PUT_VRAM
; END OF FUNCTION SUB_A539




SUB_A55F:
LD      HL, UNK_A61A
LD      DE, 0F2H
LD      A, 3
PUSH    DE
LD      IY, 0BH
PUSH    IY
CALL    PUT_VRAM
POP     IY
POP     DE
LD      HL, UNK_A652
LD      A, 4
JP      PUT_VRAM
; END OF FUNCTION SUB_A55F




SUB_A57C:
LD      DE, 800H
CALL    SUB_A3F0
LD      HL, 702BH
LD      (HL), 7
INC     HL
LD      (HL), 3
INC     HL
LD      E, L
LD      D, H
LD      HL, UNK_A5E1
LD      BC, 15H
LDIR
LD      IX, UNK_AADF
JP      PUTOBJ
; END OF FUNCTION SUB_A57C




SUB_A59C:
LD      B, A
LD      A, ($728F)
BIT     1, A
JR      NZ, LOC_A5C7
LD      A, B
LD      IX, ($718D)
AND     0C0H
CP      0C0H
RET     Z
BIT     7, A
JR      NZ, LOC_A5B7
LD      DE, 3
JR      LOC_A5BA

LOC_A5B7:
LD      DE, 2

LOC_A5BA:
LD      H, (IX+1)
LD      L, (IX+0)
ADD     HL, DE
LD      (IX+1), H
LD      (IX+0), L

LOC_A5C7:
LD      A, ($7299)
CALL    SUB_A23D
SRL     A
SRL     A
SRL     A
SLA     A
LD      E, A
LD      D, 0
LD      HL, 720EH
ADD     HL, DE
LD      A, (HL)
OR      0C0H
LD      (HL), A
RET
; END OF FUNCTION SUB_A59C

UNK_A5E1:DB 0FFH
DB 0FFH
DB 0F2H
DB 0F3H
DB 0FFH
DB 0FFH
DB 0FFH
DB 0FFH
DB 0FFH
DB 0F4H
DB 0F5H
DB 0FFH
DB 0FFH
DB 0FFH
DB 0FFH
DB 0FFH
DB 0F6H
DB 0F7H
DB 0FFH
DB 0FFH
DB 0FFH
UNK_A5F6:DB  20H
DB  68H ; H
DB  88H
DB  30H ; 0
DB 0C0H
DB  78H ; X
DB  58H ; X
DB    0
UNK_A5FE:DB  48H ; H
DB    0
DB  10H
DB    0
UNK_A602:DB    6
DB    1
DB 0EAH
DB 0EBH
DB 0EAH
DB 0ECH
DB 0EDH
DB 0EEH
UNK_A60A:DB    6
DB    1
DB 0EFH
DB 0F0H
DB 0F1H
DB 0EEH
DB 0EAH
DB 0ECH
UNK_A612:DB  70H ; P
DB    0
DB    0
DB    0
UNK_A616:DB 0A8H
DB    0
DB    0
DB    0
UNK_A61A:DB    0
DB    0
DB    0
DB    0
DB    3
DB  0FH
DB  3FH ; ?
DB  7FH ; 
DB    0
DB    0
DB    0
DB    0
DB 0C0H
DB 0F0H
DB 0FCH
DB 0FEH
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FFH
DB 0FFH
DB 0FEH
DB 0F8H
DB  7FH ; 
DB 0FEH
DB 0BCH
DB  80H
DB  80H
DB 0F0H
DB 0F0H
DB 0D0H
DB 0B6H
DB 0FDH
DB  8CH
DB 0DCH
DB  77H ; W
DB    0
DB    0
DB    0
DB    0
DB 0FFH
DB 0FEH
DB  78H ; X
DB 0F0H
DB    0
DB    0
DB    0
DB    0
DB    3
DB    1
DB    0
DB    0
DB    1
DB    3
DB 0FFH
DB 0FFH
UNK_A652:DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F4H
DB 0F4H
DB  41H ; A
DB 0F1H
DB 0F1H
DB 0F1H
DB 0F1H
DB  41H ; A
DB 0F1H
DB 0F1H
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  41H ; A
DB  18H
DB  18H
DB  18H
DB  18H
DB  18H
DB  18H
DB  18H
DB  18H



SUB_A68A:
LD      A, 1
LD      DE, 0
LD      IY, 60H ; '`'
LD      HL, UNK_A719
CALL    PUT_VRAM
LD      A, 1
LD      DE, 0
LD      HL, 60H ; '`'
LD      ($72BB), HL
LD      BC, 60H ; '`'
CALL    REFLECT_VERTICAL
LD      HL, UNK_A709
LD      ($72BD), HL
LD      B, 18H

LOC_A6B2:
PUSH    BC
LD      HL, (702BH)
LD      ($72B9), HL
LD      IX, ($72BD)
LD      A, 1
LD      IY, 4
LD      DE, ($72BB)
PUSH    IX
CALL    GET_VRAM
POP     IX
LD      B, 4

LOC_A6D0:
PUSH    BC
LD      L, (IX+0)
LD      H, 0
LD      DE, ($72BB)
ADD     HL, DE
EX      DE, HL
LD      HL, ($72B9)
LD      IY, 1
LD      A, 1
PUSH    IX
CALL    PUT_VRAM
POP     IX
LD      BC, 8
LD      HL, ($72B9)
ADD     HL, BC
LD      ($72B9), HL
INC     IX
POP     BC
DJNZ    LOC_A6D0
LD      HL, ($72BB)
LD      BC, 4
ADD     HL, BC
LD      ($72BB), HL
POP     BC
DJNZ    LOC_A6B2
RET
; END OF FUNCTION SUB_A68A

UNK_A709:DB    2
DB    3
DB    0
DB    1
DB    0
DB  1CH
DB  80H
DB    0
DB 0BFH
DB  72H ; R
DB    0
DB  38H ; 8
DB    0
DB    8
DB  19H
DB 0A7H
UNK_A719:DB    0
DB    3
DB  0FH
DB  3FH ; ?
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FFH
DB 0FEH
DB 0FCH
DB  88H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0F0H
DB 0FCH
DB 0FEH
DB 0FEH
DB 0DCH
DB 0C0H
DB 0E0H
DB    0
DB  30H ; 0
DB  60H ; `
DB  40H ; @
DB    0
DB    0
DB    0
DB    0
DB    1
DB    3
DB  77H ; W
DB 0DDH
DB 0CCH
DB  6CH ; L
DB  3FH ; ?
DB    3
DB  3FH ; ?
DB  7FH ; 
DB 0E3H
DB 0F3H
DB 0E1H
DB  20H
DB    0
DB    0
DB 0F0H
DB 0C6H
DB  8FH
DB  9FH
DB 0FEH
DB  78H ; X
DB 0F4H
DB  87H
DB 0CFH
DB 0E7H
DB 0FEH
DB 0FCH
DB 0E0H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    4
DB  0EH
DB  0FH
DB  0FH
DB    7
DB    7
DB 0CFH
DB 0FEH
DB 0FCH
DB 0F0H
DB  70H ; P
DB  78H ; X
DB  3CH ; <
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0E0H
DB 0E0H
DB 0F3H
DB  77H ; W
DB  77H ; W
DB  7FH ; 
DB  3EH ; >
DB  3EH ; >
DB  3CH ; <
DB  38H ; 8
DB    0
DB    0
DB    0
DB  22H ; "
DB  33H ; 3
DB  13H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  10H
DB  20H
DB    0
DB  80H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    3
DB  0FH
DB  3FH ; ?
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FFH
DB 0FEH
DB 0FCH
DB  88H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0F0H
DB 0FCH
DB 0FEH
DB 0FEH
DB 0DCH
DB 0C0H
DB 0E0H
DB    0
DB  30H ; 0
DB  60H ; `
DB  40H ; @
DB    0
DB    0
DB    0
DB    1
DB    3
DB  77H ; W
DB 0DDH
DB 0CCH
DB  6CH ; L
DB  3FH ; ?
DB    3
DB  0FH
DB  3FH ; ?
DB  7BH ; {
DB 0E3H
DB 0F1H
DB 0E0H
DB  20H
DB    0
DB 0F0H
DB 0C6H
DB  8FH
DB  9FH
DB 0FEH
DB  78H ; X
DB 0F0H
DB  80H
DB 0C0H
DB 0E4H
DB 0E7H
DB 0FEH
DB 0FEH
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    4
DB  0EH
DB  0FH
DB  0FH
DB 0C7H
DB 0E7H
DB 0FFH
DB 0FEH
DB 0E0H
DB 0F0H
DB  70H ; P
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0E0H
DB 0E0H
DB 0F0H
DB  70H ; P
DB  70H ; P
DB  7EH ; ~
DB 0FFH
DB 0FFH
DB    0
DB    0
DB    0
DB    0
DB  22H ; "
DB  33H ; 3
DB  13H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  10H
DB  20H
DB    0
DB  80H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    3
DB  77H ; W
DB 0DDH
DB 0CCH
DB  6CH ; L
DB  3FH ; ?
DB    3
DB  0FH
DB  1FH
DB  3BH ; ;
DB  73H ; S
DB  79H ; Y
DB  3CH ; <
DB  38H ; 8
DB    8
DB 0F0H
DB 0C6H
DB  8FH
DB  9FH
DB 0FEH
DB  78H ; X
DB 0F0H
DB  80H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0E8H
DB 0EEH
DB 0FCH
DB  1CH
DB    0
DB    0
DB    0
DB    0
DB    4
DB    6
DB    3
DB    7
DB  37H ; 7
DB  7FH ; 
DB 0FFH
DB 0E7H
DB 0E0H
DB 0E0H
DB 0C1H
DB    3
DB    3
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0E0H
DB 0F0H
DB 0F0H
DB  70H ; P
DB  70H ; P
DB  70H ; P
DB 0E0H
DB 0F8H
DB 0FCH
DB 0FCH
DB    3
DB  0FH
DB  3FH ; ?
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FFH
DB 0FEH
DB 0FCH
DB  88H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0F0H
DB 0FCH
DB 0FEH
DB 0FEH
DB 0DCH
DB 0C0H
DB 0E0H
DB    0
DB  30H ; 0
DB  60H ; `
DB  40H ; @
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    3
DB  77H ; W
DB 0DDH
DB 0CCH
DB  6CH ; L
DB  3FH ; ?
DB    3
DB    3
DB    7
DB  0FH
DB  1FH
DB  1FH
DB  1FH
DB  0FH
DB    7
DB 0F0H
DB 0C6H
DB  8FH
DB  9FH
DB 0FEH
DB  78H ; X
DB 0F0H
DB  80H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0E0H
DB 0E0H
DB 0F8H
DB 0D0H
DB  90H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    8
DB  3FH ; ?
DB  3FH ; ?
DB  3FH ; ?
DB  3BH ; ;
DB  3BH ; ;
DB  33H ; 3
DB    7
DB  0FH
DB  0FH
DB    0
DB    0
DB    0
DB    0
DB    0
DB  20H
DB  60H ; `
DB 0E0H
DB 0F0H
DB 0F0H
DB 0E0H
DB  80H
DB  80H
DB 0E0H
DB 0F0H
DB 0F0H
DB    0
DB    0
DB    0
DB  22H ; "
DB  33H ; 3
DB  13H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  10H
DB  20H
DB    0
DB  80H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    3
DB  77H ; W
DB 0DDH
DB 0CCH
DB  6CH ; L
DB  3FH ; ?
DB    3
DB    3
DB    7
DB  0FH
DB  1FH
DB  1BH
DB    1
DB    0
DB    0
DB 0F0H
DB 0C6H
DB  8FH
DB  0FH
DB 0FEH
DB  78H ; X
DB 0F0H
DB  80H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0E8H
DB 0EFH
DB 0FEH
DB 0FEH
DB    0
DB    0
DB    0
DB    0
DB    4
DB  0EH
DB  0FH
DB  0FH
DB    7
DB    7
DB    7
DB  0FH
DB  1EH
DB  3CH ; <
DB  3EH ; >
DB  1FH
DB  0FH
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0FCH
DB 0FEH
DB 0FEH
DB  1CH
DB  78H ; X
DB 0FEH
DB 0FFH
DB  1FH
DB  80H
DB  80H
DB    0
DB    3
DB  0FH
DB  3FH ; ?
DB  7FH ; 
DB  7FH ; 
DB 0FFH
DB 0FFH
DB 0FEH
DB 0FCH
DB  88H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0F0H
DB 0FCH
DB 0FEH
DB 0FEH
DB 0DCH
DB 0C0H
DB 0E0H
DB    0
DB  30H ; 0
DB  60H ; `
DB  40H ; @
DB    0
DB    0
DB    0
DB    0
DB    1
DB    3
DB  77H ; W
DB 0DDH
DB 0CCH
DB  6CH ; L
DB  3FH ; ?
DB    3
DB  7FH ; 
DB 0FFH
DB 0CFH
DB 0DFH
DB 0FFH
DB 0FEH
DB 0E0H
DB  20H
DB 0F0H
DB 0C6H
DB  8FH
DB  9FH
DB 0FEH
DB  78H ; X
DB 0F4H
DB  87H
DB  87H
DB  8FH
DB 0C6H
DB 0EEH
DB  7CH ; |
DB  38H ; 8
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB  1FH
DB  1FH
DB  3FH ; ?
DB    1
DB    7
DB  1FH
DB  1FH
DB  0FH
DB    7
DB    1
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  80H
DB 0E0H
DB 0F0H
DB 0F0H
DB 0E0H
DB 0C0H
DB  80H
DB 0C0H
DB 0E0H
DB 0E0H
DB    0
DB    0
DB    0
DB  22H ; "
DB  33H ; 3
DB  13H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  10H
DB  20H
DB    0
DB  80H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  20H
DB  70H ; P
DB  70H ; P
DB  7CH ; |
DB  7EH ; ~
DB  7EH ; ~
DB  3EH ; >
DB  1FH
DB  0FH
DB  0DH
DB  1EH
DB  3FH ; ?
DB  3FH ; ?
DB    1
DB    7
DB  0FH
DB  1FH
DB  1FH
DB  3FH ; ?
DB  3FH ; ?
DB  1FH
DB  1FH
DB  1EH
DB  9CH
DB 0E0H
DB  80H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0FCH
DB 0FFH
DB 0FFH
DB 0FFH
DB 0EFH
DB 0E0H
DB 0FCH
DB 0C0H
DB  9CH
DB  18H
DB  10H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  80H
DB  80H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  18H
DB  1CH
DB  18H
DB 0DCH
DB  8EH
DB  0FH
DB    3
DB    1
DB    1
DB    1
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  80H
DB 0C0H
DB 0C0H
DB 0E0H
DB 0E0H
DB 0E1H
DB  63H ; C
DB  1FH
DB  3FH ; ?
DB  23H ; #
DB  37H ; 7
DB  1CH
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  3CH ; <
DB  60H ; `
DB 0E1H
DB 0E7H
DB  7FH ; 
DB  3FH ; ?
DB  1EH
DB 0FCH
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  80H
DB 0C0H
DB 0C0H
DB  80H
DB    0
DB    0
DB    0



SUB_AA19:
LD      IY, 7298H
LD      IX, 72CBH
BIT     3, (IX+6)
JR      NZ, LOC_AA29
XOR     A
RET

LOC_AA29:
LD      A, (IY+1)
CP      (IX+1)
JR      NC, LOC_AA3A
ADD     A, 0CH
CP      (IX+1)
JR      NC, LOC_AA44
JR      LOC_AA5C

LOC_AA3A:
LD      A, (IY+1)
ADD     A, 0FCH
CP      (IX+1)
JR      NC, LOC_AA5C

LOC_AA44:
LD      A, (IY+3)
CP      (IX+3)
JR      NC, LOC_AA55
ADD     A, 10H
CP      (IX+3)
JR      NC, LOC_AA5E
JR      LOC_AA5C

LOC_AA55:
ADD     A, 0F0H
CP      (IX+3)
JR      C, LOC_AA5E

LOC_AA5C:
XOR     A
RET

LOC_AA5E:
LD      A, 1
RET
; END OF FUNCTION SUB_AA19




SUB_AA61:
LD      B, 9
LD      HL, UNK_873B
CALL    SOUND_INIT
LD      B, 0EH
CALL    PLAY_IT
LD      B, 0FH
CALL    PLAY_IT
LD      B, 10H
CALL    PLAY_IT
LD      IY, 7288H
CALL    SUB_9E3B
CALL    SUB_A252
LD      A, 0EH
LD      ($7298), A
LD      A, ($7299)
LD      B, A
BIT     7, A
JR      Z, LOC_AA96
ADD     A, 0F0H
LD      ($7299), A
JR      LOC_AAA3

LOC_AA96:
CP      22H ; '"'
JR      C, LOC_AA9E
ADD     A, 0F0H
JR      LOC_AAA0

LOC_AA9E:
LD      A, 22H ; '"'

LOC_AAA0:
LD      ($7299), A

LOC_AAA3:
LD      A, B
CALL    SUB_A210
ADD     A, 10H
LD      ($729B), A
LD      IX, UNK_A085
CALL    PUTOBJ
LD      A, 2
LD      ($718C), A
LD      B, 3CH ; '<'

LOC_AABA:
PUSH    BC
CALL    PLAY_SONGS
CALL    SOUND_MAN
LD      BC, 1
LD      HL, 76CH

LOC_AAC7:
SBC     HL, BC
JR      NZ, LOC_AAC7
POP     BC
DJNZ    LOC_AABA
; END OF FUNCTION SUB_AA61




SUB_AACE:
LD      A, 7FH
LD      ($7299), A
LD      A, 0C1H
LD      ($729B), A
LD      IX, UNK_A085
JP      PUTOBJ
; END OF FUNCTION SUB_AACE

UNK_AADF:DB 0E5H
DB 0AAH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  2BH ; +
DB  70H ; P



SUB_AAEC:
LD      A, (HL)
LD      ($72C9), A
PUSH    HL
LD      HL, UNK_AADF
OR      A
CALL    ACTIVATE
LD      HL, 72C3H
LD      (HL), 0
POP     HL
INC     HL
PUSH    HL

LOC_AB00:
LD      HL, 72C9H
DEC     (HL)
JP      M, LOC_AB21
POP     HL
LD      DE, 72C4H
LD      BC, 4
LDIR
PUSH    HL
CALL    SUB_8DB2
CALL    SUB_AB2C
CALL    SUB_AC24
POP     HL
INC     HL
INC     HL
PUSH    HL
JP      LOC_AB00

LOC_AB21:
POP     HL
CALL    SUB_AB30
CALL    SUB_ABB6
CALL    SUB_AC43
RET
; END OF FUNCTION SUB_AAEC




SUB_AB2C:
LD      DE, 702BH
JP      (HL)
; END OF FUNCTION SUB_AB2C




SUB_AB30:
LD      A, ($71F3)
CP      4
RET     NZ
LD      HL, 71F9H
BIT     3, (HL)
JR      NZ, LOC_AB57
LD      A, ($71F7)
INC     A
SRL     A
LD      B, A
LD      A, ($71F8)
CP      B
JR      NC, LOC_AB50
XOR     A
CALL    SUB_AB9B
JR      LOC_AB5C

LOC_AB50:
LD      A, 1
CALL    SUB_AB9B
JR      LOC_AB5C

LOC_AB57:
LD      A, 2
CALL    SUB_AB9B

LOC_AB5C:
LD      IX, UNK_AB88
LD      IY, UNK_AB67
JP      LOC_AC5A
; END OF FUNCTION SUB_AB30

UNK_AB67:DB    7
DB    7
DB  96H
DB  86H
DB  82H
DB  96H
DB  87H
DB  96H
DB  8AH
DB  89H
DB  8BH
DB  96H
DB  83H
DB  88H
DB  96H
DB  8CH
DB  8EH
DB  84H
DB  96H
DB  8DH
DB  85H
DB  8FH
DB  85H
DB  8FH
DB  80H
DB  96H
DB  8CH
DB  89H
DB  84H
DB  81H
DB  89H
DB  80H
DB  9EH
UNK_AB88:DB    2
DB  83H
DB    2
DB  83H
DB  15H
DB  85H
DB    2
DB  85H
DB    1
DB  87H
DB    0
UNK_AB93:DB    0
DB  28H ; (
DB  60H ; `
DB  28H ; (
DB 0B0H
DB  28H ; (
DB    0
DB  30H ; 0



SUB_AB9B:
LD      HL, 72C3H
LD      (HL), 0
LD      HL, UNK_AB93
ADD     A, A
ADD     A, L
LD      L, A
LD      C, (HL)
LD      B, 0
LD      ($72C4), BC
INC     HL
LD      C, (HL)
LD      B, 0
LD      ($72C6), BC
RET
; END OF FUNCTION SUB_AB9B




SUB_ABB6:
LD      A, ($71F3)
CP      6
RET     NZ
CALL    SUB_8DC8
CALL    RAND_GEN
CALL    SUB_AC1B
PUSH    AF
LD      A, R
CALL    SUB_AC19
LD      B, A
POP     AF
ADD     A, B
ADD     A, 4
LD      ($72CA), A
LD      HL, 72C3H
LD      (HL), 0
ADD     A, A
ADD     A, A
ADD     A, A
LD      C, A
LD      B, 0
LD      ($72C4), BC
LD      C, 20H ; ' '
LD      B, 0
LD      ($72C6), BC
LD      DE, 702BH
LD      HL, UNK_ABF9
LD      BC, 20H ; ' '
LDIR
CALL    SUB_AC24
RET
; END OF FUNCTION SUB_ABB6

UNK_ABF9:DB    5
DB    6
DB  9CH
DB  80H
DB 0A2H
DB  80H
DB  9DH
DB  80H
DB 0A3H
DB  99H
DB 0A1H
DB  80H
DB  9DH
DB  9DH
DB  9AH
DB  9CH
DB  9CH
DB  9CH
DB  9CH
DB  9BH
DB  9DH
DB  9DH
DB  80H
DB  9EH
DB  99H
DB 0A0H
DB  80H
DB  9DH
DB  80H
DB  9FH
DB  80H
DB  9CH



SUB_AC19:
SRL     A
; END OF FUNCTION SUB_AC19




SUB_AC1B:
SRL     A
SRL     A
SRL     A
SRL     A
RET
; END OF FUNCTION SUB_AC1B




SUB_AC24:
LD      A, ($71F9)
BIT     2, A
CALL    Z, SUB_98E2
LD      HL, UNK_AADF
OR      A
CALL    ACTIVATE
LD      IX, UNK_AADF
CALL    PUTOBJ
LD      A, ($71F9)
BIT     2, A
CALL    Z, SUB_98F8
RET
; END OF FUNCTION SUB_AC24




SUB_AC43:
LD      A, ($71F3)
DEC     A
RET     NZ
LD      A, ($71F8)
DEC     A
RET     NZ
LD      A, 3
CALL    SUB_AB9B
LD      IX, UNK_ACBE
LD      IY, UNK_AC64

LOC_AC5A:
LD      HL, 702BH
LD      A, 0FFH
CALL    SUB_8EEB
JR      SUB_AC24
; END OF FUNCTION SUB_AC43

UNK_AC64:DB    8
DB  12H
DB  14H
DB  12H
DB  0AH
DB  1BH
DB  14H
DB  12H
DB  0AH
DB  12H
DB  11H
DB  1BH
DB  2FH ; /
DB  12H
DB  12H
DB  0AH
DB  12H
DB  0BH
DB  11H
DB  1BH
DB  1BH
DB  14H
DB  12H
DB  12H
DB  0AH
DB  0BH
DB  0CH
DB  1BH
DB  1BH
DB  2FH ; /
DB  12H
DB  0CH
DB  13H
DB  1BH
DB  14H
DB  12H
DB  0CH
DB  13H
DB  13H
DB  1BH
DB  14H
DB  13H
DB  1BH
DB  16H
DB  17H
DB  13H
DB  1BH
DB  18H
DB  1BH
DB  19H
DB  1EH
DB  1DH
DB  1CH
DB  1BH
DB  1AH
DB  2EH ; .
DB  1FH
DB  20H
DB  28H ; (
DB  2CH ; ,
DB  27H ; '
DB  21H ; !
DB  2EH ; .
DB  2EH ; .
DB  20H
DB  20H
DB  29H ; )
DB  2DH ; -
DB  26H ; &
DB  22H ; "
DB  2EH ; .
DB  2EH ; .
DB  20H
DB  1FH
DB  2AH ; *
DB  2DH ; -
DB  25H ; %
DB  23H ; #
DB  2EH ; .
DB  2EH ; .
DB  20H
DB  20H
DB  2BH ; +
DB  2DH ; -
DB  24H ; $
DB  43H ; C
DB  2EH ; .
DB  44H ; D
DB  2EH ; .
DB  12H
UNK_ACBE:DB    3
DB  86H
DB    3
DB  83H
DB  16H
DB  83H
DB    2
DB  83H
DB    5
DB  84H
DB    1
DB  83H
DB  85H
DB    3
DB  87H
DB    1
DB  87H
DB    2
DB  83H
DB  21H ; !
DB  8AH
DB    1
DB  87H
DB    1
DB  88H
DB    0



SUB_ACD8:
LD      A, ($71F3)
CP      7
JR      NZ, SUB_AD1B
PUSH    HL
PUSH    IX
LD      HL, UNK_BA4E
SCF
CALL    ACTIVATE
LD      DE, 72CBH
CALL    SUB_AD27
LD      (IX+0), 2
LD      (IX+1), 0E8H
LD      (IX+3), 48H ; 'H'
LD      HL, UNK_BAC0
SCF
CALL    ACTIVATE
LD      DE, 72FAH
CALL    SUB_AD27
LD      (IX+0), 0
LD      (IX+1), 0E8H
LD      (IX+3), 58H ; 'X'
CALL    SUB_AD35
POP     IX
POP     HL
RET
; END OF FUNCTION SUB_ACD8




SUB_AD1B:
LD      A, 0C1H
LD      ($72CE), A
LD      ($72FD), A
CALL    SUB_AD35
RET
; END OF FUNCTION SUB_AD1B




SUB_AD27:
PUSH    DE
POP     IX
LD      H, D
LD      L, E
INC     DE
LD      BC, 4
XOR     A
LD      (DE), A
LDIR
RET
; END OF FUNCTION SUB_AD27




SUB_AD35:
LD      IX, UNK_BA4E
CALL    PUTOBJ
LD      IX, UNK_BAC0
CALL    PUTOBJ
RET
; END OF FUNCTION SUB_AD35

DB  38H ; 8
DB 0AFH
DB 0B0H
DB  98H
DB 0FFH
DB    0
DB  10H
DB 0AEH
DB 0FFH
DB    0
DB  68H ; H
DB 0ADH
DB    0
DB  64H ; D
DB  98H
DB 0ADH
DB  65H ; E
DB  8CH
DB  1EH
DB 0AEH
DB  8DH
DB 0B4H
DB  36H ; 6
DB 0AEH
DB 0B5H
DB 0D2H
DB  4EH ; N
DB 0AEH
DB 0D3H
DB 0FFH
DB  60H ; `
DB 0AEH
DB 0FFH
DB    0
DB  68H ; H
DB 0ADH
DB  81H
DB    0
DB    5
DB    4
DB  10H
DB 0A2H
DB 0ADH
DB  12H
DB    1
DB    0
DB    1
DB    0
DB  80H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    0
DB    1
DB    3
DB    8
DB 0C5H
DB 0ADH
DB  12H
DB    0
DB    0
DB    1
DB    0
DB    1
DB    4
DB    8
DB 0D7H
DB 0ADH
DB  12H
DB    0
DB    0
DB    1
DB    0
DB    1
DB    4
DB    8
DB 0EAH
DB 0ADH
DB  12H
DB    0
DB    0
DB    1
DB    0
DB    1
DB    4
DB    8
DB 0FDH
DB 0ADH
DB  12H
DB    0
DB    0
DB 0A8H
DB 0ADH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0AFH
DB 0ADH
DB    5
DB    4
DB  30H ; 0
DB  31H ; 1
DB  38H ; 8
DB  38H ; 8
DB  38H ; 8
DB  32H ; 2
DB  33H ; 3
DB  39H ; 9
DB  39H ; 9
DB  39H ; 9
DB  34H ; 4
DB  35H ; 5
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  36H ; 6
DB  37H ; 7
DB  51H ; Q
DB  50H ; P
DB  44H ; D
DB 0CBH
DB 0ADH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0D2H
DB 0ADH
DB    1
DB    3
DB  39H ; 9
DB  43H ; C
DB  44H ; D
DB 0DDH
DB 0ADH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0E4H
DB 0ADH
DB    1
DB    4
DB  39H ; 9
DB  43H ; C
DB  44H ; D
DB  4FH ; O
DB 0F0H
DB 0ADH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0F7H
DB 0ADH
DB    1
DB    4
DB  39H ; 9
DB  43H ; C
DB  44H ; D
DB  4FH ; O
DB    3
DB 0AEH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  0AH
DB 0AEH
DB    1
DB    4
DB  39H ; 9
DB  43H ; C
DB  44H ; D
DB  4EH ; N
DB    1
DB    0
DB    3
DB    4
DB    8
DB  16H
DB 0AFH
DB  12H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  41H ; A
DB 0F8H
DB    8
DB    4
DB  10H
DB  72H ; R
DB 0AEH
DB  12H
DB    0
DB    0
DB    0
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FFH
DB    0
DB 0FEH
DB  21H ; !
DB    8
DB    8
DB    4
DB    8
DB 0A1H
DB 0AEH
DB  12H
DB    0
DB    0
DB    0
DB    2
DB    0
DB    1
DB    0
DB    1
DB    0
DB    1
DB    0
DB    1
DB    0
DB    1
DB    0
DB    1
DB  41H ; A
DB 0F8H
DB    5
DB    4
DB  10H
DB 0D0H
DB 0AEH
DB  12H
DB    0
DB    0
DB    0
DB 0FEH
DB    0
DB 0FEH
DB    0
DB 0FEH
DB    0
DB 0FEH
DB  21H ; !
DB    8
DB    5
DB    4
DB    8
DB 0F3H
DB 0AEH
DB  12H
DB    0
DB    2
DB    0
DB    2
DB    0
DB    2
DB    0
DB    2
DB    0
DB    0
DB  78H ; X
DB 0AEH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  7FH ; 
DB 0AEH
DB    8
DB    4
DB  38H ; 8
DB  3BH ; ;
DB  3DH ; =
DB  3FH ; ?
DB  40H ; @
DB  41H ; A
DB  42H ; B
DB  39H ; 9
DB  39H ; 9
DB  3AH ; :
DB  3CH ; <
DB  3EH ; >
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  49H ; I
DB  4AH ; J
DB  4CH ; L
DB  44H ; D
DB  44H ; D
DB  45H ; E
DB  46H ; F
DB  47H ; G
DB  48H ; H
DB  4BH ; K
DB  4DH ; M
DB  4EH ; N
DB 0A7H
DB 0AEH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0AEH
DB 0AEH
DB    8
DB    4
DB  39H ; 9
DB  42H ; B
DB  41H ; A
DB  40H ; @
DB  3FH ; ?
DB  3DH ; =
DB  3BH ; ;
DB  38H ; 8
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  3EH ; >
DB  3CH ; <
DB  3AH ; :
DB  39H ; 9
DB  44H ; D
DB  4CH ; L
DB  4AH ; J
DB  49H ; I
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  4EH ; N
DB  4DH ; M
DB  4BH ; K
DB  48H ; H
DB  47H ; G
DB  46H ; F
DB  45H ; E
DB  44H ; D
DB 0D6H
DB 0AEH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0DDH
DB 0AEH
DB    5
DB    4
DB  38H ; 8
DB  3DH ; =
DB  40H ; @
DB  42H ; B
DB  39H ; 9
DB  39H ; 9
DB  3CH ; <
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  49H ; I
DB  4CH ; L
DB  44H ; D
DB  44H ; D
DB  46H ; F
DB  48H ; H
DB  4DH ; M
DB  4EH ; N
DB 0F9H
DB 0AEH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0AFH
DB    5
DB    4
DB  39H ; 9
DB  42H ; B
DB  40H ; @
DB  3DH ; =
DB  38H ; 8
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  3CH ; <
DB  39H ; 9
DB  44H ; D
DB  4CH ; L
DB  49H ; I
DB  43H ; C
DB  43H ; C
DB  4EH ; N
DB  4DH ; M
DB  48H ; H
DB  46H ; F
DB  44H ; D
DB  1CH
DB 0AFH
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  23H ; #
DB 0AFH
DB    3
DB    4
DB  39H ; 9
DB  39H ; 9
DB  39H ; 9
DB  43H ; C
DB  43H ; C
DB  43H ; C
DB  44H ; D
DB  44H ; D
DB  44H ; D
DB  4EH ; N
DB  4EH ; N
DB  4EH ; N
DB  23H ; #
DB    5
DB  77H ; W
DB 0C2H
DB  31H ; 1
DB 0AFH
DB 0C9H
DB    3
DB    0
DB    0
DB  18H
DB    0
DB  4BH ; K
DB 0AFH
DB    0
DB    0
DB  58H ; X
DB    0
DB 0FCH
DB 0AFH
DB    0
DB    0
DB  98H
DB    0
DB 0B5H
DB 0B0H
DB 0DDH
DB  21H ; !
DB 0D0H
DB 0AFH
DB 0FDH
DB  21H ; !
DB  5BH ; [
DB 0AFH
DB  3EH ; >
DB 0FFH
DB  21H ; !
DB  2BH ; +
DB  70H ; P
DB 0C3H
DB 0EBH
DB  8EH
DB  20H
DB    8
DB  12H
DB  0AH
DB  0BH
DB  11H
DB    9
DB  12H
DB  0AH
DB    9
DB  0AH
DB  12H
DB  0AH
DB  0BH
DB  11H
DB  0AH
DB  12H
DB  0BH
DB    9
DB  0AH
DB  12H
DB  0AH
DB  12H
DB  0AH
DB  0BH
DB  0BH
DB  11H
DB    9
DB  0AH
DB  12H
DB  0AH
DB  0AH
DB  0BH
DB  11H
DB    9
DB  12H
DB  0AH
DB  0BH
DB  0BH
DB  11H
DB    9
DB  12H
DB  0BH
DB  11H
DB  11H
DB  0AH
DB  12H
DB  0AH
DB  12H
DB  0BH
DB  0BH
DB  11H
DB    9
DB  12H
DB  0AH
DB  12H
DB  0BH
DB  11H
DB  11H
DB    9
DB  0AH
DB  12H
DB  0AH
DB  12H
DB  0BH
DB  11H
DB  0AH
DB  12H
DB  0BH
DB  11H
DB    9
DB  12H
DB  0AH
DB  0BH
DB  0CH
DB  11H
DB  0CH
DB  11H
DB  11H
DB    9
DB  0AH
DB  12H
DB  0AH
DB  0BH
DB  11H
DB    9
DB  12H
DB  0BH
DB  12H
DB  12H
DB    5
DB  0CH
DB    6
DB    5
DB    5
DB  0CH
DB  13H
DB  0CH
DB    5
DB    1
DB    9
DB  12H
DB  0AH
DB  12H
DB  0AH
DB  12H
DB  0BH
DB  0CH
DB    5
DB  0CH
DB    5
DB  0CH
DB    7
DB    8
DB    5
DB    4
DB    2
DB    2
DB  89H
DB    4
DB  89H
DB    3
DB  90H
DB    4
DB  8AH
DB    3
DB  8CH
DB    8
DB  87H
DB    5
DB  8DH
DB    3
DB  83H
DB    1
DB  88H
DB    4
DB  8BH
DB    4
DB  84H
DB    1
DB  86H
DB    7
DB  89H
DB    3
DB  87H
DB    1
DB  87H
DB    1
DB  83H
DB    1
DB  8AH
DB    3
DB  83H
DB    5
DB  84H
DB    2
DB  84H
DB    1
DB  87H
DB  1EH
DB    0
DB 0DDH
DB  21H ; !
DB  92H
DB 0B0H
DB 0FDH
DB  21H ; !
DB    7
DB 0B0H
DB 0C3H
DB  53H ; S
DB 0AFH
DB  20H
DB    8
DB  12H
DB  0AH
DB  0CH
DB    5
DB    4
DB    2
DB  13H
DB  13H
DB    6
DB    1
DB    2
DB  13H
DB  13H
DB    6
DB    0
DB    9
DB  12H
DB  12H
DB    5
DB    4
DB    2
DB  0CH
DB  13H
DB    6
DB    5
DB    1
DB    2
DB    6
DB    5
DB    1
DB    3
DB  13H
DB    8
DB    7
DB  13H
DB    1
DB    3
DB  13H
DB    0
DB  13H
DB    0
DB    2
DB    8
DB    5
DB    1
DB    3
DB  13H
DB    6
DB    0
DB  13H
DB  13H
DB    6
DB    1
DB    1
DB  13H
DB  13H
DB    6
DB    1
DB    0
DB    1
DB  13H
DB    0
DB  13H
DB  10H
DB  0DH
DB  13H
DB  13H
DB    6
DB    1
DB    1
DB    2
DB  13H
DB    0
DB  13H
DB    0
DB    0
DB  13H
DB    6
DB    0
DB    0
DB  10H
DB  0EH
DB  0FH
DB  10H
DB    0
DB  0EH
DB  0FH
DB  10H
DB  11H
DB  11H
DB  0EH
DB  0FH
DB  10H
DB    0
DB    0
DB  0EH
DB  0FH
DB  0FH
DB  10H
DB  0EH
DB  0DH
DB  10H
DB  0FH
DB  10H
DB    0
DB    0
DB  13H
DB  0EH
DB  0FH
DB  10H
DB    0
DB    0
DB  11H
DB  0DH
DB  11H
DB    0
DB    0
DB  11H
DB    0
DB    0
DB  0EH
DB  11H
DB    0
DB    0
DB  11H
DB  0DH
DB  0DH
DB  11H
DB    0
DB    0
DB  11H
DB  0DH
DB  0DH
DB  11H
DB  0DH
DB  0DH
DB  11H
DB  27H ; '
DB  84H
DB    1
DB  84H
DB    6
DB  84H
DB  0DH
DB  84H
DB    1
DB  83H
DB    8
DB  84H
DB    1
DB  83H
DB    2
DB  83H
DB  23H ; #
DB  84H
DB    1
DB  88H
DB    2
DB  89H
DB    3
DB  83H
DB    2
DB  8DH
DB    2
DB  89H
DB    2
DB  84H
DB    2
DB  98H
DB    2
DB 0A1H
DB    0
DB 0DDH
DB  21H ; !
DB 0C4H
DB 0B0H
DB 0FDH
DB  21H ; !
DB 0C0H
DB 0B0H
DB 0C3H
DB  53H ; S
DB 0AFH
DB  20H
DB    4
DB  11H
DB  11H
DB    2
DB 0FFH
DB    1
DB    0
DB 0C9H
DB 0B2H
DB 0B8H
DB  80H
DB    0
DB  28H ; (
DB  3CH ; <
DB 0B1H
DB 0FFH
DB    0
DB  8AH
DB 0B1H
DB  29H ; )
DB  64H ; D
DB  2AH ; *
DB 0B1H
DB  65H ; E
DB 0AFH
DB  3CH ; <
DB 0B1H
DB 0FFH
DB    0
DB    4
DB 0B1H
DB 0B0H
DB 0CDH
DB  64H ; D
DB 0B1H
DB 0CEH
DB 0FFH
DB  76H ; V
DB 0B1H
DB    0
DB  28H ; (
DB  3CH ; <
DB 0B1H
DB 0FFH
DB    0
DB  8AH
DB 0B1H
DB  29H ; )
DB  50H ; P
DB  2AH ; *
DB 0B1H
DB  51H ; Q
DB  78H ; X
DB  3CH ; <
DB 0B1H
DB  79H ; Y
DB 0B0H
DB  52H ; R
DB 0B1H
DB 0B1H
DB 0D2H
DB  64H ; D
DB 0B1H
DB 0D3H
DB 0FFH
DB  76H ; V
DB 0B1H
DB 0C1H
DB 0E8H
DB    6
DB    4
DB  18H
DB  9AH
DB 0B1H
DB 0B6H
DB    0
DB    0
DB    0
DB    0
DB    1
DB 0F0H
DB    0
DB    0
DB  80H
DB    0
DB    0
DB    0
DB 0A1H
DB 0E8H
DB    5
DB    4
DB    8
DB 0C1H
DB 0B1H
DB 0B6H
DB    0
DB    0
DB    1
DB  10H
DB    1
DB    0
DB  80H
DB    0
DB    0
DB    0
DB    1
DB    0
DB    5
DB    5
DB    8
DB 0E4H
DB 0B1H
DB 0B6H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    0
DB    7
DB    5
DB    8
DB  0CH
DB 0B2H
DB 0B6H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0C1H
DB 0D8H
DB    5
DB    6
DB  28H ; (
DB  3EH ; >
DB 0B2H
DB 0B6H
DB    1
DB 0F0H
DB    1
DB 0F0H
DB    0
DB    0
DB  40H ; @
DB    0
DB    0
DB    0
DB 0C1H
DB 0E8H
DB    5
DB    5
DB  18H
DB  6BH ; K
DB 0B2H
DB 0B6H
DB    0
DB    0
DB    1
DB 0F8H
DB    0
DB 0F8H
DB  80H
DB    0
DB    0
DB    0
DB 0A1H
DB    8
DB    6
DB    2
DB    8
DB  93H
DB 0B2H
DB 0B6H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    2
DB    0
DB    3
DB    0
DB    3
DB    0
DB    0
DB 0A1H
DB  10H
DB    4
DB    3
DB  10H
DB 0AEH
DB 0B2H
DB 0B6H
DB    1
DB 0F6H
DB    1
DB  0AH
DB  80H
DB    0
DB    0
DB    0
DB 0A0H
DB 0B1H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0A7H
DB 0B1H
DB    6
DB    4
DB  9EH
DB  9EH
DB  9EH
DB 0B5H
DB 0B5H
DB 0B5H
DB  9EH
DB  9EH
DB 0A2H
DB 0A3H
DB 0BBH
DB 0BAH
DB 0B5H
DB 0B5H
DB 0AFH
DB 0B0H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B1H
DB 0B6H
DB 0B7H
DB 0B8H
DB 0C7H
DB 0B1H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0CEH
DB 0B1H
DB    5
DB    4
DB 0B5H
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB 0A9H
DB 0AAH
DB  9EH
DB  9EH
DB  9EH
DB 0B3H
DB 0B2H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B6H
DB 0B4H
DB 0BBH
DB 0BAH
DB 0B6H
DB 0EAH
DB 0B1H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0F1H
DB 0B1H
DB    5
DB    5
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B6H
DB 0B7H
DB 0A1H
DB 0B6H
DB 0B6H
DB  9FH
DB 0A0H
DB 0B8H
DB 0B6H
DB 0B7H
DB 0B6H
DB 0A1H
DB  9FH
DB 0A0H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0A1H
DB 0B7H
DB 0B6H
DB  12H
DB 0B2H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  19H
DB 0B2H
DB    7
DB    5
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB 0A0H
DB 0B6H
DB 0A1H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB  9FH
DB 0A0H
DB 0B6H
DB 0A0H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0A1H
DB 0A0H
DB 0B7H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB  44H ; D
DB 0B2H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  4BH ; K
DB 0B2H
DB    5
DB    6
DB  9EH
DB 0B5H
DB 0B5H
DB 0B5H
DB 0B5H
DB  9EH
DB 0A4H
DB 0A6H
DB 0BCH
DB 0BAH
DB  9EH
DB 0A5H
DB 0A7H
DB 0A1H
DB 0B6H
DB 0A4H
DB 0A6H
DB  9FH
DB 0A0H
DB 0B6H
DB 0A5H
DB 0A7H
DB 0A0H
DB 0A1H
DB 0B6H
DB 0A8H
DB 0B6H
DB 0B7H
DB 0B6H
DB 0B6H
DB  71H ; Q
DB 0B2H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  78H ; X
DB 0B2H
DB    5
DB    5
DB  9EH
DB  9EH
DB  90H
DB 0B5H
DB 0B5H
DB  9EH
DB  90H
DB  92H
DB 0BBH
DB 0BAH
DB 0B5H
DB  91H
DB 0B6H
DB 0B7H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B6H
DB 0B8H
DB 0B7H
DB 0B6H
DB  99H
DB 0B2H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0A0H
DB 0B2H
DB    6
DB    2
DB 0B5H
DB 0B5H
DB 0BDH
DB 0BFH
DB  9EH
DB  9EH
DB 0B6H
DB 0B6H
DB 0BEH
DB 0C0H
DB 0C1H
DB 0C2H
DB 0B4H
DB 0B2H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0BBH
DB 0B2H
DB    4
DB    3
DB 0C3H
DB 0C4H
DB  9EH
DB  9EH
DB 0C5H
DB 0C6H
DB 0B5H
DB 0B5H
DB 0B7H
DB 0B8H
DB 0BBH
DB 0BAH
DB  15H
DB    0
DB    0
DB    0
DB    0
DB  48H ; H
DB 0B3H
DB    0
DB    0
DB  10H
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  20H
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  30H ; 0
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  40H ; @
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  50H ; P
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  58H ; X
DB    0
DB  60H ; `
DB 0B3H
DB    0
DB    0
DB  60H ; `
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  70H ; P
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  80H
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB  90H
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB 0A0H
DB    0
DB  57H ; W
DB 0B3H
DB    0
DB    0
DB 0B0H
DB    0
DB  57H ; W
DB 0B3H
DB    8
DB    0
DB  48H ; H
DB    0
DB  6FH ; O
DB 0B3H
DB  50H ; P
DB    0
DB  38H ; 8
DB    0
DB  8AH
DB 0B3H
DB 0B8H
DB    0
DB  48H ; H
DB    0
DB 0C9H
DB 0B3H
DB  30H ; 0
DB    0
DB  20H
DB    0
DB 0E0H
DB 0B3H
DB 0A0H
DB    0
DB  30H ; 0
DB    0
DB 0E0H
DB 0B3H
DB  60H ; `
DB    0
DB  30H ; 0
DB    0
DB 0F3H
DB 0B3H
DB  30H ; 0
DB    0
DB  30H ; 0
DB    0
DB 0F3H
DB 0B3H
DB  80H
DB    0
DB  20H
DB    0
DB    0
DB 0B4H
DB  21H ; !
DB  2BH ; +
DB  70H ; P
DB  36H ; 6
DB  20H
DB  23H ; #
DB  36H ; 6
DB    2
DB    6
DB  40H ; @
DB  3EH ; >
DB  96H
DB 0C3H
DB  31H ; 1
DB 0AFH
DB  21H ; !
DB  2BH ; +
DB  70H ; P
DB  36H ; 6
DB  20H
DB  23H ; #
DB  36H ; 6
DB    2
DB 0C9H
DB  21H ; !
DB  2BH ; +
DB  70H ; P
DB  36H ; 6
DB  20H
DB  23H ; #
DB  36H ; 6
DB    2
DB    6
DB  40H ; @
DB  3EH ; >
DB  9EH
DB 0C3H
DB  31H ; 1
DB 0AFH
DB    1
DB  12H
DB    0
DB  21H ; !
DB  78H ; X
DB 0B3H
DB 0EDH
DB 0B0H
DB 0C9H
DB    8
DB    2
DB  96H
DB  96H
DB  97H
DB  99H
DB  9AH
DB  9BH
DB  96H
DB  96H
DB  97H
DB  98H
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9CH
DB  9BH
DB    1
DB  36H ; 6
DB    0
DB  21H ; !
DB  93H
DB 0B3H
DB 0EDH
DB 0B0H
DB 0C9H
DB  0DH
DB    4
DB  96H
DB  96H
DB  96H
DB  96H
DB  96H
DB  97H
DB  99H
DB  9AH
DB  9BH
DB  96H
DB  96H
DB  96H
DB  96H
DB  96H
DB  96H
DB  96H
DB  96H
DB  9DH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9CH
DB  9BH
DB  96H
DB  96H
DB  96H
DB  96H
DB  96H
DB  9DH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9CH
DB  9BH
DB  96H
DB  97H
DB  98H
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB    1
DB  0EH
DB    0
DB  21H ; !
DB 0D2H
DB 0B3H
DB 0EDH
DB 0B0H
DB 0C9H
DB    6
DB    2
DB  97H
DB  99H
DB  9AH
DB  9BH
DB  96H
DB  96H
DB  9EH
DB  9EH
DB  9EH
DB  9EH
DB  9CH
DB  9BH
DB    1
DB  0AH
DB    0
DB  21H ; !
DB 0E9H
DB 0B3H
DB 0EDH
DB 0B0H
DB 0C9H
DB    4
DB    2
DB 0C7H
DB 0C8H
DB 0C9H
DB 0CAH
DB 0CBH
DB 0CCH
DB 0CDH
DB 0CEH
DB    1
DB    4
DB    0
DB  21H ; !
DB 0FCH
DB 0B3H
DB 0EDH
DB 0B0H
DB 0C9H
DB    2
DB    1
DB 0CFH
DB 0D0H
DB    1
DB    8
DB    0
DB  21H ; !
DB    9
DB 0B4H
DB 0EDH
DB 0B0H
DB 0C9H
DB    3
DB    2
DB 0D1H
DB 0D2H
DB 0D3H
DB 0D4H
DB 0D5H
DB 0D6H
DB  18H
DB 0B5H
DB 0A8H
DB  48H ; H
DB 0FFH
DB    0
DB  65H ; E
DB 0B4H
DB 0FFH
DB    0
DB  55H ; U
DB 0B4H
DB    0
DB  64H ; D
DB  65H ; E
DB 0B4H
DB  65H ; E
DB  9BH
DB  55H ; U
DB 0B4H
DB  9CH
DB 0FFH
DB  65H ; E
DB 0B4H
DB 0FFH
DB    0
DB  65H ; E
DB 0B4H
DB    0
DB  32H ; 2
DB  3DH ; =
DB 0B4H
DB 0FFH
DB    0
DB  65H ; E
DB 0B4H
DB  33H ; 3
DB  64H ; D
DB  55H ; U
DB 0B4H
DB  65H ; E
DB 0FFH
DB  3DH ; =
DB 0B4H
DB 0A1H
DB  28H ; (
DB    8
DB    7
DB    8
DB  79H ; Y
DB 0B4H
DB  15H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    0
DB    1
DB  18H
DB    1
DB    0
DB  40H ; @
DB    0
DB    0
DB    0
DB 0A1H
DB  18H
DB    4
DB    7
DB    8
DB 0C0H
DB 0B4H
DB  15H
DB    0
DB    0
DB    1
DB  10H
DB  81H
DB    0
DB    0
DB    0
DB  61H ; A
DB    0
DB    6
DB    5
DB    0
DB 0EBH
DB 0B4H
DB  15H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  7FH ; 
DB 0B4H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB  86H
DB 0B4H
DB    8
DB    7
DB    0
DB    0
DB    0
DB    1
DB    0
DB    0
DB    0
DB    0
DB  17H
DB  19H
DB    4
DB    2
DB    1
DB    0
DB    0
DB    0
DB  12H
DB  14H
DB  0DH
DB    4
DB    2
DB    0
DB    0
DB    0
DB  14H
DB  0EH
DB    5
DB    7
DB    5
DB    0
DB    0
DB    0
DB  19H
DB  12H
DB    8
DB  0EH
DB    6
DB    7
DB  1DH
DB  1BH
DB  15H
DB  19H
DB  16H
DB  0FH
DB  16H
DB  14H
DB  15H
DB  15H
DB  15H
DB  1AH
DB  10H
DB  12H
DB  11H
DB  12H
DB  15H
DB  15H
DB 0C6H
DB 0B4H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0CDH
DB 0B4H
DB    4
DB    7
DB    0
DB    1
DB    0
DB    0
DB    3
DB    2
DB    0
DB    0
DB  0DH
DB    5
DB    0
DB    0
DB  1AH
DB  0CH
DB  1CH
DB  1BH
DB  12H
DB  14H
DB  15H
DB  13H
DB  19H
DB  17H
DB  15H
DB  15H
DB  15H
DB  18H
DB  15H
DB  15H
DB 0F1H
DB 0B4H
DB 0C3H
DB  72H ; R
DB    1
DB  80H
DB 0E0H
DB    0
DB    0
DB    0
DB    0
DB 0F8H
DB 0B4H
DB    6
DB    5
DB  17H
DB  19H
DB  13H
DB  12H
DB  13H
DB  12H
DB  12H
DB  14H
DB  15H
DB  13H
DB  15H
DB  13H
DB  19H
DB  17H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  18H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  15H
DB  0EH
DB    0
DB    0
DB    0
DB    0
DB  6DH ; M
DB 0B5H
DB    0
DB    0
DB  10H
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  20H
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  30H ; 0
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  40H ; @
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  50H ; P
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  60H ; `
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  70H ; P
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  80H
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB  90H
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB 0A0H
DB    0
DB  7CH ; |
DB 0B5H
DB    0
DB    0
DB 0B0H
DB    0
DB  7CH ; |
DB 0B5H
DB  40H ; @
DB    0
DB  18H
DB    0
DB  85H
DB 0B5H
DB 0C0H
DB    0
DB  18H
DB    0
DB 0D0H
DB 0B5H
DB  21H ; !
DB  2BH ; +
DB  70H ; P
DB  36H ; 6
DB  20H
DB  23H ; #
DB  36H ; 6
DB    2
DB    6
DB  40H ; @
DB  3EH ; >
DB    0
DB 0C3H
DB  31H ; 1
DB 0AFH
DB  21H ; !
DB  2BH ; +
DB  70H ; P
DB  36H ; 6
DB  20H
DB  23H ; #
DB  36H ; 6
DB    2
DB 0C9H
DB    1
DB  42H ; B
DB    0
DB  21H ; !
DB  8EH
DB 0B5H
DB 0EDH
DB 0B0H
DB 0C9H
DB    8
DB    8
DB  28H ; (
DB  2AH ; *
DB    0
DB  21H ; !
DB  2BH ; +
DB  23H ; #
DB  2BH ; +
DB  24H ; $
DB  27H ; '
DB  28H ; (
DB    0
DB  1FH
DB  24H ; $
DB  23H ; #
DB  27H ; '
DB  1FH
DB  26H ; &
DB  28H ; (
DB    0
DB  20H
DB  23H ; #
DB  22H ; "
DB  26H ; &
DB  1EH
DB    0
DB  27H ; '
DB    0
DB  1EH
DB  22H ; "
DB  20H
DB    0
DB    0
DB    0
DB  26H ; &
DB    0
DB    0
DB  21H ; !
DB  20H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  20H
DB  1FH
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  1FH
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  1EH
DB    0
DB    0
DB    0
DB    1
DB  42H ; B
DB    0
DB  21H ; !
DB 0D9H
DB 0B5H
DB 0EDH
DB 0B0H
DB 0C9H
DB    8
DB    8
DB  28H ; (
DB  2AH ; *
DB    0
DB  21H ; !
DB  2BH ; +
DB  25H ; %
DB  25H ; %
DB  25H ; %
DB  27H ; '
DB  29H ; )
DB    0
DB  20H
DB  24H ; $
DB  23H ; #
DB  2AH ; *
DB  2CH ; ,
DB  26H ; &
DB  29H ; )
DB    0
DB  21H ; !
DB  23H ; #
DB  22H ; "
DB  23H ; #
DB  2CH ; ,
DB    0
DB  27H ; '
DB    0
DB  1EH
DB  22H ; "
DB  22H ; "
DB  21H ; !
DB  2CH ; ,
DB    0
DB  26H ; &
DB    0
DB    0
DB  21H ; !
DB  20H
DB  21H ; !
DB    0
DB    0
DB    0
DB    0
DB    0
DB  21H ; !
DB  1FH
DB  20H
DB    0
DB    0
DB    0
DB    0
DB    0
DB  1FH
DB    0
DB  20H
DB    0
DB    0
DB    0
DB    0
DB    0
DB  1EH
DB    0
DB    0
DB    0
DB 0C9H
DB 0B2H
DB 0B0H
DB  80H
DB    0
DB  1FH
DB  3CH ; <
DB 0B1H
DB 0FFH
DB    0
DB  18H
DB 0B1H
DB  20H
DB  40H ; @
DB  2AH ; *
DB 0B1H
DB  41H ; A
DB  78H ; X
DB  3CH ; <
DB 0B1H
DB 0FFH
DB    0
DB    4
DB 0B1H
DB 0FFH
DB    0
DB    4
DB 0B1H
DB  79H ; Y
DB 0C4H
DB  64H ; D
DB 0B1H
DB 0C5H
DB 0E5H
DB  76H ; V
DB 0B1H
DB 0E6H
DB 0FFH
DB    4
DB 0B1H
DB    0
DB  1FH
DB  3CH ; <
DB 0B1H
DB 0FFH
DB    0
DB  18H
DB 0B1H
DB  20H
DB  40H ; @
DB  2AH ; *
DB 0B1H
DB  41H ; A
DB  64H ; D
DB  3CH ; <
DB 0B1H
DB  65H ; E
DB  79H ; Y
DB  52H ; R
DB 0B1H
DB  79H ; Y
DB 0A3H
DB  8AH
DB 0B1H
DB 0A4H
DB 0C4H
DB  64H ; D
DB 0B1H
DB 0C5H
DB 0E5H
DB  76H ; V
DB 0B1H
DB 0E6H
DB 0FFH
DB    4
DB 0B1H
DB  6BH ; K
DB 0B6H
DB 0B0H
DB  50H ; P
DB  29H ; )
DB 0E0H
DB 0FFH
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB  10H
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB  40H ; @
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB  50H ; P
DB    0
DB  18H
DB    0
DB  85H
DB 0B7H
DB  70H ; P
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB 0D0H
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB    0
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB  18H
DB    0
DB  28H ; (
DB    0
DB  94H
DB 0B7H
DB  30H ; 0
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB  60H ; `
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB  90H
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB  28H ; (
DB    0
DB  94H
DB 0B7H
DB 0C0H
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB 0C8H
DB    0
DB  38H ; 8
DB    0
DB  85H
DB 0B7H
DB 0F0H
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB 0E8H
DB 0FFH
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  18H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  48H ; H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  58H ; X
DB    0
DB  48H ; H
DB    0
DB  94H
DB 0B7H
DB  50H ; P
DB    0
DB  58H ; X
DB    0
DB  85H
DB 0B7H
DB  78H ; X
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0A8H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0D8H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB    0
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  10H
DB    0
DB  78H ; X
DB    0
DB  85H
DB 0B7H
DB  30H ; 0
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  60H ; `
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  90H
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB  68H ; H
DB    0
DB  94H
DB 0B7H
DB 0C0H
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0F0H
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0E0H
DB 0FFH
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  10H
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  20H
DB    0
DB  98H
DB    0
DB  85H
DB 0B7H
DB  40H ; @
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  70H ; P
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB 0D0H
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB    0
DB    0
DB 0A8H
DB    0
DB  18H
DB 0B8H
DB  80H
DB    0
DB 0A8H
DB    0
DB  53H ; S
DB 0B8H
DB    1
DB  1AH
DB    0
DB  21H ; !
DB  6BH ; K
DB 0B7H
DB 0EDH
DB 0B0H
DB 0C9H
DB    6
DB    4
DB  81H
DB  83H
DB  83H
DB  83H
DB  83H
DB  82H
DB  8FH
DB  80H
DB  80H
DB  80H
DB  80H
DB  90H
DB  8FH
DB  80H
DB  80H
DB  80H
DB  80H
DB  90H
DB  89H
DB  84H
DB  84H
DB  84H
DB  84H
DB  8AH
DB    1
DB    6
DB    0
DB  21H ; !
DB  8EH
DB 0B7H
DB 0EDH
DB 0B0H
DB 0C9H
DB    2
DB    2
DB  8DH
DB  8EH
DB  8BH
DB  8CH
DB    1
DB    6
DB    0
DB  21H ; !
DB  9DH
DB 0B7H
DB 0EDH
DB 0B0H
DB 0C9H
DB    2
DB    2
DB  86H
DB  85H
DB  87H
DB  88H
DB    1
DB  48H ; H
DB    0
DB  21H ; !
DB 0ACH
DB 0B7H
DB 0EDH
DB 0B0H
DB 0C9H
DB    7
DB  0AH
DB 0CCH
DB 0C8H
DB 0C7H
DB 0C7H
DB 0C7H
DB 0C7H
DB 0CCH
DB 0CCH
DB 0CCH
DB 0CDH
DB  80H
DB  82H
DB  81H
DB  83H
DB 0CCH
DB 0CBH
DB 0CCH
DB 0CDH
DB  90H
DB  8FH
DB 0CEH
DB 0CCH
DB  80H
DB 0CBH
DB 0CCH
DB 0CDH
DB 0CEH
DB 0CCH
DB 0CCH
DB  84H
DB  84H
DB 0CBH
DB 0CCH
DB 0CCH
DB 0CFH
DB 0CCH
DB  82H
DB  81H
DB 0CEH
DB 0CCH
DB 0CCH
DB 0CDH
DB 0CCH
DB  90H
DB 0CEH
DB 0CCH
DB 0CFH
DB 0CBH
DB 0CCH
DB 0CCH
DB 0CEH
DB 0CCH
DB 0CFH
DB  80H
DB  80H
DB 0CBH
DB 0CCH
DB 0CCH
DB 0CFH
DB  84H
DB  84H
DB  84H
DB  84H
DB 0CCH
DB 0CCH
DB 0CCH
DB 0CCH
DB 0CCH
DB 0CCH
DB 0CCH
DB    1
DB  1BH
DB    0
DB  21H ; !
DB 0FDH
DB 0B7H
DB 0EDH
DB 0B0H
DB 0C9H
DB    5
DB    5
DB 0B3H
DB 0B2H
DB 0CAH
DB 0C9H
DB 0C3H
DB 0B4H
DB 0B8H
DB 0BCH
DB 0C0H
DB 0C4H
DB 0B5H
DB 0B9H
DB 0BDH
DB 0C1H
DB 0C5H
DB 0B6H
DB 0BAH
DB 0BEH
DB 0C2H
DB 0C6H
DB 0B7H
DB 0BBH
DB 0BFH
DB 0ABH
DB 0ABH
DB    1
DB  32H ; 2
DB    0
DB  21H ; !
DB  21H ; !
DB 0B8H
DB 0EDH
DB 0B0H
DB 0C9H
DB  10H
DB    3
DB 0AAH
DB 0A8H
DB 0ABH
DB 0ABH
DB 0ABH
DB 0AAH
DB 0A8H
DB 0ABH
DB 0ABH
DB 0ABH
DB 0ABH
DB 0ABH
DB 0A8H
DB 0ABH
DB 0AAH
DB 0ABH
DB 0AEH
DB 0A5H
DB 0B0H
DB 0A5H
DB 0A5H
DB 0AEH
DB 0A5H
DB 0A5H
DB 0B0H
DB 0A5H
DB 0A5H
DB 0AEH
DB 0A5H
DB 0A5H
DB 0B0H
DB 0A5H
DB 0A7H
DB 0A9H
DB 0A7H
DB 0A7H
DB 0A7H
DB 0A7H
DB 0A7H
DB 0A9H
DB 0A7H
DB 0A7H
DB 0AFH
DB 0A7H
DB 0A7H
DB 0A9H
DB 0A7H
DB 0A7H
DB    1
DB  32H ; 2
DB    0
DB  21H ; !
DB  5CH ; \
DB 0B8H
DB 0EDH
DB 0B0H
DB 0C9H
DB  10H
DB    3
DB 0ABH
DB 0ABH
DB 0AAH
DB 0B1H
DB 0ABH
DB 0ABH
DB 0ABH
DB 0ABH
DB 0AAH
DB 0B1H
DB 0ABH
DB 0ABH
DB 0AAH
DB 0ABH
DB 0B1H
DB 0ABH
DB 0A5H
DB 0A4H
DB 0A5H
DB 0A5H
DB 0ADH
DB 0A5H
DB 0A5H
DB 0A4H
DB 0A5H
DB 0A5H
DB 0ADH
DB 0A5H
DB 0A5H
DB 0A4H
DB 0A5H
DB 0ADH
DB 0A7H
DB 0A7H
DB 0A6H
DB 0A7H
DB 0A7H
DB 0ACH
DB 0A7H
DB 0A7H
DB 0A6H
DB 0A7H
DB 0A7H
DB 0ACH
DB 0A7H
DB 0A7H
DB 0A6H
DB 0A7H
DB    1
DB  0AH
DB    0
DB  21H ; !
DB  97H
DB 0B8H
DB 0EDH
DB 0B0H
DB 0C9H
DB    2
DB    4
DB  91H
DB  92H
DB  94H
DB  93H
DB  95H
DB  96H
DB  97H
DB  98H
DB 0A5H
DB 0B8H
DB 0B0H
DB  50H ; P
DB  2BH ; +
DB    0
DB    0
DB 0A8H
DB    0
DB  18H
DB 0B8H
DB  80H
DB    0
DB 0A8H
DB    0
DB  53H ; S
DB 0B8H
DB 0E0H
DB 0FFH
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB  10H
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB  40H ; @
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB  50H ; P
DB    0
DB  18H
DB    0
DB  85H
DB 0B7H
DB  70H ; P
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB 0D0H
DB    0
DB    8
DB    0
DB  62H ; B
DB 0B7H
DB    0
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB  18H
DB    0
DB  28H ; (
DB    0
DB  94H
DB 0B7H
DB  30H ; 0
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB  60H ; `
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB  90H
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB  28H ; (
DB    0
DB  94H
DB 0B7H
DB 0C0H
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB 0C8H
DB    0
DB  38H ; 8
DB    0
DB  85H
DB 0B7H
DB 0F0H
DB    0
DB  28H ; (
DB    0
DB  62H ; B
DB 0B7H
DB 0E8H
DB 0FFH
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  18H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  48H ; H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  58H ; X
DB    0
DB  48H ; H
DB    0
DB  94H
DB 0B7H
DB  50H ; P
DB    0
DB  58H ; X
DB    0
DB  85H
DB 0B7H
DB  78H ; X
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0A8H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0D8H
DB    0
DB  48H ; H
DB    0
DB  62H ; B
DB 0B7H
DB    0
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  10H
DB    0
DB  78H ; X
DB    0
DB  85H
DB 0B7H
DB  30H ; 0
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  60H ; `
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB  90H
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0C0H
DB    0
DB  68H ; H
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB  68H ; H
DB    0
DB  94H
DB 0B7H
DB 0E0H
DB 0FFH
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  10H
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  20H
DB    0
DB  98H
DB    0
DB  85H
DB 0B7H
DB  40H ; @
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  70H ; P
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB 0A0H
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB 0D0H
DB    0
DB  88H
DB    0
DB  62H ; B
DB 0B7H
DB  98H
DB    0
DB  88H
DB    0
DB 0F4H
DB 0B7H
DB 0E8H
DB    0
DB  40H ; @
DB    0
DB  8EH
DB 0B8H
DB 0C8H
DB    0
DB  60H ; `
DB    0
DB 0A3H
DB 0B7H
DB 0CBH
DB  72H ; R
DB 0CBH
DB  72H ; R
DB 0CBH
DB  72H ; R
UNK_B9AE:DB 0B3H
DB 0B9H
DB 0CBH
DB  72H ; R
DB    6
DB    3
DB 0E4H
DB 0BEH
DB 0B9H
DB    8
DB 0BAH
DB 0B9H
DB    1
DB    0
DB    1
DB    4
DB    0
DB  80H
DB  80H
DB  80H
DB 0E2H
DB  63H ; C
DB  71H ; Q
DB  33H ; 3
DB  1FH
DB    3
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    1
DB    1
DB  47H ; G
DB 0C6H
DB  4EH ; N
DB 0CCH
DB 0F8H
DB 0E0H
DB 0C0H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    2
DB    3
DB    1
DB    3
DB  1FH
DB  33H ; 3
DB  60H ; `
DB  60H ; `
DB 0E0H
DB  80H
DB  80H
DB  80H
DB    0
DB    0
DB    0
DB    0
DB  40H ; @
DB 0C0H
DB  40H ; @
DB 0C0H
DB 0F8H
DB 0ECH
DB 0C6H
DB    6
DB    7
DB    1
DB    1
DB    1
UNK_B9FE:DB    3
DB 0BAH
DB 0CBH
DB  72H ; R
DB    9
DB    3
DB 0F8H
DB  0EH
DB 0BAH
DB    8
DB  0AH
DB 0BAH
DB    1
DB    0
DB    1
DB    4
DB    0
DB    0
DB    0
DB  80H
DB 0C0H
DB 0F8H
DB 0FEH
DB  7EH ; ~
DB  3FH ; ?
DB    3
DB  1FH
DB  3CH ; <
DB    4
DB    0
DB    0
DB    0
DB    0
DB    0
DB    1
DB    1
DB    3
DB  1FH
DB  7FH ; 
DB 0FEH
DB 0FCH
DB 0F8H
DB 0FEH
DB  0FH
DB    2
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  0EH
DB  3EH ; >
DB  7FH ; 
DB 0E3H
DB 0DFH
DB 0BCH
DB  84H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  60H ; `
DB 0F0H
DB 0FCH
DB 0FFH
DB  7EH ; ~
DB  3CH ; <
DB  1CH
DB  0CH
DB    4
UNK_BA4E:DB  53H ; S
DB 0BAH
DB 0CBH
DB  72H ; R
DB  15H
DB    3
DB 0F0H
DB  60H ; `
DB 0BAH
DB  0CH
DB  5AH ; Z
DB 0BAH
DB  0AH
DB    0
DB  0AH
DB    4
DB  0FH
DB    8
DB  44H ; D
DB  48H ; H
DB  50H ; P
DB  5AH ; Z
DB  46H ; F
DB  7FH ; 
DB    3
DB  3FH ; ?
DB  3FH ; ?
DB  6FH ; O
DB  7FH ; 
DB  5FH ; _
DB  6FH ; O
DB  37H ; 7
DB  0BH
DB    4
DB  22H ; "
DB  12H
DB  0AH
DB  5AH ; Z
DB  62H ; B
DB 0FEH
DB  80H
DB 0FCH
DB 0FCH
DB 0F6H
DB 0FAH
DB 0FEH
DB 0F6H
DB 0ECH
DB 0D0H
DB  20H
DB    8
DB  14H
DB  28H ; (
DB  45H ; E
DB  43H ; C
DB  7FH ; 
DB    3
DB  3FH ; ?
DB  4FH ; O
DB  9FH
DB 0BFH
DB 0AFH
DB  27H ; '
DB  23H ; #
DB  20H
DB  10H
DB  10H
DB  28H ; (
DB  14H
DB 0A2H
DB 0C2H
DB 0FEH
DB 0C0H
DB 0FCH
DB 0F2H
DB 0F9H
DB 0FDH
DB 0F5H
DB 0E4H
DB 0C4H
DB    4
DB    8
DB    0
DB    0
DB  1BH
DB    9
DB    0
DB    0
DB    0
DB    0
DB    1
DB    1
DB    1
DB    0
DB    0
DB    0
DB    1
DB    3
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB  80H
DB 0C8H
DB  0CH
DB  0CH
DB 0FCH
DB 0FEH
UNK_BAC0:DB 0C5H
DB 0BAH
DB 0FAH
DB  72H ; R
DB  16H
DB    3
DB 0C8H
DB 0CEH
DB 0BAH
DB    4
DB 0CCH
DB 0BAH
DB  0FH
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    3
DB    3
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB 0FEH
DB 0CCH
DB    0
DB    0
DB    0
DB  8CH
DB 0FCH
DB 0F4H
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
DB    0
UNK_BAEE:DB  88H
DB  83H
DB  81H
DB    0
DB    3
DB    5
DB    9
DB    5
DB    9
DB    5
DB  0FH
DB 0FFH
UNK_BAFA:DB  0FH
DB  99H
DB  84H
DB    0
DB  0FH
DB  87H
DB  0FH
DB    8
DB  88H
DB 0FFH
UNK_BB04:DB  11H
DB    1
DB  23H ; #
DB    6
DB    8
DB  10H
DB    1
DB  28H ; (
DB    5
DB    7
DB  0FH
DB    2
DB  2DH ; -
DB    5
DB    6
DB  0EH
DB    2
DB  32H ; 2
DB    4
DB    6
DB  0DH
DB    3
DB  37H ; 7
DB    4
DB    5
DB  0CH
DB    3
DB  3CH ; <
DB    4
DB    5
UNK_BB22:DB  20H
DB  38H ; 8
DB  50H ; P
DB  68H ; H
DB  80H
DB  98H
DB 0B0H
DB 0C8H
DB 0E0H
DB 0F8H
DB 0FFH
DB 0FFH



SUB_BB2E:
XOR     A
LD      ($72D1), A
CALL    SUB_BE39
LD      A, (IX+6)
OR      A
JP      Z, LOC_BC44
LD      C, A
AND     0FH
LD      HL, UNK_BB22
JR      Z, LOC_BB48
LD      B, A

LOC_BB45:
INC     HL
DJNZ    LOC_BB45

LOC_BB48:
LD      B, (HL)
LD      A, R
SUB     B
JP      NC, LOC_BC44
SRL     C
SRL     C
SRL     C
SRL     C
LD      B, C
LD      DE, 5
LD      HL, UNK_BB04
DEC     B
JR      Z, LOC_BB64

LOC_BB61:
ADD     HL, DE
DJNZ    LOC_BB61

LOC_BB64:
LD      DE, 7309H
LD      BC, 5
LDIR
LD      A, 8
LD      ($72D1), A
LD      A, ($71F6)
CP      1
LD      HL, UNK_BAEE
LD      DE, UNK_BC77
JR      C, LOC_BB8D
JR      Z, LOC_BB85
LD      HL, UNK_BAFA
JR      LOC_BB8D

LOC_BB85:
LD      HL, 730CH
DEC     (HL)
DEC     (HL)
LD      DE, UNK_BD45

LOC_BB8D:
LD      ($7310), HL
LD      ($7312), DE
LD      A, 1
LD      ($7314), A
CALL    SUB_BD87
PUSH    IX
POP     HL
SCF
CALL    ACTIVATE
LD      HL, 1
LD      A, ($71F6)
DEC     A
JR      Z, LOC_BBAE
LD      L, 1EH

LOC_BBAE:
XOR     A
CALL    REQUEST_SIGNAL
LD      ($7315), A
CALL    SUB_BDF4
LD      L, (IX+0CH)
CALL    SUB_BBD6
LD      (IX+4), A
LD      L, (IX+0DH)
CALL    SUB_BBD6
LD      (IX+5), A
LD      (IX+6), 0
LD      D, 0C3H
LD      E, D
LD      B, D
LD      C, D
JP      SUB_BD6A
; END OF FUNCTION SUB_BB2E




SUB_BBD6:
LD      A, 1
LD      H, 0
PUSH    IX
CALL    REQUEST_SIGNAL
POP     IX
RET
; END OF FUNCTION SUB_BBD6




SUB_BBE2:
CALL    SUB_BDF4
LD      A, (IX+5)
CALL    TEST_SIGNAL
RET     Z
CALL    SUB_BDF4
CALL    SUB_BDE6
JP      LOC_BD81
; END OF FUNCTION SUB_BBE2




SUB_BBF5:

; FUNCTION CHUNK AT BC5E SIZE 0000000B BYTES
; FUNCTION CHUNK AT BD9D SIZE 00000049 BYTES

LD      A, ($7314)
OR      A
JR      Z, LOC_BC18
LD      A, ($7315)
CALL    TEST_SIGNAL
RET     Z
XOR     A
LD      ($7314), A
LD      B, 0CH
CALL    PLAY_IT
LD      B, 0DH
CALL    PLAY_IT
CALL    SUB_BDFD
LD      B, D
LD      C, E
JP      SUB_BD6A

LOC_BC18:
CALL    SUB_BDF4
LD      A, (IX+4)
CALL    TEST_SIGNAL
RET     Z
JP      LOC_BC5E
; END OF FUNCTION SUB_BBF5




SUB_BC25:
CALL    SUB_BDF4
LD      A, (IX+6)
OR      A
RET     NZ
JR      LOC_BC30

LOC_BC2F:
POP     HL

LOC_BC30:
CALL    SUB_BDF4
LD      A, (IX+5)
CALL    FREE_SIGNAL
LD      A, (IX+4)
CALL    FREE_SIGNAL
LD      A, 1
LD      (IX+6), A

LOC_BC44:
CALL    SUB_BDF4
LD      (IY+3), 0C3H
LD      (IY+1), 0C3H
XOR     A
LD      ($72D1), A
LD      A, 0FFH
LD      ($71C6), A
LD      ($71D0), A
JP      LOC_BD81
; END OF FUNCTION SUB_BC25

; START OF FUNCTION CHUNK FOR SUB_BBF5

LOC_BC5E:
CALL    SUB_BDFD
LD      A, H
OR      L
CALL    Z, SUB_BC69
JP      LOC_BD9D
; END OF FUNCTION CHUNK FOR SUB_BBF5



SUB_BC69:
LD      A, D
OR      A
JP      Z, LOC_BC2F
CP      0FFH
JP      Z, LOC_BC2F
LD      HL, ($7312)
JP      (HL)
; END OF FUNCTION SUB_BC69

UNK_BC77:DB 0EDH
DB  5FH ; _
DB 0E6H
DB  3FH ; ?
DB 0C6H
DB  10H
DB  5FH ; _
DB  16H
DB 0FFH
DB 0AFH
DB  32H ; 2
DB  16H
DB  73H ; S
DB  21H ; !
DB 0B2H
DB 0BCH
DB  22H ; "
DB  12H
DB  73H ; S
DB  2AH ; *
DB  10H
DB  73H ; S
DB  22H ; "
DB  0EH
DB  73H ; S
DB 0DDH
DB  21H ; !
DB    9
DB  73H ; S
DB 0EDH
DB  5FH ; _
DB 0E6H
DB  3FH ; ?
DB 0C6H
DB  60H ; `
DB 0DDH
DB  6EH ; N
DB    2
DB  67H ; G
DB    6
DB    1
DB 0CDH
DB  27H ; '
DB 0BEH
DB  47H ; G
DB 0C5H
DB 0D5H
DB 0CDH
DB  10H
DB 0A2H
DB 0D1H
DB 0DDH
DB  96H
DB    0
DB 0C1H
DB  4FH ; O
DB 0C3H
DB  6AH ; J
DB 0BDH
DB  2AH ; *
DB  0EH
DB  73H ; S
DB  7EH ; ~
DB 0FEH
DB 0FFH
DB 0CAH
DB 0D8H
DB 0BCH
DB  7EH ; ~
DB 0CBH
DB  7FH ; 
DB  28H ; (
DB    5
DB 0CBH
DB 0BFH
DB  83H
DB  18H
DB    2
DB  7BH ; {
DB  96H
DB  4FH ; O
DB  23H ; #
DB  22H ; "
DB  0EH
DB  73H ; S
DB  62H ; B
DB  2EH ; .
DB  0AH
DB    6
DB    0
DB 0CDH
DB  27H ; '
DB 0BEH
DB  47H ; G
DB 0C3H
DB  6AH ; J
DB 0BDH
DB 0DDH
DB  21H ; !
DB  98H
DB  72H ; R
DB 0DDH
DB  66H ; F
DB    1
DB  6AH ; J
DB  3AH ; :
DB  16H
DB  73H ; S
DB 0B7H
DB  28H ; (
DB    4
DB 0DDH
DB  6EH ; N
DB    1
DB  62H ; B
DB  47H ; G
DB 0CDH
DB  27H ; '
DB 0BEH
DB 0D2H
DB  0DH
DB 0BDH
DB 0DDH
DB  46H ; F
DB    1
DB 0DDH
DB  4EH ; N
DB    3
DB  21H ; !
DB  1DH
DB 0BDH
DB  22H ; "
DB  12H
DB  73H ; S
DB 0CDH
DB    3
DB 0BDH
DB 0C3H
DB  6AH ; J
DB 0BDH
DB 0EDH
DB  5FH ; _
DB 0FEH
DB  23H ; #
DB 0D0H
DB  3EH ; >
DB    8
DB  81H
DB  4FH ; O
DB 0C9H
DB  21H ; !
DB  0AH
DB  73H ; S
DB  35H ; 5
DB  28H ; (
DB  0AH
DB 0FDH
DB  21H ; !
DB  16H
DB  73H ; S
DB 0CDH
DB 0E6H
DB 0BDH
DB 0C3H
DB  84H
DB 0BCH
DB 0EDH
DB  5FH ; _
DB 0E6H
DB  3FH ; ?
DB  4FH ; O
DB  7BH ; {
DB  91H
DB 0FEH
DB  90H
DB  38H ; 8
DB    2
DB  3EH ; >
DB  1EH
DB  4FH ; O
DB  3AH ; :
DB  16H
DB  73H ; S
DB 0B7H
DB    6
DB    0
DB  28H ; (
DB    2
DB    6
DB 0FFH
DB 0CDH
DB  6AH ; J
DB 0BDH
DB  21H ; !
DB  84H
DB 0BCH
DB  22H ; "
DB  12H
DB  73H ; S
DB 0FDH
DB  21H ; !
DB  16H
DB  73H ; S
DB 0C3H
DB 0E6H
DB 0BDH
UNK_BD45:DB  21H ; !
DB  5FH ; _
DB 0BDH
DB  22H ; "
DB  12H
DB  73H ; S
DB  3AH ; :
DB 0CAH
DB  72H ; R
DB 0CBH
DB  27H ; '
DB 0CBH
DB  27H ; '
DB 0CBH
DB  27H ; '
DB 0C6H
DB  10H
DB  57H ; W
DB  1EH
DB  3CH ; <
DB  42H ; B
DB  0EH
DB  9CH
DB 0C3H
DB  6AH ; J
DB 0BDH
DB  3AH ; :
DB  99H
DB  72H ; R
DB 0BAH
DB    6
DB 0FFH
DB  30H ; 0
DB    3
DB    6
DB    0
DB  4BH ; K



SUB_BD6A:
CALL    SUB_BDF4
LD      (IX+2), B
LD      (IY+1), D
LD      (IY+2), 0
LD      (IX+3), C
LD      (IY+3), E
LD      (IY+4), 0

LOC_BD81:
CALL    SUB_BD87
JP      PUTOBJ
; END OF FUNCTION SUB_BD6A




SUB_BD87:
LD      A, ($71F6)
LD      IX, UNK_B9FE
OR      A
JR      Z, LOCRET_BD9C
LD      IX, UNK_BA4E
DEC     A
JR      Z, LOCRET_BD9C
LD      IX, UNK_B9AE

LOCRET_BD9C:
RET
; END OF FUNCTION SUB_BD87

; START OF FUNCTION CHUNK FOR SUB_BBF5

LOC_BD9D:
CALL    SUB_BDFD
PUSH    BC
LD      A, H
CP      1
JR      Z, LOC_BDAD
JR      C, LOC_BDB0
LD      A, B
SUB     D
LD      B, A
JR      LOC_BDB0

LOC_BDAD:
LD      A, D
SUB     B
LD      B, A

LOC_BDB0:
LD      A, L
CP      1
JR      Z, LOC_BDBA
LD      A, C
SUB     E
LD      C, A
JR      LOC_BDBD

LOC_BDBA:
LD      A, E
SUB     C
LD      C, A

LOC_BDBD:
LD      A, 5
CP      B
JR      C, LOC_BDC5
CP      C
JR      NC, LOC_BDCB

LOC_BDC5:
SRL     B
SRL     C
JR      LOC_BDBD

LOC_BDCB:
DEC     H
JR      Z, LOC_BDD3
LD      A, D
ADD     A, B
LD      D, A
JR      LOC_BDD6

LOC_BDD3:
LD      A, D
SUB     B
LD      D, A

LOC_BDD6:
DEC     L
JR      Z, LOC_BDDE
LD      A, E
ADD     A, C
LD      E, A
JR      LOC_BDE1

LOC_BDDE:
LD      A, E
SUB     C
LD      E, A

LOC_BDE1:
POP     BC
CALL    SUB_BD6A
RET
; END OF FUNCTION CHUNK FOR SUB_BBF5



SUB_BDE6:
LD      A, (IY+0)
OR      A
LD      (IY+0), 1
RET     Z
LD      (IY+0), 0
RET
; END OF FUNCTION SUB_BDE6




SUB_BDF4:
LD      IY, 72CBH
LD      IX, 7300H
RET
; END OF FUNCTION SUB_BDF4




SUB_BDFD:
CALL    SUB_BDF4
LD      B, (IX+2)
LD      D, (IY+1)
LD      A, B
CP      D
LD      H, 0
JR      Z, LOC_BE12
LD      H, 2
JR      NC, LOC_BE12
LD      H, 1

LOC_BE12:
LD      C, (IX+3)
LD      E, (IY+3)
LD      A, C
CP      E
LD      L, 0
JP      Z, LOCRET_BE26
LD      L, 2
JP      NC, LOCRET_BE26
LD      L, 1

LOCRET_BE26:
RET
; END OF FUNCTION SUB_BDFD

DB 0CBH
DB  20H
DB  3AH ; :
DB  16H
DB  73H ; S
DB 0B0H
DB  28H ; (
DB    7
DB 0FEH
DB    3
DB  28H ; (
DB    3
DB  7CH ; |
DB  85H
DB 0C9H
DB  7CH ; |
DB  95H
DB 0C9H



SUB_BE39:
LD      IX, 71EFH
LD      HL, UNK_860F
LD      DE, 4
LD      A, (IX+2)
CALL    SUB_BE73
LD      E, (IX+3)
DEC     E
ADD     HL, DE
LD      B, (HL)
LD      (IX+5), B
LD      E, (IX+4)
DEC     E
LD      HL, UNK_861F
ADD     HL, DE
LD      A, (HL)
LD      (IX+7), A
LD      A, (IX+4)
LD      DE, 4
LD      HL, UNK_8626
CALL    SUB_BE73
LD      E, (IX+5)
ADD     HL, DE
LD      A, (HL)
LD      (IX+6), A
RET
; END OF FUNCTION SUB_BE39




SUB_BE73:
DEC     A
RET     Z
ADD     HL, DE
JR      SUB_BE73
; END OF FUNCTION SUB_BE73




SUB_BE78:
LD      B, 9
LD      HL, UNK_873B
CALL    SOUND_INIT
LD      A, ($71F3)
CP      1
JR      Z, SUB_BEB2
CP      5
JR      Z, SUB_BEB2
CP      2
JR      Z, LOC_BEA0
CP      4
JR      Z, LOC_BEA0
CP      3
JR      Z, LOC_BEA8
CP      6
JR      Z, LOC_BEA8
CP      7
JR      Z, LOC_BEA8
RET

LOC_BEA0:
CALL    SUB_BEB2
LD      B, 7
JP      PLAY_IT

LOC_BEA8:
LD      B, 8
CALL    PLAY_IT
LD      B, 9
JP      PLAY_IT
; END OF FUNCTION SUB_BE78




SUB_BEB2:
LD      B, 1
CALL    PLAY_IT
LD      B, 2
CALL    PLAY_IT
LD      B, 3
JP      PLAY_IT
; END OF FUNCTION SUB_BEB2




SUB_BEC1:
XOR     A
ADD     A, D
JP      M, LOC_BED9
XOR     A
ADD     A, H
JP      M, LOC_BF1A

LOC_BECB:
CP      D
JP      C, LOC_BF1A
JP      NZ, LOC_BF1D
LD      A, L
CP      E
JP      C, LOC_BF1A
XOR     A
RET

LOC_BED9:
XOR     A
ADD     A, H
JP      P, LOC_BF1D
JP      LOC_BECB
; END OF FUNCTION SUB_BEC1




SUB_BEE1:
XOR     A
ADD     A, H
JP      M, LOC_BEF9
XOR     A
ADD     A, D
JP      M, LOC_BF1A

LOC_BEEB:
CP      H
JP      C, LOC_BF1A
JP      NZ, LOC_BF1D
LD      A, E
CP      L
JP      C, LOC_BF1A
XOR     A
RET

LOC_BEF9:
XOR     A
ADD     A, D
JP      P, LOC_BF1D
JP      LOC_BEEB
; END OF FUNCTION SUB_BEE1




SUB_BF01:
	CP L
	JP Z, LOC_BF1D
	JP C, LOC_BF0D
	XOR L
	JP P, LOC_BF1A
	XOR A

LOC_BF0D:
	XOR L
	JP M, LOC_BF1A
	XOR A
RET

	db 189,202,026,191,195,005,191

LOC_BF1A:
	XOR A
	INC A
RET

LOC_BF1D:
	XOR A
RET

SUB_BF1F:
	LD L, A
	OR A
	JP P, LOC_BF27
	LD H, 0FFH
RET

LOC_BF27:
	LD H, 0
RET

SUB_BF2A:
	PUSH DE
	PUSH HL
	LD HL, DATA_SET_99
	LD E, A
	LD D, 0
	ADD HL, DE
	LD A, (HL)
	POP HL
	POP DE
RET

DATA_SET_99:
	db 001,002,004,008,016,032,064,128

SUB_BF3F:
	CALL SUB_BF2A
	AND L
	JP Z, LOC_BF49
	XOR A
	INC A
RET

LOC_BF49:
	XOR A
RET

;************************************************************************************
    db 175,178,194,073,191,123,254,008,218,063,191,175,201

SUB_BF58:
	POP HL
	EX (SP), HL
	PUSH HL
	LD A, (BC)
	LD L, A
	INC BC
	LD A, (BC)
	INC BC
	LD H, A
	EX (SP), HL
	PUSH DE

LOC_BF63:
	LD E, (HL)
	INC HL
	LD D, (HL)
	INC HL
	PUSH HL
	LD A, E
	OR D
	JP NZ, LOC_BF77
	POP HL
	LD E, (HL)
	INC HL
	LD D, (HL)
	INC HL
	PUSH HL
	EX DE, HL
	LD E, (HL)
	INC HL
	LD D, (HL)

LOC_BF77:
	INC BC
	LD A, (BC)
	RLCA
	JP NC, LOC_BF9A
	INC BC
	POP HL
	EX (SP), HL
	LD (HL), E
	INC HL
	LD (HL), D
	INC HL

LOC_BF84:
	POP DE
	EX (SP), HL
	DEC HL
	XOR A
	CP H
	JP NZ, LOC_BF90
	CP L
	JP Z, LOC_BF96

LOC_BF90:
	EX (SP), HL
	PUSH HL
	EX DE, HL
	JP LOC_BF63

LOC_BF96:
	POP HL
	EX DE, HL
	EX (SP), HL
	JP (HL)

LOC_BF9A:
	POP HL
	EX (SP), HL
	PUSH HL
	RRCA
	LD H, A
	DEC BC
	LD A, (BC)
	LD L, A
	EX (SP), HL
	INC BC
	INC BC

LOC_BFA5:
	LD A, (DE)
	LD (HL), A
	INC HL
	INC DE
	EX (SP), HL
	DEC HL
	XOR A
	CP L
	JP NZ, LOC_BFB4
	CP H
	JP Z, LOC_BFB8

LOC_BFB4:
	EX (SP), HL
	JP LOC_BFA5

LOC_BFB8:
	POP HL
	JP LOC_BF84






